#!/usr/bin/perl
#
#  Created by  Hai Lin,  Dec. 03 2004

#
# This is to compare the atom lists between the real system and the 
#  (large = primary + background-charge) system. 
# 

#                    ##################
#                    #                #  
###################### Read Me First! ####################################
#                    #                #
#                    ##################
#  Required input:
#  
#  1. Number of atoms for the real (entire) system.
#  2. Index  of QM atoms in the real system.
#  3. Index  of Cap atoms.
#
#  Output (in file named QMMMatomList.out):
#  ID_large   ID_real     Comments
#
# This is very helpful in debugging the code and also when one want to 
# change MM parameters for a specific atom
#
##########################################################################
#
# Input here:
# 
# Example:  
#
#       MM .  QM
#          .
#    H3    .  H7
#      \   .  |
#   H2--C1---C5--O8--H9
#      /   .  |
#    H4    .  H6

  $numreal  = 9;
  @qm  = (5,6,7,8,9);
  @cap = (1);

##########################################################################

#$infilename=$ARGV[0];
#$outfilename=$ARGV[1];

#open(FILE4, "<test$infilename.sum");
open(FILE5, ">QMMMatomList.out");

$numqm    = @qm;
$numcap   = @cap;
$numcps   = $numqm + $numcap;
$nummm    = $numreal - $numcps;

printf (FILE5 "=========================================\n");
printf (FILE5 "Number of atoms %12d \n", $numreal);
printf (FILE5 "=========================================\n");


printf (FILE5 "-----------------------------------------\n");
printf (FILE5 "Number of QM atoms %12d\n", $numqm);
printf (FILE5 "-----------------------------------------\n");
printf (FILE5 "Index in Large      Index in Real      Comment\n\n");

for $i (0 .. $numqm-1){
   printf (FILE5 "%8d            %8d          QM atoms\n", $i+1, $qm[$i]); 
}
printf (FILE5 "\n");


printf (FILE5 "-----------------------------------------\n");
printf (FILE5 "Number of Cap atoms %12d\n", $numcap);
printf (FILE5 "-----------------------------------------\n");
printf (FILE5 "Index in Large      Index in Real      Comment\n\n");
$idcap = $numqm;
for $i (0 .. $numcap-1){
   $idcap ++;
   printf (FILE5 "%8d            %8d         Cap atoms\n", $idcap, $cap[$i]); 
}
printf (FILE5 "\n\n");


printf (FILE5 "-----------------------------------------\n");
printf (FILE5 "Number of MM atoms %12d\n", $nummm);
printf (FILE5 "-----------------------------------------\n");
printf (FILE5 "Index in Large      Index in Real      Comment\n\n");
$idlarge = $numcps;
for $i (1 .. $numreal){
   $lfind = 0;	
   for $j (0 .. $numqm) {
      if ($i == $qm[$j]) {
      	$lfind = 1;
      }	
   }   
   for $j (0 .. $numcap) {
      if ($i == $cap[$j]) {
      	$lfind = 1;
      }	
   }
   if ($lfind == 0) { 	
      $idlarge ++;	
      printf (FILE5 "%8d            %8d          MM atoms\n", $idlarge, $i); 
   }   
}
printf (FILE5 "=========================================\n");


close(FILE5);
stop;


# 
# End of script
#
##########################################################################
