#!/usr/bin/perl
#
#  Extracts data from qmmm output file
#   the Energies, momentum, temperature and volume 
#   from the dynamics calculations are extracted
#   and saved into seperate files
#   option: 2nd argument for scale the time
#
use strict;

my $infilename;
my $scalt=1;
my $time;
my $value;
my @word;
my $string;
my $line;

#print "$#ARGV \n";
if ($#ARGV==-1) {
	print "Enter input file name: ";
	$infilename=<STDIN>;
}elsif ($#ARGV==0) {
	$infilename=$ARGV[0];
}else {
	$infilename=$ARGV[0];
	$scalt=$ARGV[1];
}	

#print "$ARGV[-1] $ARGV[0] \n";
open FIN, "$infilename" or die "Failed to open $infilename : $!\n";
open FEN, "> Energy.dat" or die $!;
open FM, "> Momentum.dat" or die $!;
open FTE, "> Temperature.dat" or die $!;
open FVO, "> Volume.dat" or die $!;
open FEK, "> E_kinetic.dat" or die $!;
open FEP, "> E_potential.dat" or die $!;
open avE, "> averageE.dat" or die $!;
open avT, "> AverT.dat" or die $!;

while(<FIN>){
    $string=ltrim($_);
    chomp($string);
	@word=split(/ +/,$string);
	if($word[0] eq "Timestep=") {
		$time=$word[3]/$scalt;
#read following lines
        $line= <FIN>; #CPU time
        $line= <FIN>; #Wall time
        $line= <FIN>; #timing details
        $line= <FIN>; #Approx. time needed
        $line= <FIN>; #Comment
        $line= <FIN>; # Temperature
        $string=ltrim($line);
        chomp($string);
        @word=split(/ +/,$string);
        $value=$word[2];
        print FTE "$time $value \n";
        $line= <FIN>; # Temperature
        $string=ltrim($line);
        chomp($string);
        @word=split(/ +/,$string);
        $value=$word[2];
        print FVO "$time $value \n";
        $line= <FIN>; # Momentum vector
        $line= <FIN>; # kinetic energy
        $string=ltrim($line);
        chomp($string);
        @word=split(/ +/,$string);
        $value=$word[3];
        print FEK "$time $value \n";
        $line= <FIN>; # potential energy
        $string=ltrim($line);
        chomp($string);
        @word=split(/ +/,$string);
        $value=$word[3];
        print FEP "$time $value \n";
        $line= <FIN>; # total energy
        $string=ltrim($line);
        chomp($string);
        @word=split(/ +/,$string);
        $value=$word[3];
        print FEN "$time $value \n";
        $line= <FIN>; # kinetic energy
        $line= <FIN>; # potential energy
        $line= <FIN>; # total energy
        $line= <FIN>; #Comment
        $line= <FIN>; # total energy
        $line= <FIN>; # total energy
        $line= <FIN>; # Momentum
        $string=ltrim($line);
        chomp($string);
        @word=split(/ +/,$string);
        $value=$word[2];
        print FM "$time $value \n";
        $line= <FIN>; #Comment
        $line= <FIN>; # kinetic energy
        $line= <FIN>; # potential energy
        $line= <FIN>; # average energy
        $string=ltrim($line);
        chomp($string);
        @word=split(/ +/,$string);
        $value=$word[3];
        print avE "$time $value \n";
        $line= <FIN>; # average temperature
        $string=ltrim($line);
        chomp($string);
        @word=split(/ +/,$string);
        $value=$word[3];
        print avT "$time $value \n";
    }
}


# Left trim function to remove leading whitespace
# from http://www.somacon.com/p114.php
sub ltrim($)
{
    my $string = shift;
    $string =~ s/^\s+//;
    return $string;
}
