c**********************************************************************
c  gau_ext_opt
c**********************************************************************
c
      subroutine gau_ext_opt1(optinp,geom,ierr)
c
c     Subroutine gau_ext_opt
c
c*    Gau_ext_opt is an  which uses Gaussian's external keyword
c*    and Gaussian's optmizer
c*
c*      MULTILEVEL  <-->  G03 <--> Gau_external <--> MULTILEVEL
c*
c*     Created:  March. 2004 by Yan Zhao
c*     Revised:  April, 2004 by Hai Lin
c
c*     Purpose:  To perform  optimization using Gaussian's optimizer 
c*     
c*     Called by:  mlohook
c*     Calls:  optghk, opthhk 
c*
      use files
      use input, only : mlopt, mlinp,cartgeom
      use optimize, only : ener, grad, hess
      implicit  none
 
c
c i/o variables
c
      integer            ierr
      type (cartgeom) :: geom
      type (mlopt)    :: optinp                  
c
c local variables
c      
      integer            i, j, k, n3tm
      character*20       basis, method,v3s  
c
      n3tm = 3*mlinp%geom%natoms
 
c       call opthhk
       basis = ' '     
       method = 'external' 
       v3s = 'v3s'
  
      if(method(:4).eq.'orca')	stop 'Error the method for ext-opt'
 	
       open (unit=extoinf, status='unknown', file=extin, err=9991)
       call g03inp(extoinf, method, basis, 
     *            geom%charge, geom%mult, geom, 
     *            optinp%optl, 1, v3s)
       call system('g03shuttle extopt.inp extopt.out')
       call g03outo(geom, ener, grad, ierr) 
            if (ierr.eq.1) go to 7000 
 
       mlinp%geom = geom
c
c  Display the results of the optimization
c
      write(outfile,1100)
      write(outfile,1250)  ener
      write(outfile,1300)
      write(outfile,1350)  grad(:n3tm)
      write(outfile,1400)
      write(outfile,1450)
      do 20 i=1, geom%natoms
         write(outfile,1500) geom%atm(i), geom%aucoord(3*i-2),
     *       geom%aucoord(3*i-1), geom%aucoord(3*i)
  20  continue
      write(outfile,1550)
      do 40 i=1, geom%natoms
         write(outfile,1500) geom%atm(i), geom%angcoord(3*i-2),
     *       geom%angcoord(3*i-1), geom%angcoord(3*i)
  40  continue
  
1100  format(/2(/80('-')),//2x,'External Optimization with Gaussian',
     *         a,//80('-')/)
1250  format(/2x,'Optimized Energy:',t30,f19.12)
1300  format(/2x,'Optimized Cartesian Gradient:')
1350  format(t20,d15.8,t40,d15.8,t60,d15.8)
1400  format(/2x,'Optimized Geometry:')
1450  format(//5x,'Atomic Coordinates (in a.u.):',//8x,'Atom', t28, 'X',
     *         t48, 'Y', t68, 'Z'/)
1500  format(9x,a2,t20,d15.8,t40,d15.8,t60,d15.8)
1550  format(//5x,'Atomic Coordinates (in ang.):',//8x,'Atom', t28, 'X',
     *         t48, 'Y', t68, 'Z'/)  
      return
 
9991  write (outfile,*) 'Error creating Gaussian98 Opt input file'
      stop 'progohk 1'
7000  write (outfile,'(/a)') 'ERROR: External Optimization failed.'
      stop 'gau_ext_opt'
      end     
       

