c
c******************************************************************************
c  MLHHOOK
c******************************************************************************
c
c   modified 2/10/2007 by Christoph Riplinger
c
c      subroutine mlhhook(progrms, mlgeninp%geom,
c     *       mcoptl, ltest, ltestmm, mlgeninp%mmgeom,          
c     *       lqmmm, qmmminp,
c     *       tmeth, tbas, toptl, ierr)
      subroutine mlhhook(progrms, geom, mcoptl,
     *   ltest, ltestmm, mmgeom,
     *   mlgeninp, optinp, lhessType,
     *   lqmmm, qmmminp,
     *   tmeth, tbas, toptl, ierr)
c
c   end 2/10/2007 by Christoph Riplinger
c  
c     Subroutine mlhhook
c
c     Created:  Feb. 22, 2005 by Hai Lin
c
c     Purpose:  To call the appropriate hessian subhook
c
c     Called by:  main
c     Calls:    
c             proghhk, progmmhhk
c
c     Variables defined here:
c
c   add 2/10/2007 by Christoph Riplinger
c
c      use input,    only : cartgeom, proglist, mlinp,
c     *                     mmvalen, qmmminf, maxoptl
      use input,    only : cartgeom, proglist, mlinp,
     *                     mmvalen, qmmminf, maxoptl, mlopt, general
c
c   end 2/10/2007 by Christoph Riplinger
c
      use files,    only : outfile
      use optimize, only : ener, grad, hess
      use param,    only : lowqmhs, uniths,qmmmhs,mmhs
      use caltyp,   only : thess
      use energy
      use gradient
      use hessian
      implicit none
c
c  i/o variables
c also add mmgeom definition below                                      
c
      type (proglist) :: progrms
      integer            ierr, limohc, ltest, ltestmm, lqmmm            
c
c   add 2/10/2007 by Christoph Riplinger
c
      integer            lhessType, ipartcal 
c
c   end 2/10/2007 by Christoph Riplinger
c
      character*10       prognme
      type (cartgeom) :: geom
      type (mmvalen)  :: mmgeom
c
      character*80    :: mcoptl(maxoptl), toptl(maxoptl)
      character*20    :: tmeth, tbas
      type (qmmminf)  :: qmmminp                                        
c
c   add 2/10/2007 by Christoph Riplinger
c
      type (mlopt)    :: optinp
      type (general)  :: mlgeninp
c
c   end 2/10/2007 by Christoph Riplinger
c
c  local variables
c
      integer            n3tm
c              
      n3tm = 3*geom%natoms
c
c   add 2/10/2007 by Christoph Riplinger
c
      if (mlgeninp%part%ipartcal .eq. 1) then            
         ipartcal = 1
      else
         ipartcal = 0
      endif
c
c   end 2/10/2007 by Christoph Riplinger
c
c  Make calls to subhooks depending on activated switches
c
c  TEST
c
      if (ltest.eq.1)  then
         call proghhk(progrms%testprog,tmeth,tbas, 
     *          geom%charge, geom%mult, geom , toptl, ener, 
     *          grad(:n3tm), hess(:n3tm,:n3tm), ierr,'null')
         call testdisp( geom%natoms, thess )
      endif
c
c  TESTMM                                                               
c
      if (ltestmm.eq.1)  then
         call progmmhhk(progrms%testmmprog,tmeth,tbas,geom,
     *	        mmgeom,toptl,ener,
     *          grad(:n3tm), hess(:n3tm,:n3tm), ierr,'null')
         call testdisp( geom%natoms, thess )
      endif      	 	      	       
c
c  QMMM                                                                 
c
      if (lqmmm .eq. 1) then
c
c   add 2/10/2007 by Christoph Riplinger
c
c            call qmmmhhk(progrms%qmprog, progrms%mmprog, geom,
c     *         mmgeom, qmmminp, ierr)
c   QMMM Hessian calculation
         if (lhessType .eq. 1) then
            call qmmmhhk(progrms%qmprog, progrms%mmprog, geom,
     *         mmgeom, qmmminp, ierr)
c   Numerical Hessian calculation
         elseif (lhessType .eq. 2) then
            call qmmmnumhhk(progrms%qmprog, progrms%mmprog, geom,
     *         mmgeom, qmmminp, optinp, mlgeninp%part, 
     *         ipartcal, ierr)
c   Hybrid Hessian calculation
         elseif (lhessType .eq. 3) then
            call qmmmhybridhhk(progrms%qmprog, progrms%mmprog, geom,
     *         mmgeom, qmmminp, optinp, mlgeninp%part, 
     *         ipartcal, ierr)
c   Estimated Hessian calculation
         elseif (lhessType .eq. 4) then
            call orcaesthhk(progrms%qmprog, progrms%mmprog, geom,
     *         mmgeom, qmmminp, optinp, mlgeninp%part,
     *         ipartcal, ierr)
         endif
c
c   end 2/10/2007 by Christoph Riplinger
c
         ener = qmmmener
         grad(:n3tm) = qmmmgrad(:n3tm)
c
c   modified 2/10/2007 by Christoph Riplinger
c   For a partial calculation of the hessian we only store this partial hessian
c
c         hess(:n3tm,:n3tm) = qmmmhess(:n3tm,:n3tm)    
         if (ipartcal .eq. 1) then
            n3tm = 3*mlgeninp%part%partatmnum
         endif
         hess(:n3tm,:n3tm) = qmmmhess(:n3tm,:n3tm)
         n3tm = 3*geom%natoms
c
c   end 2/10/2007 by Christoph Riplinger
c 
      endif	            
c                                                                       
c
c   Frequency calculation
c
c   modified 2/10/2007 by Christoph Riplinger
c
c      call freqcal(geom)
      if (ipartcal .ne. 1) then
          call freqcal(geom) 
      endif
c
c   end 2/10/2007 by Christoph Riplinger
c
      return
      end
c
c     
c*****************************************************************************
c  PROGHHK
c*****************************************************************************
c
      subroutine proghhk(prognme, esmeth, esbas, 
     *                    qmcharge,qmmult,geom, optl, 
     *                    ener, grad, hess, ierr, ver_lab)
c
c     Subroutine proghhk
c
c     Created:  Feb 22, 2005 by Hai Lin
c     Revised:  Apr  3, 2006 by Yan Zhang
c               May 22, 2006 by Yan Zhang
c
c
c     Purpose:  Get a single point energy, gradient, and hessian for the
c        given geom with the specified electronic structure package.
c
c     Description:  Calls a function to write a G03 FREQ input file,
c         runs this calculation on the system, and then calls fxns that
c         read the energy, gradient, and hessian from the formatted
c         checkpoint file created by G03.
c
c     Note:  Currently only G03 is enabled but it would be easily
c        expanded to other electronic structure programs.  new _inpe and
c        _oute subroutines would have to be written for each different
c        program though.
c
c     Called by: opthhk, 
c     Calls:  g03inp, g03oute, g03outg, g03outh, system, 
c             orcainp, orcaoute, orcaoutg, orcaouth
c
c     Variables defined here:
c
      use caltyp
      use files
      use input, only : cartgeom, maxoptl
      implicit none
      character*10 prognme
      character*20 esmeth, esbas,ver_lab
      type (cartgeom) :: geom
c
      character*80 optl(maxoptl)
      double precision ener, grad(3*geom%natoms)
      double precision hess(3*geom%natoms, 3*geom%natoms)
      integer ierr

      integer qmcharge, qmmult
c
c  GAUSSIAN03
c
c      if ((prognme(:3).eq.'g03') .or. (prognme(:3).eq.'g09')) then   !1222BW10 add g09
      if ((prognme(:3).eq.'g03') .or. (prognme(:3).eq.'g09')            1020XW17
     * .or. (prognme(:3).eq.'g16')) then                                1020XW17
         open (unit=g03inf, status='unknown', file=g03in, err=9993)
         call g03inp(g03inf, esmeth,esbas,
     *             qmcharge,qmmult, geom,optl,thess,ver_lab)
         close (g03inf, err=9993)
         call system('g03shuttle g03.inp g03.out')

         call g03oute(1,esmeth, ener)
         call g03outg(1,esmeth, grad, geom%natoms)
         call g03outh(esmeth, hess, geom%natoms)                           
      endif
c
c    ORCA 4/3/2006 by Yan Zhang
c

      if (prognme(:4).eq.'orca') then

c
c	 calculation of the single point ernergy
c
         open (unit=orcainf, status='unknown', file=orcain, err=9994)
         call orcainp(orcainf, esmeth,esbas,qmcharge, qmmult, 
     *        geom,optl,tener,ver_lab)
         close (orcainf, err=9994)
         call system('orcashuttle orca.inp orca.out')
         call orcaoute(1,esmeth, ener)
c
c	 calculation of the gradient
c
         open (unit=orcainf, status='unknown', file=orcain, err=9994)
         call orcainp(orcainf, esmeth,esbas,qmcharge,qmmult,
     *        geom,optl,tgrad,ver_lab)
         close (orcainf, err=9994)
         call system('orcashuttle orca.inp orca.out')
         call orcaoutg(1,esmeth, grad, geom%natoms, geom%natoms)
c
c	 calculation of the hessian
c
         open (unit=orcainf, status='unknown', file=orcain, err=9994)
         call orcainp(orcainf, esmeth,esbas,qmcharge, qmmult,
     *   geom,optl,thess,ver_lab)
         close (orcainf, err=9994)
         call system('orcashuttle orca.inp orca.out')
         call orcaouth(esmeth, hess, geom%natoms)                           
c
c	  end  4/3/2006 by Yan Zhang
c
c   Gamess   5/22/2006 by Yan Zhang
c
      else if (prognme(:6).eq.'gamess') then
         open (unit=gmsinf, status='unknown', file=gmsin, err=9995)
         call gmsinp(gmsinf,esmeth,esbas,qmcharge,qmmult,
     *         geom,optl,thess,ver_lab)
         close(gmsinf,err=9995)
         call system('gmsshuttle gms.inp gms.out')
         call gmsoutg (1, esmeth, grad, geom%natoms,ener)
         call gmsouth (esmeth, hess, geom%natoms)
c
c   end 5/22/2006  by Yan Zhang
C

      endif


      return
c9993  write (outfile,*) 'Error creating Gaussian03 Freq input file'
9993  write (outfile,*) 'Error creating Gaussian Freq input file'       1020XW17
	stop   'proghhk 3'

9994  write (outfile,*) 'Error creating Orca input file'
      stop 'proghhk 4'

9995  write (outfile,*) 'Error creating Gamess input file'
      stop 'proghhk 5'

      end
c
c
c*****************************************************************************
c  g03OUTH
c*****************************************************************************
c  
      subroutine g03outh (esmeth, hess, natoms)
c
c     Subroutine g03outh
c
c     Created:  Feb. 21, 2005 by Hai Lin
c     Revised:
c     Purpose:  Get the hessian out of the Gaussian03 formatted
c        checkpoint file.  
c
c     Called by:  proghhk
c     Calls:
c
c     Variables defined here: 
c     
      use files
      use numfmt
      implicit none
      
      character*20  esmeth
      integer nhess
     
      integer ctr, i, k, natoms, j, hstrt, hend
      double precision  hess(3*natoms,3*natoms), cfltfmt
  
c
      character*80 string, case
      character*15 htxt(3*natoms*(3*natoms+1)/2)
      nhess = 3*natoms*(3*natoms+1)/2
c     
c  Open the formatted checkpoint file.
c
      open( unit=fchk, status='unknown', file=testfchk, err=9900)
c
      read( fchk, '(a80)', end=9910 ) string
      string = case(string)
 
      do while( string(:25).ne.'cartesian force constants' )
c
         read( fchk, '(a80)', end=9910 ) string
         string = case(string)
      enddo
      ctr = 1
      do while( ctr .le. nhess )
c
         read( fchk, '(a80)', end=9910 ) string
         string = case(string)
         i = 0
         do while( ctr.le.nhess .and. i.lt.5 )
            hstrt = i*(nlen(hfmt)+1)+2
            hend  = (i+1)*(nlen(hfmt)+2)
            htxt(ctr) = string(hstrt:hend)
            ctr = ctr+1
            i = i+1
         end do
      end do
      j=1
      k=1
c
c  Convert the array of numbers into a full hessian matrix, taking into
c    account that the Gaussian checkpoint file contains only the lower
c    triangular portion of the matrix 
c
      do 20 i=1, nhess
         hess(j,k) = cfltfmt(htxt(i),hfmt)
         if ( j .eq. k) then
            j = j+1
            k = 1
         else
            hess(k,j) = hess(j,k)
            k = k+1
         endif
  20  continue
      close( unit=fchk )
      return
9900  write( outfile,*) 'Error opening Gaussian98 checkpoint file'
      stop 'g03outh 1'
9910  write( outfile,*) 'Error reading Gaussian98 checkpoint file'
      stop 'g03outh 2'
      end
c
c
c*****************************************************************************
c  PROGMMHHK
c*****************************************************************************
c
      subroutine progmmhhk(prognme, esmeth, esbas, geom, mmgeom, 
     *                     optl, ener, grad, hess, ierr, ver_lab)
c
c     Subroutine progmmhhk
c
c     Created:  Feb 22, 2004 by Hai Lin
c
c     Purpose:  Get a single point energy, gradient, and hessian for the
c        given geom with the specified force field package.
c
c     Description:  Calls a subroutine to write an MM input file,
c         runs theree (energy, gradient, and hessian) calculations 
c         on the system, and then calls subroutine that
c         read the energy, gradient, and hessian from the MM output 
c         file created by the force field package.
c
c     Note:  Currently only TINKER is enabled but it would be easily
c        expanded to other force field programs.  new _inpe and
c        _oute subroutines would have to be written for each different
c        program though.
c
c     Called by: opthhk, eshparse, 
c         mcshhk, 
c        mlhhook
c
c     Calls:  t41inp, t41outg, t41outh, system
c
      use caltyp
      use files
      use input, only : cartgeom, mmvalen, maxoptl
      implicit none
c
c  i/o variables
c
      character*10 prognme
      character*20 esmeth, esbas,ver_lab
      type (cartgeom) :: geom
      type (mmvalen) :: mmgeom
c
      character*80 optl(maxoptl)
      double precision ener, grad(3*geom%natoms)
      double precision hess(3*geom%natoms, 3*geom%natoms)
      integer ierr
c
c  local variables
c
c
c  TINKER 
c
      if (prognme(:6).eq.'tinker') then
         open (unit=t41inf, status='unknown', file=t41in, err=9994)
         open (unit=t41keyf, status='unknown', file=t41key, err=9995)
         call t41inp(t41inf, t41keyf,
     *    esmeth, esbas, geom, mmgeom,optl,thess,ver_lab)
         close (t41inf, err=9994)
         close (t41keyf, err=9995)
c	 
c hailin01182005end	 
c
c read the atomic MM charge
c  also print MM parameters if required
c
         if ((tprm .eq. 1) .or. (mmgeom%lprnatmprm .eq. 1)) then
            call system('t41shuttle t41 p')
            call t41outp(mmgeom)
         endif    
c
c compue energy, gradient, and hessian
c		  	 	 
         call system('t41shuttle t41 e')
         call t41oute(1,esmeth,ener)
         call system('t41shuttle t41 g')
         call t41outg(1,esmeth,ener, grad, geom%natoms)
         call system('t41shuttle t41 h')
         call t41outh(esmeth, hess, geom%natoms)
      endif
      return
9994  write (outfile,*) 'Error creating TINKER .xyz file'
      stop 'progmmhhk 4'
9995  write (outfile,*) 'Error creating TINKER .key file'
      stop 'progmmhhk 5'
      end
c
c
c*****************************************************************************
c  PROGMM0HHK
c*****************************************************************************
c
      subroutine progmm0hhk(prognme, esmeth, esbas, geom, mmgeom, 
     *                     optl, ener, grad, hess, ierr, ver_lab, 
     *                     qmmminp)
c
c     Subroutine progmmhhk
c
c     Created:  Dec. 03, 2004 by Hai Lin
c
c     Purpose:  Get a single point energy, gradient, and hessian for the
c        given geom with the specified force field package and with MM
c        charges on QM and HL atoms to be zero.
c
c     Description:  Calls a subroutine to write an MM input file,
c         runs theree (energy, gradient, and hessian) calculations 
c         on the system, and then calls subroutine that
c         read the energy, gradient, and hessian from the MM output 
c         file created by the force field package.
c
c     Note:  Currently only TINKER is enabled but it would be easily
c        expanded to other force field programs.  new _inpe and
c        _oute subroutines would have to be written for each different
c        program though.
c
c     Called by: opthhk, eshparse, 
c         mcshhk, 
c        mlhhook
c
c     Calls:  t41inp, t41outg, t41outh, system
c
      use caltyp
      use files
      use input, only : cartgeom, mmvalen, maxoptl, qmmminf
      implicit none
c
c  i/o variables
c
      character*10 prognme
      character*20 esmeth, esbas,ver_lab
      type (cartgeom) :: geom
      type (mmvalen) :: mmgeom
c
      character*80 optl(maxoptl)
      double precision ener, grad(3*geom%natoms)
      double precision hess(3*geom%natoms, 3*geom%natoms)
      integer ierr
      type (qmmminf)  :: qmmminp       
c
c  local variables
c
      integer      i,ii   
      integer      j, mmatm, mmnum             !0817BW10
      double precision mmcharge,mm1charge      !0126BW13 for balanced M1 charge in E(SS,Coulomb) calculation

c
c  TINKER 
c
      if (prognme(:6).eq.'tinker') then
         open (unit=t41inf, status='unknown', file=t41in, err=9994)
         open (unit=t41keyf, status='unknown', file=t41key, err=9995)
         call t41inp(t41inf, t41keyf,
     *    esmeth, esbas, geom, mmgeom,optl,thess,ver_lab)
         close (t41inf, err=9994)
c
c hailin01182005end	 
c
c set MM charges on QM atoms to zero
c  for the entire system, the index read in for the QM atoms will be used
c  for the capped system, the index will be from 1 to N, where N is the 
c      summed number for the QM and HL atoms.
c  the tcssmmkey in the common block caltyp specify the system, i.e.
c      whether the entire or the capped system
         
        if (tcssmmkey .eq. 1) then
           ii = qmmminp%qmnatm
           do i=1, ii
              write (t41keyf, *) 'charge ', -qmmminp%qmatm(i), ' 0.0'
           enddo		  
        elseif (tcssmmkey .eq. 2) then
           ii = qmmminp%qmnatm + qmmminp%capatm%capnatm 
           do i=1, ii
              write (t41keyf, *) 'charge ', -i, ' 0.0'
           enddo
        else
           write (outfile,*) 'Error! Please specify CPS or ES.'
           stop 'progmm0hhk 6'
        endif
        close (t41keyf, err=9995)
c
c read the atomic MM charge
c  also print MM parameters if required
c
         if ((tprm .eq. 1) .or. (mmgeom%lprnatmprm .eq. 1)) then
            call system('t41shuttle t41 p')
            call t41outp(mmgeom)
         endif    

c   start by Bo Wang 0207BW15
c   Do MM charge correction for M1 atom
         if (tcssmmkey .eq. 1 .and. qmmminp%lchgcorr .ne. 0) then
             open (unit=t41keyf, status='old',position='append',
     &                     file=t41key, err=9995)
             do i=1, qmmminp%mm1stlay%natm1stlay
               ii = qmmminp%mm1stlay%atm1stlay(i)
               mmcharge=0
               mmnum = qmmminp%balgroupn(i)
               do j=2,mmnum
                 mmatm=qmmminp%balgroup(i,j)
                 mmcharge = mmcharge + mmgeom%atmcharge(mmatm)
               enddo
               mm1charge = qmmminp%groupchg(i) - mmcharge
               write (t41keyf, 100) -ii,mm1charge
100   format (1x, 'charge',3x,i5,3x,d12.6)
             enddo
             close (t41keyf, err=9995)
         endif
c   end by Bo Wang 0207BW15

c
c compue energy, gradient, and hessian
c		  	 	 
         call system('t41shuttle t41 e')
         call t41oute(1,esmeth,ener)
         call system('t41shuttle t41 g')
         call t41outg(1,esmeth,ener, grad, geom%natoms)
         call system('t41shuttle t41 h')
         call t41outh(esmeth, hess, geom%natoms)
      endif
      return
9994  write (outfile,*) 'Error creating TINKER .xyz file'
      stop 'progmm0hhk 4'
9995  write (outfile,*) 'Error creating TINKER .key file'
      stop 'proghmm0hk 5'
      end
c
c
c*****************************************************************************
c  T41OUTH
c*****************************************************************************
c  
      subroutine t41outh (esmeth, hess, natoms)
c
c     Subroutine t41outh
c
c     Created:  Feb. 22, 2004 by Hai Lin
c     Revised:
c     Purpose:  Get the hessian out of the TINKER output file.
c
c     Called by:  progmmhhk
c     Calls:
c     
      use files
      use numfmt
      implicit none
c
c  i/o variables
c      
      integer           natoms 
      character*20      esmeth
      double precision  hess(3*natoms,3*natoms)
c
c  local variables
c 
      integer          i, j, k
      integer          nhess, natom3
      integer          nwords, isec, ieof, iscend
      integer          idiagfind, ioffdfind
      double precision kcal2au, au2kcal
      double precision au2ang, ang2au
      double precision kcalpangang2au, au2kcalpangang
      double precision hreadkcal
      double precision cfloat
c
      character*80     words(40), case
c      
      natom3 = natoms * 3
      nhess = natom3 * (natom3 + 1) / 2
c
c     Define unit converting factor
c
      au2kcal = 627.5095d0
      kcal2au = 1.0d0 / au2kcal
      au2ang = 0.529177249d0
      ang2au = 1.0d0 / au2ang
      kcalpangang2au = kcal2au / ang2au / ang2au
      au2kcalpangang = 1.0d0 / kcalpangang2au
c
      open(unit=t41outf,status='unknown', file=t41out, err=9900)
      ieof = 0
      nwords = 6
      idiagfind = 0
      ioffdfind = 0
c
c Search for 'Diagonal Hessian Elements'
c
      do while (ieof .ne. 1)
         call readln(t41outf,words,nwords,isec,ieof,iscend)
  
         if(words(1) .eq. 'DIAGONAL'  .and. 
     *      words(2) .eq. 'HESSIAN'   .and.
     *      words(3) .eq. 'ELEMENTS') then
            idiagfind = 1
            goto 100
         endif
      enddo
100   if(idiagfind .eq. 0) then
         write(outfile, *) 
     *      'Error: No TINKER diagonal hessian elements found.'
         stop 't41outh 4'
      endif
c
c      read the diag-hessian and convert it into au.
c
      i = 0
      do while (ieof .ne. 1)
         if(i .ge. natom3) goto 200
         call readln(t41outf,words,nwords,isec,ieof,iscend)
         do j = 1, nwords 
            i = i + 1
            hreadkcal = cfloat(case(words(j)))
            hess(i,i) = hreadkcal * kcalpangang2au
         enddo   
      enddo
200   if(i .gt. natom3) then
         write(outfile, *)
     *      'Error: Too many TINKER diagonal hessian elements ...'
         stop 't41outh 5'
      endif
      	      	   
c
c Search for 'Off-diagonal Hessian Elements'
c      read the hessian and convert it into au.
c
      i = 0
      do while (ieof .ne. 1)
         if(i .ge. natom3) goto 300
         call readln(t41outf,words,nwords,isec,ieof,iscend)
         if(words(1) .eq. 'OFF-DIAGONAL'  .and. 
     *      words(2) .eq. 'HESSIAN'       .and.
     *      words(3) .eq. 'ELEMENTS')     then
            i = i + 1
            k = i
         else
            do j = 1, nwords 
               k = k + 1
               hreadkcal = cfloat(case(words(j)))
               hess(i,k) = hreadkcal * kcalpangang2au
               hess(k,i) = hess(i,k)
            enddo   
         endif      
      enddo
300   if(i .ge. natom3) then
         write(outfile,*) 
     *    'Error: Too many TINKER off-diagonal hessian elements ...'
         stop 't41outh 6'
      endif
			     
      close( unit=t41outf )
      
      return
9900  write( outfile,*) 'Error opening TINKER output file'
      stop 't41outh 1'
      end
c
c
c******************************************************************************
c  MTOLTM
c******************************************************************************
c
      subroutine mtoltm( matrix, ltmat, dim )
c
c     Subroutine mtoltm
c
c     Created:  July 12, 1999 by J. M. Rodgers
c     Revised:
c     Purpose:  To convert a 2 dimensional array matrix to a 1 dimensional
c        array ltmat containing only the lower triangular elements of 
c        matrix.
c
c     Called by:  qmmmdisp
c     Calls:
c
c     Variables defined here:
c
      use files, only : outfile
      implicit none
      integer  dim, i, j, ctr
      double precision  matrix(dim,dim), ltmat(dim*(dim+1)/2)
      ctr = 0
      do 20 i=1, dim
         do 40 j=1, i
            ctr = ctr + 1
            ltmat(ctr) = matrix(i,j)
  40     continue
  20  continue
      if (ctr .ne. dim*(dim+1)/2) then
         write(outfile,*) 'ERROR: Problem in MTOLTM'
      endif
      return
      end
c
c******************************************************************************
c  QMMMHHK
c******************************************************************************
c
      subroutine qmmmhhk(qmprognme, mmprognme, geom, 
     *   mmgeom, qmmminp, ierr)
c
c     Subroutine qmmmhhk
c
c     Created:  Feb. 22, 2004 by Hai Lin
c     Revised:  Dec. 03, 2004 by Hai Lin
c               Apr. 16, 2006 by Yan Zhang
c               May. 22, 2006 by Yan Zhang
c               Aug.  8, 2006 by Yan Zhang
c                           
c                Set MM charges on the QM atoms to zero for electric
c                embedding schemes.
c
c     Purpose:  To determine the QMMM energy, gradient, and hessian
c
c     Called by:  mlhhook, opthhk
c     Calls:  proghhk 
c  
      use caltyp
      use input,    only : cartgeom, mmvalen, qmmminf
      use files,    only : outfile
      use energy,   only : qmmmener, qmes, mmes
      use gradient, only : qmmmgrad, qmmmqmgr, qmmmmmgr
c
c  modified 11/1/2007 by Yan Zhang                      
c
c      use hessian,  only : qmmmhess, qmmmqmhs, qmmmmmhs
      use hessian,  only : qmmmhess, qmmmqmhs, qmmmmmhs, hessmaxatm
c
c  end by Yan zhang 11/1/2007       
c
      implicit none
c
c i/o variables
c
      character*10       qmprognme, mmprognme
      type (cartgeom) :: geom
      type (mmvalen)  :: mmgeom
      type (qmmminf)  :: qmmminp
      integer            ierr
c
c local variables
c      
      type (cartgeom) :: ssgeom, bgchgeom
      type (mmvalen)  :: ssmmgeom
      integer            lsnatm, ssnatm, bgchnum
      integer            sumtyp
      integer            i, j, k, l      
c
c        please check module.F:hessian:maxatm value
c
c
c   modified 2/10/2007 by Christoph Riplinger
c
c
c        please check module.F:hessian:maxatm value
c
c      integer, parameter :: hessmax = 50*3
      integer            ipartcal
c
c   modify 11/1/2007 by Yan Zhang    
c      integer, parameter :: hessmax = 100*3
      integer, parameter :: hessmax = hessmaxatm*3
c
c   end 11/2/2007 by Yan Zhang  
c
c   end 2/10/2007 by Christoph Riplinger
c
      double precision  hs(hessmax*(hessmax+1)/2)
c
c  Save the prnprm switch value
c
      ssmmgeom%lprnatmprm = mmgeom%lprnatmprm
c     
c     The program can not calculate the QM/MM hessian using Orca
c	revised 4/16/2006 by Yan Zhang
c

      if((qmprognme(:4).eq.'orca').
     $	and.qmmminp%embed .ne. 'mechanical') then
      write(outfile,*) 'The program can not calculate',
     $		   ' the QM/MM hessian using Orca with electric ',
     $			'embedding.'
       stop 'qmmmhhk 1'
      end if
c
c    end 4/16/2006 by Yan Zhang
c
c FB not support hessian calculation.
c added by Yan Zhang, Apr.17, 2009
c
      if(qmmminp%iflexbound.eq.1) stop
     *  "FB not support hessian calculation"
c
c end
c     
c     The program can not calculate the QM/MM hessian
C     using Gamess with electric embedding
c	revised 5/22/2006 by Yan Zhang
c
      if((qmprognme(:6).eq.'gamess').
     $	and.(qmmminp%embed .ne. 'mechanical')) then
        write(outfile,*) 'The program can not calculate',
     $  ' the QM/MM hessian using Gamess with electric ',
     $			'embedding.'
       stop 'qmmmhhk 2'
      end if
c
c    end 5/22/2006 by Yan Zhang
c
c  Initialize
c     Be ware of that 'i' will be changed each time when do calculations
c     for the entire, primary, and primarty+charge systems
c
      sumtyp = 0
      i = geom%natoms*3
cx      call qmmmgsum(qmmminp, mmgeom, geom%natoms, 
        call qmmmgsum(qmmminp, mmgeom, geom, geom%natoms,     !0206BW15 add geom
     *   qmmmgrad(:i), sumtyp, ierr)
      call qmmmhsum(qmmminp, mmgeom, geom%natoms, 
     *   qmmmhess(:i,:i), sumtyp, ierr)
c
c  MM calculation on the entire system
c      
      write(outfile,100)
      write(outfile,110)
      i = geom%natoms*3
      tcssmmkey = 1
      if (qmmminp%embed .eq. 'mechanical') then
         call progmmhhk(mmprognme, qmmminp%mmmeth, qmmminp%mmbas, 
     *	    geom, mmgeom, qmmminp%mmoptl, mmes(2), 
     *      qmmmmmgr(2,:i), qmmmmmhs(2,:i,:i), 
     *      ierr, 'null')
      else
         call progmm0hhk(mmprognme, qmmminp%mmmeth, qmmminp%mmbas, 
     *      geom, mmgeom, qmmminp%mmoptl, mmes(2),
     *      qmmmmmgr(2,:i), qmmmmmhs(2,:i,:i),
     *      ierr, 'null', qmmminp)
      endif          	       
      write(outfile,115) mmes(2)
100   format(80('-'))
110   format(/2x,'MM calculation on the entire system:',/)
115   format('MM energy (a.u.) for the entire system:',f20.10)      
116   format(/,10('Debug'))
117   format(2x,'MM Hessian on entrie system:')
118   format(4(d20.10))
119   format(10('Debug'),/)
     
      if (tdebug .eq. 1) then
          write (outfile,116)
          write (outfile,117)
          call mtoltm0 (i, qmmmmmhs(2,:i,:i), hs(:i*(i+1)/2))
          write (outfile,118) hs(:i*(i+1)/2)
          write (outfile,119)
      endif
      sumtyp = 1 
cx      call qmmmgsum (qmmminp, mmgeom, geom%natoms,
        call qmmmgsum(qmmminp, mmgeom, geom, geom%natoms,     !0206BW15 add geom

     *   qmmmmmgr(2,:i), sumtyp, ierr)
      call qmmmhsum (qmmminp, mmgeom, geom%natoms,
     *   qmmmmmhs(2,:i,:i), sumtyp, ierr)
c
c  Assign the appropriate geometries to ssgeom
c      
      write(outfile,100)
      write(outfile,120)
      call qmmmssgeom(geom,mmgeom,ssgeom,ssmmgeom,bgchgeom,
     *                qmmminp)
120   format(' Construct the capped primary system:')
      
c
c  MM calculation on the primary system, no point charges import
c
      write(outfile,100)
      write(outfile,130)
      tprm = 0
      tcssmmkey = 2
      i = ssgeom%natoms*3
      if (qmmminp%embed .eq. 'mechanical') then            
         call progmmhhk(mmprognme, qmmminp%mmmeth, qmmminp%mmbas, 
     *      ssgeom, ssmmgeom, qmmminp%mmoptl, mmes(1),
     *      qmmmmmgr(1,:i), qmmmmmhs(1,:i,:i), 
     *      ierr, 'null')
      else
         call progmm0hhk(mmprognme, qmmminp%mmmeth, qmmminp%mmbas,
     *      ssgeom, ssmmgeom, qmmminp%mmoptl, mmes(1),
     *      qmmmmmgr(1,:i), qmmmmmhs(1,:i,:i),
     *      ierr, 'null', qmmminp)
      endif          	       
      write(outfile,135) mmes(1)
      
130   format(//2x,'MM calculation on the capped primary system',
     *   ' without background charges:',/)
135   format(/2x,'MM energy (a.u.) for capped primary system:',
     *   f20.10)
137   format(2x,'MM Hessian on primary system:')
      
      if (tdebug .eq. 1) then
         write (outfile,116)
         write (outfile,137)
         call mtoltm0 (i, qmmmmmhs(1,:i,:i), hs(:i*(i+1)/2))	  	
         write (outfile,118) -hs(:i*(i+1)/2)
         write (outfile,119)
      endif
      sumtyp = 2
cx      call qmmmgsum (qmmminp, mmgeom, ssgeom%natoms,
        call qmmmgsum(qmmminp, mmgeom, geom, ssgeom%natoms,     !0206BW15 add geom
     *   -qmmmmmgr(1,:i), sumtyp, ierr)
      call qmmmhsum (qmmminp, mmgeom, ssgeom%natoms,
     *   -qmmmmmhs(1,:i,:i), sumtyp, ierr)
  
c
c  Work on background charges
c
      if (qmmminp%embed .eq. 'mechanical') goto 2000
      
      write(outfile,100)
      write(outfile,1000)
1000  format(//2x,'Treatment for the background point charges:')
c
c  Scale M1, M2 charges
c
      call bgchscale(geom,mmgeom,ssgeom,ssmmgeom,bgchgeom,
     *                qmmminp)
      	   
      if ((qmmminp%bordercharge .eq. 'scale')) goto 3000
		 
c		  
c     
c  Shift/redistribute M1 charges
c
      call bgchshift(geom,mmgeom,ssgeom,ssmmgeom,bgchgeom,
     *                qmmminp)   
c
c  Add charges to the small system
c
3000  call qmmmbgchgeom(geom,mmgeom,ssgeom,ssmmgeom,bgchgeom,
     *                qmmminp)
c
c  EE polarized charge calculation with the QEQ or EEM method
c  8/8/2006 by Yan Zhang                                                           
c
      call polareech(qmprognme,mmprognme, geom, mmgeom, 
     &                     ssgeom, ssmmgeom, qmmminp)

c
c  end 8/8/2006 by Yan Zhang1
c
c  Electricstatic interactions within background point charges
c	 
      write(outfile,100)
      write(outfile,400)
      i = ssgeom%natoms*3
      tcssmmkey = 2
      call progmmsthhk(1,mmprognme, qmmminp%mmmeth, qmmminp%mmbas,
     *  ssgeom, ssmmgeom, qmmminp%mmoptl, mmes(3), 
     *  qmmmmmgr(3,:i), qmmmmmhs(3,:i,:i), 
     *  ierr, 'null', qmmminp)
      write(outfile,435) mmes(3)
        
      mmes(1) = mmes(1) + mmes(3)      	       
      
400   format(/2x,'Electricstatic interactions within ',
     *  'background point charges:',/)      
435   format(/2x,'Additional MM energy (a.u.):',t50,f20.10,/2x,
     *  '(due to electricstatic interactions within',/2x,
     *  ' background point charges)',/)			        
437   format(2x,'Additonal MM Hessian')
     
      if (tdebug .eq. 1) then
         write (outfile,116)
         write (outfile,437)
         call mtoltm0 (i, qmmmmmhs(3,:i,:i), hs(:i*(i+1)/2))
         write (outfile,118) -hs(:i*(i+1)/2)
         write (outfile,119)
      endif
	 
      if (qmmminp%bordercharge .eq. 'scale')       then
         sumtyp = 4
      elseif (qmmminp%bordercharge .eq. 'shift')   then
         sumtyp = 5
      elseif (qmmminp%bordercharge .eq. 'redist1') then
         sumtyp = 6
      elseif (qmmminp%bordercharge .eq. 'rc')      then
         sumtyp = 6
      elseif (qmmminp%bordercharge .eq. 'redist2') then
         sumtyp = 7										 
      elseif (qmmminp%bordercharge .eq. 'rcd2')    then
         sumtyp = 7										 
      elseif (qmmminp%bordercharge .eq. 'redist3') then
         sumtyp = 6      
      elseif (qmmminp%bordercharge .eq. 'rcd')     then
         sumtyp = 6      
c add by Bo Wang 0207BW15
      elseif (qmmminp%bordercharge .eq. 'rcbal')   then
         sumtyp = 6
      elseif (qmmminp%bordercharge .eq. 'rcbal2')  then
         sumtyp = 3
      elseif (qmmminp%bordercharge .eq. 'rcbal3')  then
         sumtyp = 3
      elseif (qmmminp%bordercharge .eq. 'rcdbal')  then
         sumtyp = 6
      elseif (qmmminp%bordercharge .eq. 'amber2') then
         sumtyp = 3
      elseif (qmmminp%bordercharge .eq. 'seebal')  then
         sumtyp = 4
      elseif (qmmminp%bordercharge .eq. 'amber1') then
         sumtyp = 3
      elseif (qmmminp%bordercharge .eq. 'shiftbal') then
         sumtyp = 5
      elseif (qmmminp%bordercharge .eq. 'shiftbal2') then
         sumtyp = 5
c end by Bo Wang 0207BW15
      else
         sumtyp = -1
      endif
cx      call qmmmgsum (qmmminp, mmgeom, ssgeom%natoms,
      call qmmmgsum(qmmminp, mmgeom, geom, ssgeom%natoms,     !0206BW15 add geom
     *   -qmmmmmgr(3,:i), sumtyp, ierr)	     					         
	      
      call qmmmhsum (qmmminp, mmgeom, ssgeom%natoms,
     *   -qmmmmmhs(3,:i,:i), sumtyp, ierr)	     					         
	 
2000  continue
c
c
c  QM or QM** calculation on the small system
c
      write(outfile,100)
      write(outfile,140)
      i = ssgeom%natoms*3
      
      if (qmmminp%embed .eq. 'mechanical') then      
         call proghhk(qmprognme, qmmminp%qmmeth, qmmminp%qmbas, 
     *      qmmminp%qmcharge, qmmminp%qmmult,
     *      ssgeom, qmmminp%qmoptl, qmes(1), 
     *      qmmmqmgr(:i), qmmmqmhs(:i,:i), 
     *      ierr, 'null')
      else
         call proghsthk(1,qmprognme, qmmminp%qmmeth, qmmminp%qmbas,
     *      qmmminp%qmcharge, qmmminp%qmmult,
     *      ssgeom, qmmminp%qmoptl, qmes(1), 
     *      qmmmqmgr(:i), qmmmqmhs(:i,:i), 
     *      ierr, 'null',
     *      qmmminp, ssmmgeom)	 
      endif
      
      write(outfile,145) qmes(1)
      
140   format(/2x,'QM calculation on the capped small system:',/)
145   format('QM energy (a.u.) for capped small system:',f20.10)      
147   format(2x,'QM (QM**) Hessian on primary (primary + ',
     *  'background-charge) system:')
      if (tdebug .eq. 1) then
          write (outfile,116)
          write (outfile,147)
          call mtoltm0 (i, qmmmqmhs(:i,:i), hs(:i*(i+1)/2))
          write (outfile,118) hs(:i*(i+1)/2)
          write (outfile,119)
      endif
      if (qmmminp%embed .eq. 'mechanical')            then
         sumtyp = 2
      elseif (qmmminp%embed .eq. 'electric')          then
         if (qmmminp%bordercharge .eq. 'scale')       then
            sumtyp = 4
         elseif (qmmminp%bordercharge .eq. 'shift')   then
            sumtyp = 5
         elseif (qmmminp%bordercharge .eq. 'redist1') then
            sumtyp = 6
         elseif (qmmminp%bordercharge .eq. 'rc')      then
            sumtyp = 6
         elseif (qmmminp%bordercharge .eq. 'redist2') then
            sumtyp = 7
         elseif (qmmminp%bordercharge .eq. 'rcd2')    then
            sumtyp = 7
         elseif (qmmminp%bordercharge .eq. 'redist3') then
            sumtyp = 6	 	    
         elseif (qmmminp%bordercharge .eq. 'rcd')     then
            sumtyp = 6	 	    
c add by Bo Wang 0207BW15
         elseif (qmmminp%bordercharge .eq. 'rcbal')   then
            sumtyp = 6
         elseif (qmmminp%bordercharge .eq. 'rcbal2')  then
            sumtyp = 3
         elseif (qmmminp%bordercharge .eq. 'rcbal3')  then
            sumtyp = 3
         elseif (qmmminp%bordercharge .eq. 'rcdbal')  then
            sumtyp = 6
         elseif (qmmminp%bordercharge .eq. 'amber2') then
            sumtyp = 3
         elseif (qmmminp%bordercharge .eq. 'seebal')  then
            sumtyp = 4
         elseif (qmmminp%bordercharge .eq. 'amber1') then
            sumtyp = 3
         elseif (qmmminp%bordercharge .eq. 'shiftbal') then
            sumtyp = 5
         elseif (qmmminp%bordercharge .eq. 'shiftbal2') then
            sumtyp = 5
c end by Bo Wang 0207BW15

         else
            sumtyp = -1    	    	    
         endif    
      else
            sumtyp = -1	        
      endif
cx      call qmmmgsum (qmmminp, mmgeom, ssgeom%natoms,
        call qmmmgsum(qmmminp, mmgeom, geom, ssgeom%natoms,    !0206BW15 add geom
     *   qmmmqmgr(:i), sumtyp, ierr)	   
      call qmmmhsum (qmmminp, mmgeom, ssgeom%natoms,
     *   qmmmqmhs(:i,:i), sumtyp, ierr)	   
	         	 
5000  continue
c
c  Calculate the QMMM energy
c
      write(outfile,100)
      write(outfile,9000)            
      qmmmener = qmes(1) - mmes(1) + mmes(2)
      write(outfile,9100) qmmmener, qmes(1), mmes(1), mmes(2)
      
9000  format(/,'Display of QMMM energy (a.u.):',/2x,'QMMM      ',
     *   10x,'QM;CPS**',10x,'MM;CPS*',10x,'MM;ES') 
9100  format(4(f16.10,2x))      
c
c  Display gradient and hessian results
c
      i = geom%natoms*3
      write(outfile,100)
      write(outfile,9200)
      write(outfile,9210) qmmmgrad(:i)
      write(outfile,9220)
      call mtoltm0 (i, qmmmhess(:i,:i), hs(:i*(i+1)/2))	        
      write(outfile,9210) hs(:i*(i+1)/2)
9200  format(/,'Display of QMMM gradient (a.u.):')
9210  format(3(e20.12))
9220  format(/,'Display of QMMM hessian (a.u.):')
		       
      return 
      end
c******************************************************************************
c  QMMMHSUM
c******************************************************************************
c
      subroutine qmmmhsum(qmmminp, mmgeom, dim, hess, sumtyp, ierr)
c
c     Subroutine qmmmhsum
c
c     Created:  Feb. 22, 2004 by Hai Lin
c     Revised:  
c
c     Purpose:  To add the qm or mm Hessians (input as hess) into the 
c               qmmmhess hessian
c
c     Called by:  qmmmhhk
c     Calls:  
c
      use caltyp
      use input, only    : cartgeom, mmvalen, qmmminf
      use files, only    : outfile
      use hessian, only  : qmmmhess, qmmmqmhs, qmmmmmhs
      implicit none
c
c  i/o variables
c  
c      type (cartgeom) :: geom, lsgeom, ssgeom
      type (mmvalen)  :: mmgeom
      type (qmmminf)  :: qmmminp
      integer            ierr
      integer            dim
      integer            sumtyp
      double precision   hess(dim*3,dim*3)
c
c  local variables
c
      integer  capnatm, qmnatm, mmnatm, m1chnatm
      integer  ssnatm, cssnatm, lsnatm
      integer  i, j, k, m, ii, jj, kk, mm
      integer  t1, t2, t3, t4
      integer  m0, m1a, m1b, m2a, m2b, p1, p2
      integer  m1st, m2nd
      integer  mp
      
      double precision  bs1,  bs2
      double precision  bs1x, bs2x
      double precision  qs1,  qs2,  mqs1,  mqs2,  pqs1,  pqs2
      double precision  qs1x, qs2x, mqs1x, mqs2x, pqs1x, pqs2x
      double precision  qstemp1, qstemp2, qstemp1x, qstemp2x
c
c        please check module.F:hessian:maxatm value
c
      integer, parameter :: hessmax = 50*3
      double precision  hs(hessmax*(hessmax+1)/2)
c
c
c  prepare atom numbers
c
      capnatm = qmmminp%capatm%capnatm
      qmnatm  = qmmminp%qmnatm
      mmnatm  = qmmminp%mmnatm
      ssnatm  = mmgeom%natoms
      cssnatm = capnatm + qmnatm
      lsnatm  = capnatm + qmnatm + mmnatm
      m1chnatm = ssnatm - lsnatm
      m1st = qmmminp%mm1stlay%natm1stlay
      m2nd = qmmminp%mm2ndlay%natm2ndlay
      
c
c  prepare the auxiliary charge bondlength scale factor
c
      qs1  = qmmminp%chredist%chposit
      qs2  = 1.0d0 - qs1
      mqs1 = qmmminp%chredist%dipposit - 
     *          qmmminp%chredist%dipdist * 0.5d0
      mqs2 = 1.0d0 - mqs1
      pqs1 = qmmminp%chredist%dipposit + 
     *          qmmminp%chredist%dipdist * 0.5d0
      pqs2 = 1.0d0 - pqs1	   
c
c  switch sumtyp
c
c -1) Special: do nothing
c
      if (sumtyp .eq. -1) then
         return
      endif
c      	 
c  0) Special: Initialization hess
c
      if (sumtyp .eq. 0) then
         hess(: dim*3, : dim*3) = 0.0d0
      endif	 
c
c  1) Large (real) system
c         
      if (sumtyp .eq. 1) then
         qmmmhess(: lsnatm*3, : lsnatm*3) =
     *      qmmmhess(: lsnatm*3, : lsnatm*3) + hess(: dim*3, : dim*3)
      endif	 
c
c  >2) CSS system: QM + Cap
c      (QM, QM)
c         
      if (sumtyp .ge. 2) then
         do i=1, qmnatm*3
            t1 = (i + 2) / 3 
            t2 = i - t1*3
            ii = qmmminp%qmatm(t1)
            
            do j=i, qmnatm*3
               t3 = (j + 2) / 3 
               t4 = j - t3*3
               jj = qmmminp%qmatm(t3)
               
               qmmmhess(ii*3+t2, jj*3+t4) = 
     *            qmmmhess(ii*3+t2, jj*3+t4) + 
     *            hess(i, j)
               
               qmmmhess(jj*3+t4, ii*3+t2) = 
     *            qmmmhess(ii*3+t2, jj*3+t4) 
            enddo
         enddo   
c
c      (QM, Cap)
c         
c       M0  P1 -->  (1 - g1)         for M0 M1a, 
c                        g1          for M0 M1b.
c                 
c       M1a P1 --> 2(1 - g1)         for M1a M1a, 
c                        g1          for M1a M1b.
c
         do i=1, capnatm*3
            t1 = (i + 2) / 3 
            t2 = i - t1*3
            m1a = qmmminp%capatm%capatmqm(t1)
            m1b = qmmminp%capatm%capatmm1(t1)
            p1  = qmmminp%capatm%capatm(t1)
            bs1 = qmmminp%capatm%capbondscale(t1)	 
            bs2 = 1.0d0 - bs1
            ii  = i + qmnatm*3
            
            do j=1, qmnatm*3
               t3 = (j + 2) /3
               t4 = j - t3*3
               m0 = qmmminp%qmatm(t3)
	                      
               if ((m0 .eq. m1a) .and. (t2 .eq. t4)) then
                  qmmmhess(m0*3+t4, m1a*3+t2) =
     *               qmmmhess(m0*3+t4, m1a*3+t2) + 
     *               2.0d0* bs2 * hess(j, ii)
               else
                  qmmmhess(m0*3+t4, m1a*3+t2) =
     *               qmmmhess(m0*3+t4, m1a*3+t2) + 
     *                      bs2 * hess(j, ii)
               endif
               
               qmmmhess(m0*3+t4, m1b*3+t2) =
     *            qmmmhess(m0*3+t4, m1b*3+t2) + 
     *               bs1 * hess(j, ii)
               qmmmhess(m1a*3+t2, m0*3+t4) =
     *            qmmmhess(m0*3+t4, m1a*3+t2) 
               qmmmhess(m1b*3+t2, m0*3+t4) =
     *            qmmmhess(m0*3+t4, m1b*3+t2) 
               
            enddo   
         enddo
c
c      (Cap, Cap)  
c               
c       P2  P1 -->  (1 - g1)(1 - g2) for M1a M2a,
c                   (1 - g1)     g2  for M1a M2b,
c                        g1 (1 - g2) for M1b M2a,
c                        g1      g2  for M1b M2b.
         do i=1, capnatm*3
            t1 = (i + 2) /3
            t2 = i - t1*3
            m1a = qmmminp%capatm%capatmqm(t1)
            m1b = qmmminp%capatm%capatmm1(t1)
            p1  = qmmminp%capatm%capatm(t1)
            bs1 = qmmminp%capatm%capbondscale(t1)	 
            bs2 = 1.0d0 - bs1
            ii  = i + qmnatm*3
            do j=i, capnatm*3
               t3 = (j + 2) /3
               t4 = j - t3*3
               m2a  = qmmminp%capatm%capatmqm(t3)
               m2b  = qmmminp%capatm%capatmm1(t3)
               p2   = qmmminp%capatm%capatm(t3)
               bs1x = qmmminp%capatm%capbondscale(t3)	 
               bs2x = 1.0d0 - bs1x
               jj   = j + qmnatm*3
               qmmmhess(m2a*3+t4, m1a*3+t2) = 
     *            qmmmhess(m2a*3+t4, m1a*3+t2) + 
     *            bs2 * bs2x * hess(jj, ii)
                  
               qmmmhess(m2b*3+t4, m1a*3+t2) = 
     *            qmmmhess(m2b*3+t4, m1a*3+t2) + 
     *            bs2 * bs1x * hess(jj, ii)
               
               qmmmhess(m2a*3+t4, m1b*3+t2) = 
     *            qmmmhess(m2a*3+t4, m1b*3+t2) + 
     *            bs1 * bs2x * hess(jj, ii)
               
               qmmmhess(m2b*3+t4, m1b*3+t2) = 
     *            qmmmhess(m2b*3+t4, m1b*3+t2) + 
     *            bs1 * bs1x * hess(jj, ii)
               qmmmhess(m1a*3+t2, m2a*3+t4) = 
     *            qmmmhess(m2a*3+t4, m1a*3+t2)  
               qmmmhess(m1a*3+t2, m2b*3+t4) = 
     *            qmmmhess(m2b*3+t4, m1a*3+t2)  
                  
               qmmmhess(m1b*3+t2, m2a*3+t4) = 
     *            qmmmhess(m2a*3+t4, m1b*3+t2)  
               qmmmhess(m1b*3+t2, m2b*3+t4) = 
     *            qmmmhess(m2b*3+t4, m1b*3+t2) 
            enddo
         enddo      
      endif
c
c  >3) MM atoms after QM + Cap
c      
      if (sumtyp .ge. 3) then
c
c     (QM, MM)
c      
         do i=1, qmnatm*3
            t1 = (i + 2) /3
            t2 = i - t1*3
            m0 = qmmminp%qmatm(t1)
	    
         do j=1, mmnatm*3
               t3 = (j + 2) / 3 
               t4 = j - t3*3
               mm = qmmminp%mmatm(t3)
               jj = j + cssnatm*3
               
               qmmmhess(mm*3+t4, m0*3+t2) = 
     *            qmmmhess(mm*3+t4, m0*3+t2) + 
     *            hess(jj, i)
               
               qmmmhess(m0*3+t2, mm*3+t4) = 
     *            qmmmhess(mm*3+t4, m0*3+t2) 
            enddo
         enddo   	    
c
c     (Cap, MM)
c
c       M0  P1 -->  (1 - g1)         for M0 M1a, 
c                        g1          for M0 M1b.
c                 
c       M1b P1 -->      2g1          for M1b M1b, 
c                   (1 - g1)         for M1a M1b.
c
c
         do i=1, capnatm*3
            t1 = (i + 2) / 3 
            t2 = i - t1*3
            m1a = qmmminp%capatm%capatmqm(t1)
            m1b = qmmminp%capatm%capatmm1(t1)
            p1  = qmmminp%capatm%capatm(t1)
            bs1 = qmmminp%capatm%capbondscale(t1)	 
            bs2 = 1.0d0 - bs1
            ii  = i + qmnatm*3
            
            do j=1, mmnatm*3
               t3 = (j + 2) /3
               t4 = j - t3*3
               mm = qmmminp%mmatm(t3)
               jj = j + cssnatm*3
	                      
               if ((mm .eq. m1b) .and. (t2 .eq. t4)) then
                  qmmmhess(mm*3+t4, m1b*3+t2) =
     *               qmmmhess(mm*3+t4, m1b*3+t2) + 
     *               2.0d0* bs1 * hess(jj, ii)
               else
                  qmmmhess(mm*3+t4, m1b*3+t2) =
     *               qmmmhess(mm*3+t4, m1b*3+t2) + 
     *                      bs1 * hess(jj, ii)
               endif
               
               qmmmhess(mm*3+t4, m1a*3+t2) =
     *            qmmmhess(mm*3+t4, m1a*3+t2) + 
     *               bs2 * hess(jj, ii)
               qmmmhess(m1a*3+t2, mm*3+t4) =
     *            qmmmhess(mm*3+t4, m1a*3+t2) 
               qmmmhess(m1b*3+t2, mm*3+t4) =
     *            qmmmhess(mm*3+t4, m1b*3+t2) 
               
            enddo   
         enddo
c
c     (MM, MM)
c
         do i=1, mmnatm*3
            t1 = (i + 2) /3
            t2 = i - t1*3
            m0 = qmmminp%mmatm(t1)
            ii = i + cssnatm*3
            do j=i, mmnatm*3
               t3 = (j + 2) /3
               t4 = j - t3*3
               mm = qmmminp%mmatm(t3)
               jj = j + cssnatm*3
            
               qmmmhess(mm*3+t4, m0*3+t2) =
     *            qmmmhess(mm*3+t4, m0*3+t2) + 
     *            hess(jj, ii)
               
               qmmmhess(m0*3+t2, mm*3+t4) =
     *            qmmmhess(mm*3+t4, m0*3+t2) 
            enddo
         enddo   
      endif   
c
c  4) M1 atom after QM + Cap + MM
c      
      if (sumtyp .eq. 4) then
c
c     (QM, M1)
c      
         do i=1, qmnatm*3
            t1 = (i + 2) /3
            t2 = i - t1*3
            m0 = qmmminp%qmatm(t1)
	    
            do j=1, m1st*3
               t3 = (j + 2) / 3 
               t4 = j - t3*3
               mm = qmmminp%mm1stlay%atm1stlay(t3)
               jj = j + lsnatm*3
               
               qmmmhess(mm*3+t4, m0*3+t2) = 
     *            qmmmhess(mm*3+t4, m0*3+t2) + 
     *            hess(jj, i)
               
               qmmmhess(m0*3+t2, mm*3+t4) = 
     *            qmmmhess(mm*3+t4, m0*3+t2) 
            enddo
         enddo   	    
c
c     (Cap, M1)
c
c       M0  P1 -->  (1 - g1)         for M0 M1a, 
c                        g1          for M0 M1b.
c                 
c       M1b P1 -->      2g1          for M1b M1b, 
c                   (1 - g1)         for M1a M1b.
c
c
         do i=1, capnatm*3
            t1 = (i + 2) / 3 
            t2 = i - t1*3
            m1a = qmmminp%capatm%capatmqm(t1)
            m1b = qmmminp%capatm%capatmm1(t1)
            p1  = qmmminp%capatm%capatm(t1)
            bs1 = qmmminp%capatm%capbondscale(t1)	 
            bs2 = 1.0d0 - bs1
            ii  = i + qmnatm*3
            
            do j=1, m1st*3
               t3 = (j + 2) /3
               t4 = j - t3*3
               mm = qmmminp%mm1stlay%atm1stlay(t3)
               jj = j + lsnatm*3
	                      
               if ((mm .eq. m1b) .and. (t2 .eq. t4)) then
                  qmmmhess(mm*3+t4, m1b*3+t2) =
     *               qmmmhess(mm*3+t4, m1b*3+t2) + 
     *               2.0d0* bs1 * hess(jj, ii)
               else
                  qmmmhess(mm*3+t4, m1b*3+t2) =
     *               qmmmhess(mm*3+t4, m1b*3+t2) + 
     *                      bs1 * hess(jj, ii)
               endif
               
               qmmmhess(mm*3+t4, m1a*3+t2) =
     *            qmmmhess(mm*3+t4, m1a*3+t2) + 
     *               bs2 * hess(jj, ii)
               qmmmhess(m1a*3+t2, mm*3+t4) =
     *            qmmmhess(mm*3+t4, m1a*3+t2) 
               qmmmhess(m1b*3+t2, mm*3+t4) =
     *            qmmmhess(mm*3+t4, m1b*3+t2) 
               
            enddo   
         enddo
c
c     (MM, M1)
c
         do i=1, mmnatm*3
            t1 = (i + 2) /3
            t2 = i - t1*3
            m0 = qmmminp%mmatm(t1)
            ii = i + cssnatm*3
            do j=i, m1st*3
               t3 = (j + 2) /3
               t4 = j - t3*3
               mm = qmmminp%mm1stlay%atm1stlay(t3)
               jj = j + lsnatm*3
            
               qmmmhess(mm*3+t4, m0*3+t2) =
     *            qmmmhess(mm*3+t4, m0*3+t2) + 
     *            hess(jj, ii)
               
               qmmmhess(m0*3+t2, mm*3+t4) =
     *            qmmmhess(mm*3+t4, m0*3+t2) 
            enddo
         enddo   
c
c     (M1, M1)
c
         do i=1, m1st*3
            t1 = (i + 2) /3
            t2 = i - t1*3
            m0 = qmmminp%mm1stlay%atm1stlay(t1)
            ii = i + lsnatm*3
            do j=i, m1st*3
               t3 = (j + 2) /3
               t4 = j - t3*3
               mm = qmmminp%mm1stlay%atm1stlay(t3)
               jj = j + lsnatm*3
            
               qmmmhess(mm*3+t4, m0*3+t2) =
     *            qmmmhess(mm*3+t4, m0*3+t2) + 
     *            hess(jj, ii)
               
               qmmmhess(m0*3+t2, mm*3+t4) =
     *            qmmmhess(mm*3+t4, m0*3+t2) 
            enddo
         enddo   
      endif   
c
c  5) bordercharge = shift: dipole mimic charges
c
      if (sumtyp .eq. 5) then
c
c     (QM, mq/pq)
c      
c       M0  P1 -->  (1 - g1)         for M0 M1a, 
c                        g1          for M0 M1b.
c
         mp = -3
         do i=1, qmnatm*3
            t1 = (i + 2) /3
            t2 = i - t1*3
            m0 = qmmminp%qmatm(t1)
	    
            do j=1, m2nd*6
               t3 = (j + 5) / 6 
               t4 = j - t3*6
               m1a = qmmminp%mm2ndlay%atm2ndlaym1(t3)
               m1b = qmmminp%mm2ndlay%atm2ndlay(t3)	    		 	    
               jj = j + lsnatm*3
     	       
               if (t4 .le. mp) then 
                  qstemp1 = mqs1
                  qstemp2 = mqs2
                  t4 = t4 + 3
               else
                  qstemp1 = pqs1
                  qstemp2 = pqs2     	       
               endif   
     	       
               qmmmhess(m1a*3+t4, m0*3+t2) = 
     *            qmmmhess(m1a*3+t4, m0*3+t2) + 
     *            qstemp2 * hess(jj, i)
               
               qmmmhess(m1b*3+t4, m0*3+t2) = 
     *            qmmmhess(m1b*3+t4, m0*3+t2) + 
     *            qstemp1 * hess(jj, i)
               qmmmhess(m0*3+t2, m1a*3+t4) = 
     *            qmmmhess(m1a*3+t4, m0*3+t2) 
               qmmmhess(m0*3+t2, m1b*3+t4) = 
     *            qmmmhess(m1b*3+t4, m0*3+t2) 
            enddo
         enddo   	    
c
c     (Cap, mq/pq)
c               
c       P2  P1 -->  (1 - g1)(1 - g2) for M1a M2a,
c                   (1 - g1)     g2  for M1a M2b,
c                        g1 (1 - g2) for M1b M2a,
c                        g1      g2  for M1b M2b.
c
         do i=1, capnatm*3
            t1 = (i + 2) /3
            t2 = i - t1*3
            m1a = qmmminp%capatm%capatmqm(t1)
            m1b = qmmminp%capatm%capatmm1(t1)
            p1  = qmmminp%capatm%capatm(t1)
            bs1 = qmmminp%capatm%capbondscale(t1)	 
            bs2 = 1.0d0 - bs1
            ii  = i + qmnatm*3
            do j=1, m2nd*6
               t3 = (j + 5) / 6 
               t4 = j - t3*6
               m2a = qmmminp%mm2ndlay%atm2ndlaym1(t3)
               m2b = qmmminp%mm2ndlay%atm2ndlay(t3)	    		 	    
               jj = j + lsnatm*3
     	       
               if (t4 .le. mp) then 
                  qstemp1 = mqs1
                  qstemp2 = mqs2
                  t4 = t4 + 3
               else
                  qstemp1 = pqs1
                  qstemp2 = pqs2     	       
               endif   
               qmmmhess(m2a*3+t4, m1a*3+t2) = 
     *            qmmmhess(m2a*3+t4, m1a*3+t2) + 
     *            bs2 * qstemp2 * hess(jj, ii)
                  
               qmmmhess(m2b*3+t4, m1a*3+t2) = 
     *            qmmmhess(m2b*3+t4, m1a*3+t2) + 
     *            bs2 * qstemp1 * hess(jj, ii)
               
               qmmmhess(m2a*3+t4, m1b*3+t2) = 
     *            qmmmhess(m2a*3+t4, m1b*3+t2) + 
     *            bs1 * qstemp2 * hess(jj, ii)
               
               qmmmhess(m2b*3+t4, m1b*3+t2) = 
     *            qmmmhess(m2b*3+t4, m1b*3+t2) + 
     *            bs1 * qstemp1 * hess(jj, ii)
               qmmmhess(m1a*3+t2, m2a*3+t4) = 
     *            qmmmhess(m2a*3+t4, m1a*3+t2)  
               qmmmhess(m1a*3+t2, m2b*3+t4) = 
     *            qmmmhess(m2b*3+t4, m1a*3+t2)  
                  
               qmmmhess(m1b*3+t2, m2a*3+t4) = 
     *            qmmmhess(m2a*3+t4, m1b*3+t2)  
               qmmmhess(m1b*3+t2, m2b*3+t4) = 
     *            qmmmhess(m2b*3+t4, m1b*3+t2) 
            enddo
         enddo      
c
c     (MM, mq/pq)
c
         do i=1, mmnatm*3
            t1 = (i + 2) /3
            t2 = i - t1*3
            m0 = qmmminp%mmatm(t1)
	    ii = i + cssnatm*3
	    do j=1, m2nd*6
               t3 = (j + 5) / 6 
               t4 = j - t3*6
               m1a = qmmminp%mm2ndlay%atm2ndlaym1(t3)
               m1b = qmmminp%mm2ndlay%atm2ndlay(t3)	    		 	    
               jj = j + lsnatm*3
	    
               if (t4 .le. mp) then 
                  qstemp1 = mqs1
                  qstemp2 = mqs2
                  t4 = t4 + 3
               else
                  qstemp1 = pqs1
                  qstemp2 = pqs2     	       
               endif   
	       
               qmmmhess(m1a*3+t4, m0*3+t2) = 
     *            qmmmhess(m1a*3+t4, m0*3+t2) + 
     *            qstemp2 * hess(jj, ii)
c 1214HL04
               if ((m0 .eq. m1b) .and. (t2 .eq. t4)) then
                  qmmmhess(m1b*3+t4, m0*3+t2) = 
     *               qmmmhess(m1b*3+t4, m0*3+t2) + 
     *               2.0d0 * qstemp1 * hess(jj, ii)
               else
                  qmmmhess(m1b*3+t4, m0*3+t2) =
     *               qmmmhess(m1b*3+t4, m0*3+t2) +
     *               qstemp1 * hess(jj, ii)          		  	       
               endif
c 1214HL04end
	       
               qmmmhess(m0*3+t2, m1a*3+t4) = 
     *            qmmmhess(m1a*3+t4, m0*3+t2) 
               qmmmhess(m0*3+t2, m1b*3+t4) = 
     *            qmmmhess(m1b*3+t4, m0*3+t2) 
            enddo
         enddo   	    
c
c   (mq/pq, mq/pq)
c
         do i=1, m2nd*6
            t1 = (i + 5) /6
            t2 = i - t1*6
            m1a = qmmminp%mm2ndlay%atm2ndlaym1(t1)
            m1b = qmmminp%mm2ndlay%atm2ndlay(t1)	    		 	    
            ii  = i + lsnatm*3
        if (t2 .le. mp) then 
               qstemp1x = mqs1
               qstemp2x = mqs2
               t2 = t2 + 3
        else
               qstemp1x = pqs1
               qstemp2x = pqs2     	       
        endif   
        do j=i, m2nd*6
               t3 = (j + 5) / 6 
               t4 = j - t3*6
               m2a = qmmminp%mm2ndlay%atm2ndlaym1(t3)
               m2b = qmmminp%mm2ndlay%atm2ndlay(t3)	    		 	    
               jj = j + lsnatm*3
     	       
               if (t4 .le. mp) then 
                  qstemp1 = mqs1
                  qstemp2 = mqs2
                  t4 = t4 + 3
               else
                  qstemp1 = pqs1
                  qstemp2 = pqs2     	       
               endif   
               qmmmhess(m2a*3+t4, m1a*3+t2) = 
     *            qmmmhess(m2a*3+t4, m1a*3+t2) + 
     *            qstemp2x * qstemp2 * hess(jj, ii)
                  
               qmmmhess(m2b*3+t4, m1a*3+t2) = 
     *            qmmmhess(m2b*3+t4, m1a*3+t2) + 
     *            qstemp2x * qstemp1 * hess(jj, ii)
               
               qmmmhess(m2a*3+t4, m1b*3+t2) = 
     *            qmmmhess(m2a*3+t4, m1b*3+t2) + 
     *            qstemp1x * qstemp2 * hess(jj, ii)
               
               qmmmhess(m2b*3+t4, m1b*3+t2) = 
     *            qmmmhess(m2b*3+t4, m1b*3+t2) + 
     *            qstemp1x * qstemp1 * hess(jj, ii)
               qmmmhess(m1a*3+t2, m2a*3+t4) = 
     *            qmmmhess(m2a*3+t4, m1a*3+t2)  
               qmmmhess(m1a*3+t2, m2b*3+t4) = 
     *            qmmmhess(m2b*3+t4, m1a*3+t2)  
                  
               qmmmhess(m1b*3+t2, m2a*3+t4) = 
     *            qmmmhess(m2a*3+t4, m1b*3+t2)  
               qmmmhess(m1b*3+t2, m2b*3+t4) = 
     *            qmmmhess(m2b*3+t4, m1b*3+t2) 
            enddo
         enddo      
      endif
c
c  6) bordercharge = redist1/rc/redist3/rcd: redistribute charges
c
      if (sumtyp .eq. 6) then
c
c     (QM, q)
c      
c       M0  P1 -->  (1 - g1)         for M0 M1a, 
c                        g1          for M0 M1b.
c
         do i=1, qmnatm*3
            t1 = (i + 2) /3
            t2 = i - t1*3
	    m0 = qmmminp%qmatm(t1)
	    
	    do j=1, m2nd*3
               t3 = (j + 2) / 3 
               t4 = j - t3*3
               m1a = qmmminp%mm2ndlay%atm2ndlaym1(t3)
               m1b = qmmminp%mm2ndlay%atm2ndlay(t3)	    		 	    
               jj = j + lsnatm*3
     	       
               qstemp1 = qs1
               qstemp2 = qs2
     	       
               qmmmhess(m1a*3+t4, m0*3+t2) = 
     *            qmmmhess(m1a*3+t4, m0*3+t2) + 
     *            qstemp2 * hess(jj, i)
               
               qmmmhess(m1b*3+t4, m0*3+t2) = 
     *            qmmmhess(m1b*3+t4, m0*3+t2) + 
     *            qstemp1 * hess(jj, i)
               qmmmhess(m0*3+t2, m1a*3+t4) = 
     *            qmmmhess(m1a*3+t4, m0*3+t2) 
               qmmmhess(m0*3+t2, m1b*3+t4) = 
     *            qmmmhess(m1b*3+t4, m0*3+t2) 
            enddo
         enddo   	    
c
c     (Cap, q)
c               
c       P2  P1 -->  (1 - g1)(1 - g2) for M1a M2a,
c                   (1 - g1)     g2  for M1a M2b,
c                        g1 (1 - g2) for M1b M2a,
c                        g1      g2  for M1b M2b.
c
         do i=1, capnatm*3
            t1 = (i + 2) /3
            t2 = i - t1*3
            m1a = qmmminp%capatm%capatmqm(t1)
            m1b = qmmminp%capatm%capatmm1(t1)
            p1  = qmmminp%capatm%capatm(t1)
            bs1 = qmmminp%capatm%capbondscale(t1)	 
            bs2 = 1.0d0 - bs1
            ii  = i + qmnatm*3
        do j=1, m2nd*3
               t3 = (j + 2) / 3
               t4 = j - t3*3
               m2a = qmmminp%mm2ndlay%atm2ndlaym1(t3)
               m2b = qmmminp%mm2ndlay%atm2ndlay(t3)	    		 	    
               jj = j + lsnatm*3
     	       
               qstemp1 = qs1
               qstemp2 = qs2
               qmmmhess(m2a*3+t4, m1a*3+t2) = 
     *            qmmmhess(m2a*3+t4, m1a*3+t2) + 
     *            bs2 * qstemp2 * hess(jj, ii)
                  
               qmmmhess(m2b*3+t4, m1a*3+t2) = 
     *            qmmmhess(m2b*3+t4, m1a*3+t2) + 
     *            bs2 * qstemp1 * hess(jj, ii)
               
               qmmmhess(m2a*3+t4, m1b*3+t2) = 
     *            qmmmhess(m2a*3+t4, m1b*3+t2) + 
     *            bs1 * qstemp2 * hess(jj, ii)
               
               qmmmhess(m2b*3+t4, m1b*3+t2) = 
     *            qmmmhess(m2b*3+t4, m1b*3+t2) + 
     *            bs1 * qstemp1 * hess(jj, ii)
               qmmmhess(m1a*3+t2, m2a*3+t4) = 
     *            qmmmhess(m2a*3+t4, m1a*3+t2)  
               qmmmhess(m1a*3+t2, m2b*3+t4) = 
     *            qmmmhess(m2b*3+t4, m1a*3+t2)  
                  
               qmmmhess(m1b*3+t2, m2a*3+t4) = 
     *            qmmmhess(m2a*3+t4, m1b*3+t2)  
               qmmmhess(m1b*3+t2, m2b*3+t4) = 
     *            qmmmhess(m2b*3+t4, m1b*3+t2) 
            enddo
         enddo      
c
c     (MM, q)
c
         do i=1, mmnatm*3
            t1 = (i + 2) /3
            t2 = i - t1*3
            m0 = qmmminp%mmatm(t1)
            ii = i + cssnatm*3
            do j=1, m2nd*3
               t3 = (j + 2) / 3 
               t4 = j - t3*3
               m1a = qmmminp%mm2ndlay%atm2ndlaym1(t3)
               m1b = qmmminp%mm2ndlay%atm2ndlay(t3)	    		 	    
               jj = j + lsnatm*3
     	       
               qstemp1 = qs1
               qstemp2 = qs2
               qmmmhess(m1a*3+t4, m0*3+t2) = 
     *            qmmmhess(m1a*3+t4, m0*3+t2) + 
     *            qstemp2 * hess(jj, ii)
C 1214HL04
               if ((m0 .eq. m1b) .and. (t2 .eq. t4)) then
                  qmmmhess(m1b*3+t4, m0*3+t2) =
     *               qmmmhess(m1b*3+t4, m0*3+t2) +
     *               2.0d0 * qstemp1 * hess(jj, ii)          	            
               else
                  qmmmhess(m1b*3+t4, m0*3+t2) = 
     *               qmmmhess(m1b*3+t4, m0*3+t2) + 
     *               qstemp1 * hess(jj, ii)
     	       endif
C 1214HL04end	       
	         
               qmmmhess(m0*3+t2, m1a*3+t4) = 
     *            qmmmhess(m1a*3+t4, m0*3+t2) 
               qmmmhess(m0*3+t2, m1b*3+t4) = 
     *            qmmmhess(m1b*3+t4, m0*3+t2) 
            enddo
         enddo   	    
c
c   (q, q)
c
         do i=1, m2nd*3
            t1 = (i + 2) /3
            t2 = i - t1*3
            m1a = qmmminp%mm2ndlay%atm2ndlaym1(t1)
            m1b = qmmminp%mm2ndlay%atm2ndlay(t1)	    		 	    
            ii  = i + lsnatm*3
            qstemp1x = qs1
            qstemp2x = qs2
         do j=i, m2nd*3
               t3 = (j + 2) / 3 
               t4 = j - t3*3
               m2a = qmmminp%mm2ndlay%atm2ndlaym1(t3)
               m2b = qmmminp%mm2ndlay%atm2ndlay(t3)	    		 	    
               jj = j + lsnatm*3
C 1214HL04     	       
               qstemp1 = qs1
               qstemp2 = qs2
C 1214HL04end
               qmmmhess(m2a*3+t4, m1a*3+t2) = 
     *            qmmmhess(m2a*3+t4, m1a*3+t2) + 
     *            qstemp2x * qstemp2 * hess(jj, ii)
                  
               qmmmhess(m2b*3+t4, m1a*3+t2) = 
     *            qmmmhess(m2b*3+t4, m1a*3+t2) + 
     *            qstemp2x * qstemp1 * hess(jj, ii)
               
               qmmmhess(m2a*3+t4, m1b*3+t2) = 
     *            qmmmhess(m2a*3+t4, m1b*3+t2) + 
     *            qstemp1x * qstemp2 * hess(jj, ii)
               
               qmmmhess(m2b*3+t4, m1b*3+t2) = 
     *            qmmmhess(m2b*3+t4, m1b*3+t2) + 
     *            qstemp1x * qstemp1 * hess(jj, ii)
               qmmmhess(m1a*3+t2, m2a*3+t4) = 
     *            qmmmhess(m2a*3+t4, m1a*3+t2)  
               qmmmhess(m1a*3+t2, m2b*3+t4) = 
     *            qmmmhess(m2b*3+t4, m1a*3+t2)  
                  
               qmmmhess(m1b*3+t2, m2a*3+t4) = 
     *            qmmmhess(m2a*3+t4, m1b*3+t2)  
               qmmmhess(m1b*3+t2, m2b*3+t4) = 
     *            qmmmhess(m2b*3+t4, m1b*3+t2) 
            enddo
         enddo      
      endif
c
c  7) bordercharge = redist2/rcd2: redistribute and dipole mimic charges
c
      if (sumtyp .eq. 7) then
c
c     (QM, q/mq/pq)
c      
c       M0  P1 -->  (1 - g1)         for M0 M1a, 
c                        g1          for M0 M1b.
c
         mp = -3
         do i=1, qmnatm*3
            t1 = (i + 2) /3
            t2 = i - t1*3
            m0 = qmmminp%qmatm(t1)
	    
            do j=1, m2nd*9
               t3 = (j + 8) / 9 
               t4 = j - t3*9
               m1a = qmmminp%mm2ndlay%atm2ndlaym1(t3)
               m1b = qmmminp%mm2ndlay%atm2ndlay(t3)	    		 	    
               jj = j + lsnatm*3
     	       
               if (t4 .le. mp*2) then 
                  qstemp1 =  qs1
                  qstemp2 =  qs2
                  t4 = t4 + 6
               elseif (t4. le. mp) then
                  qstemp1 = mqs1
                  qstemp2 = mqs2
                  t4 = t4 + 3
               else
                  qstemp1 = pqs1
                  qstemp2 = pqs2     	       
               endif   
     	       
               qmmmhess(m1a*3+t4, m0*3+t2) = 
     *            qmmmhess(m1a*3+t4, m0*3+t2) + 
     *            qstemp2 * hess(jj, i)
               
               qmmmhess(m1b*3+t4, m0*3+t2) = 
     *            qmmmhess(m1b*3+t4, m0*3+t2) + 
     *            qstemp1 * hess(jj, i)
               qmmmhess(m0*3+t2, m1a*3+t4) = 
     *            qmmmhess(m1a*3+t4, m0*3+t2) 
               qmmmhess(m0*3+t2, m1b*3+t4) = 
     *            qmmmhess(m1b*3+t4, m0*3+t2) 
            enddo
         enddo   	    
c
c     (Cap, q/mq/pq)
c               
c       P2  P1 -->  (1 - g1)(1 - g2) for M1a M2a,
c                   (1 - g1)     g2  for M1a M2b,
c                        g1 (1 - g2) for M1b M2a,
c                        g1      g2  for M1b M2b.
c
         do i=1, capnatm*3
            t1 = (i + 2) /3
            t2 = i - t1*3
            m1a = qmmminp%capatm%capatmqm(t1)
            m1b = qmmminp%capatm%capatmm1(t1)
            p1  = qmmminp%capatm%capatm(t1)
            bs1 = qmmminp%capatm%capbondscale(t1)	 
            bs2 = 1.0d0 - bs1
            ii  = i + qmnatm*3
         do j=1, m2nd*9
               t3 = (j + 8) / 9
               t4 = j - t3*9
               m2a = qmmminp%mm2ndlay%atm2ndlaym1(t3)
               m2b = qmmminp%mm2ndlay%atm2ndlay(t3)	    		 	    
               jj = j + lsnatm*3
     	       
               if (t4 .le. mp*2) then 
                  qstemp1 =  qs1
                  qstemp2 =  qs2
                  t4 = t4 + 6
               elseif (t4. le. mp) then
                  qstemp1 = mqs1
                  qstemp2 = mqs2
                  t4 = t4 + 3
               else
                  qstemp1 = pqs1
                  qstemp2 = pqs2     	       
               endif   
               qmmmhess(m2a*3+t4, m1a*3+t2) = 
     *            qmmmhess(m2a*3+t4, m1a*3+t2) + 
     *            bs2 * qstemp2 * hess(jj, ii)
                  
               qmmmhess(m2b*3+t4, m1a*3+t2) = 
     *            qmmmhess(m2b*3+t4, m1a*3+t2) + 
     *            bs2 * qstemp1 * hess(jj, ii)
               
               qmmmhess(m2a*3+t4, m1b*3+t2) = 
     *            qmmmhess(m2a*3+t4, m1b*3+t2) + 
     *            bs1 * qstemp2 * hess(jj, ii)
               
               qmmmhess(m2b*3+t4, m1b*3+t2) = 
     *            qmmmhess(m2b*3+t4, m1b*3+t2) + 
     *            bs1 * qstemp1 * hess(jj, ii)
               qmmmhess(m1a*3+t2, m2a*3+t4) = 
     *            qmmmhess(m2a*3+t4, m1a*3+t2)  
               qmmmhess(m1a*3+t2, m2b*3+t4) = 
     *            qmmmhess(m2b*3+t4, m1a*3+t2)  
                  
               qmmmhess(m1b*3+t2, m2a*3+t4) = 
     *            qmmmhess(m2a*3+t4, m1b*3+t2)  
               qmmmhess(m1b*3+t2, m2b*3+t4) = 
     *            qmmmhess(m2b*3+t4, m1b*3+t2) 
            enddo
         enddo      
c
c     (MM, q/mq/pq)
c
         do i=1, mmnatm*3
            t1 = (i + 2) /3
            t2 = i - t1*3
            m0 = qmmminp%mmatm(t1)
            ii = i + cssnatm*3
         do j=1, m2nd*9
               t3 = (j + 8) / 9 
               t4 = j - t3*9
               m1a = qmmminp%mm2ndlay%atm2ndlaym1(t3)
               m1b = qmmminp%mm2ndlay%atm2ndlay(t3)	    		 	    
               jj = j + lsnatm*3
     	       
               if (t4 .le. mp*2) then 
                  qstemp1 = qs1
                  qstemp2 = qs2
                  t4 = t4 + 6
               elseif (t4. le. mp) then
                  qstemp1 = mqs1
                  qstemp2 = mqs2
                  t4 = t4 + 3
               else
                  qstemp1 = pqs1
                  qstemp2 = pqs2     	       
               endif   
               qmmmhess(m1a*3+t4, m0*3+t2) = 
     *            qmmmhess(m1a*3+t4, m0*3+t2) + 
     *            qstemp2 * hess(jj, ii)
c 1214HL04
               if ((m0 .eq. m1b) .and. (t2 .eq. t4)) then	                      
                  qmmmhess(m1b*3+t4, m0*3+t2) = 
     *               qmmmhess(m1b*3+t4, m0*3+t2) + 
     *               2.0d0 * qstemp1 * hess(jj, ii)
               else
                  qmmmhess(m1b*3+t4, m0*3+t2) =
     *               qmmmhess(m1b*3+t4, m0*3+t2) +
     *               qstemp1 * hess(jj, ii)
               endif
c 1214HL04end
	       	  	       
               qmmmhess(m0*3+t2, m1a*3+t4) = 
     *            qmmmhess(m1a*3+t4, m0*3+t2) 
               qmmmhess(m0*3+t2, m1b*3+t4) = 
     *            qmmmhess(m1b*3+t4, m0*3+t2) 
            enddo
         enddo   	    
c
c   (q/mq/pq, q/mq/pq)
c
         do i=1, m2nd*9
            t1 = (i + 8) /9
            t2 = i - t1*9
            m1a = qmmminp%mm2ndlay%atm2ndlaym1(t1)
            m1b = qmmminp%mm2ndlay%atm2ndlay(t1)	    		 	    
            ii  = i + lsnatm*3
        if (t2 .le. mp*2) then 
               qstemp1x =  qs1
               qstemp2x =  qs2
               t2 = t2 + 6   	    
        elseif (t2 .le. mp) then
               qstemp1x = mqs1
               qstemp2x = mqs2
               t2 = t2 + 3
        else
               qstemp1x = pqs1
               qstemp2x = pqs2     	       
        endif   
        do j=i, m2nd*9
               t3 = (j + 8) / 9 
               t4 = j - t3*9
               m2a = qmmminp%mm2ndlay%atm2ndlaym1(t3)
               m2b = qmmminp%mm2ndlay%atm2ndlay(t3)	    		 	    
               jj = j + lsnatm*3
     	       
               if (t4 .le. mp*2) then 
                  qstemp1 =  qs1
                  qstemp2 =  qs2
                  t4 = t4 + 6
               elseif (t4.le. mp) then        	       
                  qstemp1 = mqs1
                  qstemp2 = mqs2
                  t4 = t4 + 3
               else
                  qstemp1 = pqs1
                  qstemp2 = pqs2     	       
               endif   
               qmmmhess(m2a*3+t4, m1a*3+t2) = 
     *            qmmmhess(m2a*3+t4, m1a*3+t2) + 
     *            qstemp2x * qstemp2 * hess(jj, ii)
                  
               qmmmhess(m2b*3+t4, m1a*3+t2) = 
     *            qmmmhess(m2b*3+t4, m1a*3+t2) + 
     *            qstemp2x * qstemp1 * hess(jj, ii)
               
               qmmmhess(m2a*3+t4, m1b*3+t2) = 
     *            qmmmhess(m2a*3+t4, m1b*3+t2) + 
     *            qstemp1x * qstemp2 * hess(jj, ii)
               
               qmmmhess(m2b*3+t4, m1b*3+t2) = 
     *            qmmmhess(m2b*3+t4, m1b*3+t2) + 
     *            qstemp1x * qstemp1 * hess(jj, ii)
               qmmmhess(m1a*3+t2, m2a*3+t4) = 
     *            qmmmhess(m2a*3+t4, m1a*3+t2)  
               qmmmhess(m1a*3+t2, m2b*3+t4) = 
     *            qmmmhess(m2b*3+t4, m1a*3+t2)  
                  
               qmmmhess(m1b*3+t2, m2a*3+t4) = 
     *            qmmmhess(m2a*3+t4, m1b*3+t2)  
               qmmmhess(m1b*3+t2, m2b*3+t4) = 
     *            qmmmhess(m2b*3+t4, m1b*3+t2) 
            enddo
         enddo      
      endif
c
c  if debug, show the uptodate hessian
c      
      if (tdebug .eq. 1) then
         write (outfile,1000)
         write (outfile,1010) sumtyp
         i = lsnatm*3
         call mtoltm0 (i, qmmmhess(:i,:i), hs(:i*(i+1)/2))
         write (outfile,1020) hs(:i*(i+1)/2)
         write (outfile,1005)
      endif
1000  format(/,10('Debug'))
1005  format(10('Debug'),/)
1010  format('Sumtyp = ',i2,8x,'Uptodate hessian for real system:')
c1020  format(4(e20.10))
1020  format(5(e16.8))
        
      return
      
      end      
c*****************************************************************************
c  PROGMMSTHHK
c*****************************************************************************
c
      subroutine progmmsthhk(ppnum, prognme, esmeth, esbas, geom, 
     *   mmgeom, optl, ener, grad, hess, ierr, ver_lab,
     *   qmmminp)
c
c     Subroutine progmmsthhk
c
c     Created:  Feb. 22, 2004 by Hai Lin 
c     Revised:  Dec. 03, 2004 by Hai Lin
c                 Change v12 = 1.0 to v12 = 0.0
c
c
c     Purpose:  Get a single point interaction energy and gradient between 
c               the given geom and the background point charge with the 
c               specified force field package.
c
c
c     Description:  Calls a subroutine to write an MM input file,
c         runs two (energy and gradient) calculations on the system, 
c         and then calls a subroutine 
c         that reads the energy and gradient from the MM output file
c         created by the force field package.
c
c     Note:  Currently only TINKER is enabled but it would be easily
c        expanded to other force field programs.  new _inpe and
c        _oute subroutines would have to be written for each different
c        program though.
c
c  ppnum determines the name of the input and output files for parallel runs
c  reserved for future use
c
c     Called by:  optghk, qmmmghk, mlghook
c
c     Calls:  t41inp, t41outg, system
c
      use caltyp
      use files
      use input, only : cartgeom, mmvalen, qmmminf, maxoptl
      implicit none
c
c  i/o variables
c
      character*10       prognme
      character*20       esmeth, esbas, ver_lab
c
      character*80       optl(maxoptl)
      integer            ierr, ppnum
      type (cartgeom) :: geom
      type (mmvalen)  :: mmgeom	          
      type (qmmminf)  :: qmmminp
      double precision   ener, grad(geom%natoms*3)             
      double precision   hess(3*geom%natoms, 3*geom%natoms)
c
c  local variables
c      
      double precision   v11, v12, v22
c
c  TINKER 
c
      if (prognme(:6).eq.'tinker') then
         open (unit=t41inf, status='unknown', file=t41in, err=9994)
         open (unit=t41keyf, status='unknown', file=t41key, err=9995)
         call t41inp(t41inf, t41keyf,
     *      esmeth, esbas, geom, mmgeom,optl,tgrad,ver_lab)
c
c hailin01182005end      
c
c  additional key words
c
         v11 = 0.0d0
         v12 = 0.0d0
         v22 = 1.0d0
         call t41keyadd(t41keyf, geom, mmgeom, qmmminp, 
     *      v11, v12, v22, ierr)
     
         close (t41inf, err=9994)
         close (t41keyf, err=9995)        	    
         close (t41inf, err=9994)
         close (t41keyf, err=9995)
c
c read the atomic MM charge
c  also print MM parameters if required
c
         if ((tprm .eq. 1) .or. (mmgeom%lprnatmprm .eq. 1)) then
            call system('t41shuttle t41 p')
            call t41outp(mmgeom)
         endif    
c
c calculate energy, gradient, and Hessian
c	 
         call system('t41shuttle t41 e')
         call t41oute(1,esmeth,ener)
         call system('t41shuttle t41 g')
         call t41outg(1,esmeth,ener, grad, geom%natoms)
         call system('t41shuttle t41 h')
         call t41outh(esmeth, hess, geom%natoms)         
      endif
      return
9994  write (outfile,*) 'Error creating TINKER .xyz file'
      stop 'progghk 4'
9995  write (outfile,*) 'Error creating TINKER .key file'
      stop 'progghk 5'
      end
c
c*****************************************************************************
c  PROGHSTHK
c*****************************************************************************
c
      subroutine proghsthk(ppnum, prognme, esmeth, esbas, 
     *   qmcharge, qmmult, ssgeom, 
     *   optl, ener, grad, hess, ierr, ver_lab, qmmminp, ssmmgeom)
c
c     Subroutine proghsthk
c
c     Created:  Feb. 22, 2004 by Hai Lin
c     Revised:  
c     Purpose:  Get a single point energy, gradient, and hessian for 
c        the small system in the presence of background charges with the
c        specified electronic structure package.
c
c     Description:  Calls a function to write a G03 input file,
c         runs this calculation on the system, and then calls a fxn that
c         reads the energy and gradient from the formatted checkpoint file
c         created by G03.
c
c     Note:  Currently only G03 are enabled but it would be easily
c        expanded to other electronic structure programs.  new _inpe and
c        _oute subroutines would have to be written for each different
c        program though.
c
c  ppnum determines the name of the input and output files for parallel runs
c  reserved for future use
c
c     Called by:  qmmmghk
c
c     Calls:  g03inp, g03oute, g03outg, system
c
      use caltyp
      use files
      use input, only : cartgeom, mmvalen, qmmminf, maxoptl
      implicit none
c
c  i/o variables
c
      character*10 prognme
      character*20 esmeth, esbas, ver_lab                                                
      
      type (cartgeom) :: ssgeom
      type (mmvalen)  :: ssmmgeom   
      type (qmmminf)  :: qmmminp
      
c
      character*80 optl(maxoptl)
      double precision ener, grad(3*ssgeom%natoms)
      double precision hess(3*ssgeom%natoms,3*ssgeom%natoms)
      integer ierr, ppnum

      integer qmcharge, qmmult
      
c
c  GAUSSIAN03
c
c      if ((prognme(:3).eq.'g03') .or. (prognme(:3).eq.'g09')) then   !1222BW10 add g09
      if ((prognme(:3).eq.'g03') .or. (prognme(:3).eq.'g09')            1020XW17
     * .or. (prognme(:3).eq.'g16')) then                                1020XW17
         open (unit=g03inf, status='unknown', file=g03in, err=9993)
	 
         call g03stinp(g03inf, esmeth, esbas, 
     *      qmcharge, qmmult, ssgeom, 
     *      optl, thess, ver_lab, qmmminp, ssmmgeom)
         close (g03inf, err=9993)
         call system('g03shuttle g03.inp g03.out')

         call g03oute(1,esmeth, ener)
         call g03outg(1,esmeth, grad, ssgeom%natoms)                         
         call g03outh(esmeth, hess, ssgeom%natoms)                               
      endif
      return
c9993  write (outfile,*) 'Error creating Gaussian03 Forces input file'
9993  write (outfile,*) 'Error creating Gaussian Forces input file'     1020XW17
      stop 'progghk 3'
      end
c
c
c******************************************************************************
c  MTOLTM0
c******************************************************************************
c
      subroutine mtoltm0( dim, matrix, ltmat)
c
c     Subroutine mtoltm
c
c     Created:  Feb 22, 2004 by Hai Lin
c     Revised:  
c     Purpose:  To convert a 2 dimensional array matrix to a 1 dimensional
c        array ltmat containing only the lower triangular elements of 
c        matrix.
c
c     Called by:  qmmmhsumm, qmmmhhk
c     Calls:
c    
      use files, only : outfile
      implicit none
c
c  i/o variables
c
      integer  dim
      double precision  matrix(dim,dim), ltmat(dim*(dim+1)/2)
c
c  local variables
c
      integer  i, j, ctr
      
      ctr = 0
      do 20 i=1, dim
         do 40 j=1, i
            ctr = ctr + 1
            ltmat(ctr) = matrix(i,j)
  40     continue
  20  continue
      if (ctr .ne. dim*(dim+1)/2) then
         write(outfile,*) 'ERROR: Problem in MTOLTM'
      endif
      return
      end

