c**********************************************************************
c readln
c**********************************************************************
c
      subroutine readln(iunit,word,nword,isec,ieof,iscend)
c
c     Created:  Feb 22. 2004 by Hai Lin
c
c     Revised: 
c
c     This subroutine finds the first non-comment and non-blank line
c     from the input file (iunit), 
c     where each line has at most 80 characters,
c     and chop the line into words according to the space locations.
c
c     It returns the number of the words in (nword), and the individual 
c     word in array (word) after changing to upper case.
c
c     The flags are also set 
c        if it is beginning of a section (isec), 
c     or if it is end of the file (ieof)
c     or if it is end of the section (iscend).
c
      implicit none
c
c  i/o variables
c
      integer  iunit, nword
      integer  ieof, isec, iscend
c
      character*80  word(40)
c            
c  local variables
c
      integer  ip, icom, ibeg      
c
c      character*81  line, sename, string, upcse                        0808XW18      
      character*81  line, sename, string                                0808XW18
      character*80  upcse                                               0808XW18

c
      isec = 0
      ieof = 0
      iscend = 0
      nword = 0
c
10    read(iunit,'(a80)',end=500) string
c      
      ip = 0
c
c     find the first nonblank character in a line
c
20    ip = ip + 1
      if (string(ip:ip) .eq. ' ' .and. ip .le. 80) goto 20           
c
c     if it all blank or it is a comment line then read the next line
c
      if (ip .gt. 80 .or. string(ip:ip) .eq. '#')  goto 10
c
c     convert to uppercase
c
      line = upcse(string)
C
C     Find the position of a comment character, if any,
C     in a nonblank noncomment line
C
      icom = ip 
50    icom = icom + 1
c
      if (line(icom:icom) .ne. '#' .and. icom .le. 80)  goto 50         
C
55    if (ip .lt. icom) then
         ibeg = ip
60       ip = ip + 1
         if (line(ip:ip) .ne. ' ' .and. ip .lt. icom) goto 60 
         nword = nword + 1
         word(nword) = line(ibeg:ip-1)
70       ip = ip + 1
         if (line(ip:ip) .eq. ' ' .and. ip .lt. icom) goto 70
         goto 55
      endif
c
c
c     find the section name
c
      if (word(1)(1:1) .eq. '*') then
         sename = word(1)(2:)
         word(1) = sename
         isec = 1
      endif
c
c
c     find if section ends
c
      if (word(1)(1:3) .eq. 'END') then
         iscend = 1
      endif
c
      return
c
500   ieof = 1
c
      return
c
      end
c
c
c***************************************************************************
c upcse 
c***************************************************************************
c
      function upcse(string)
c      
c     Purpose:  consistent case
c     
c     Created:  Feb. 22, 2004 by Hai Lin
c
c     Revised: 
c
c     Description:  this function takes a string of 80 characters and
c                   converts all the lower case letters to upper case.
c
c     Called by: 
c     Calls:
C   Function which takes a string of 80 characters and converts the 
C   lower case letters in the string to upper case letters
C   This functions is a modified version of CASE which was written
C   by Rozeanne Steckler
C
      implicit none 
c
c  i/o variables
c
c
      character*80 string, upcse
c      
c  local variables
c
      integer  itry, i
      character*80 line
      character * 1 xlett
c
      line = string
      do 10 i = 1, 80
         xlett = line(i:i)
         itry = ichar (xlett)
         if (xlett .ge. 'a' .and. xlett .le. 'z') then 
            itry = itry - 32
            line(i:i) = char (itry)
         endif
10    continue
c
      upcse  = line 
c
      return
c
      end
c
c
c****************************************************************************
c  CASE
c****************************************************************************
c
      function case (string)
c
c     Function case
c
c     Created:  April 8, 1999 by P. L. Fast
c               This code was taken from Polyrate
c     Revised: 
c
c     Purpose:  consistent case
c
c     Description:  this function takes a string of 80 characters and
c                   converts all the upper case letters to lower case.
c
c     Called by: rline, chkln, g03oute
c     Calls:
c
c     Variables defined here: 
c
c
      implicit none
c
      integer  itry, i
c
      character*80 string, case
      character * 1 xlett
c
      do 10 i = 1, 80
        xlett = string(i:i)
        itry = ichar (xlett)
        if (xlett .ge. 'A' .and. xlett .le. 'Z') then
          itry = itry + 32
          string (i:i) = char (itry)
        endif
 10   continue
c
      case  = string
c
      return
      end
c
c
c****************************************************************************
c  RLINE
c****************************************************************************
c
      subroutine rline(iunitr,string,istrt,isect,iscend,iend)
c
c     Created:  April 8, 1999 by P. L. Fast
c               Taken from Polyrate
c     Revised:  June 18, 1999 by JMR
c                
c
c     This subroutine finds the first non-comment and non-blank line
c     and the location of the first character on that line.  The contents
c     of the line are placed in the variable string.  It will
c     then change it to all lower case using the routine 'case'.
c     A flag is set if the line is the start of a new section.
c
c     istrt:   location in 80 character string that is the first non-blank
c     isect:   a 1 is returned if the first non-blank character is a *
c              signalling the start of a section
c     iscend:  a 1 is returned if the line is 'end' signalling a section
c              end
c     iend:    a 1 is returned if the end of file 5 is encountered
c     string:  80 character string that is the contents of the current line
c
c     Called by: read5, rmlgen, rmlopt, rextopt, rgeom,
c            
c     Calls: fchar, chkln, case
c
      use files, only : outfile
      implicit none
c
      integer  iunitr, istrt, isect, iend, j, iblnk 
      integer  iscend, icommt
c
      character * 80 string, case
c
1000  format(A80)
c
c       initialize variables
c
      istrt = 1
      isect = 0
      iend = 0
      iblnk = 1
      iscend = 0
      icommt = 1
c
c     read in next line in iunitr - find first non-blank character  with
c     fchar and then check the line with chkln to see if it is a comment
c     line. Continue cycling through lines in infile until a non-blank,
c     non-comment line is found 
c
      do while ((iblnk .eq. 1) .and. (icommt .eq. 1))
         istrt=1
         read(iunitr,1000,end=9999) string
         call fchar(string, istrt, iblnk)
         if (iblnk .ne. 1) then
            call chkln(string, istrt, isect, icommt, iscend)
         endif
      end do
c
c     strip off any trailing comments on the line
c
c
      do 1 j=istrt,80
         if (string(j:j).eq.'#') then
            string(j:80) = ' '
c
c
            return
         endif
1     continue
c
c     change to lower case
c
      string = case(string)
      return
9999  iend=1
      return
      end
c
c
c*******************************************************************************
c  READ5
c*******************************************************************************
c
      subroutine read5( mlgeninp, progrms, mloptinp, extoptinp, 
     *      mcoptl, lqmmm, qmmminp, ltest, ltestmm, 
     *      ldynamic, dyninp,                                           0524SP10
     *      tmeth, tbas, toptl ) 
                                                                         
c
c     Subroutine read5
c
c     Created:  Feb. 21, 2005 by Hai Lin
c     Revised:  Aug. 28, 2006 by Yan Zhang
c               May  24, 2010 by Soroosh Pezeshki
c
c     Purpose:  read the input file
c
c     Description:  this subroutine is used to call additional subroutines
c                   to read the input file and return values for all
c                   parameters specified by the user.
c
c     Called by:  main
c     Calls: defprog, defgen, deftest, deftestmm,
c            rline, rmlgen,  
c            insumry, rextopt, rmlopt, rtest, rtestmm,
c            qmmmcutoff
c            rdynamics                                                  0524SP10
c
      use input
      use files, only : outfile, infile
      implicit none
c
c  i/o variables
c
      type (proglist):: progrms
      type (general) :: mlgeninp
      integer           lqmmm, ltest, ltestmm              
c
      character*80   :: mcoptl(maxoptl), toptl(maxoptl)
      character*20   :: tmeth, tbas
      type (qmmminf) :: qmmminp                                         
      type (extopt)  :: extoptinp
      type (mlopt)   :: mloptinp
c
c  add 5/24/2010 Soroosh Pezeshki
c
      integer :: ldynamic
      type (dynamicsinf) :: dyninp
c
c  end add 5/24/2010 Soroosh Pezeshki
c

c
c  local variables
c
      integer  istrt,isect,iend,j,iscend
c
      character*80  string      
c
c     initialize variables and set defaults
c
      call defprog( progrms )
      call defgen( mlgeninp, mloptinp, extoptinp ) 
      call defqmmm( qmmminp )                                           
      
      call deftest( ltest, tmeth, tbas, toptl )
      call deftestmm( ltestmm, tmeth, tbas, toptl)                      
c
c     read the first section of the input file
c
      call rline(infile,string,istrt,isect,iscend,iend)
      ldynamic=0                                                        0525SP10
      lqmmm=0                                                           0525SP10

c
c     check that the input file was not empty
c
      if (iend .eq. 1) then
        write (outfile,1000)
 1000   format (3x, 'Error:  input file was empty')
        flush (outfile)                                                 0713SP11
        stop 'read5  1'
      endif
c
c     check that the first line of the input file is a section header
c
      if (isect .ne. 1) then
         write (outfile,1100)
 1100    format (3x, 'Error:  the first line of the input file must',
     *               ' be a section header that begins with an *')
         flush (outfile)                                                0713SP11
         stop 'read5 2'
      endif
c
c     Call the correct subroutine to read the data in the section.
c     Control is returned back to this subroutine when another section
c     is found.  This loop will continue until the end of file is reached.
c
      j = 0
c
      do while (iend .eq. 0)
        j = istrt + 1      
        if (string(j:j+7) .eq. 'multigen') then
           call rmlgen (mlgeninp,string, iend, istrt)
        elseif (string(j:j+4) .eq. 'qm/mm') then                        
       call rqmmm(progrms, qmmminp, mlgeninp,                       
     *           string, iend, istrt)                          
           lqmmm = 1         
        elseif (string(j:j+5) .eq. 'testmm') then                       
           call rtestmm (progrms, tmeth, tbas, toptl,                   
     *           string, iend, istrt, mlgeninp)                         
           ltestmm = 1                                                  
        elseif (string(j:j+3) .eq. 'test') then
           call rtest (progrms, tmeth, tbas, toptl,
     *           string, iend, istrt)
           ltest = 1
        elseif (string(j:j+7) .eq. 'multiopt') then
           mlgeninp%lopt = 1
           call rmlopt(progrms, mloptinp, mlgeninp%geom%natoms,
     *                   string, istrt, iend )
        elseif (string(j:j+5) .eq. 'extopt') then
           mlgeninp%lextopt = 1
           call rextopt( progrms, extoptinp, string, istrt, iend )
c
c   add 5/24/2010 by Soroosh Pezeshki
c
        elseif (string(j:j+7) .eq. 'dynamics') then
           call rdynamics(dyninp,string, iend, istrt,
     *                mlgeninp%geom)
           ldynamic=1
c
c calculate the gradient at step 0
c
c           mlgeninp%lgrad = 1
c
c  end add 5/24/2010 by Soroosh Pezeshki
c
        else
c
           write (outfile,1200) string(j-1:80)
           flush (outfile)                                              0713SP11
           stop 'read5 3'
        endif
      enddo
c
 1200 format (3x, 'Error:  the following is not a valid section name: ',
     *            a)
c
c   add 8/28/2006 by Yan Zhang 
c
      call qmmmcutoff(mlgeninp,mlgeninp%geom,mlgeninp%mmgeom,qmmminp)
c
c   end 8/28/2006 by Yan Zhang 
c
c
      call insumry( mlgeninp, progrms, mloptinp, extoptinp, mcoptl, 
c     *      lqmmm, qmmminp, ltest, ltestmm,              
     *      lqmmm, qmmminp, ltest, ltestmm, ldynamic,dyninp,            0524SP10
     *      tmeth, tbas, toptl )                        
      return
      end
c 
c
c*******************************************************************************
c  DEFPROG
c*******************************************************************************
c
      subroutine defprog( progrms )
c
c     Created:  Feb 21, 2005 by Hai Lin
c
c     Purpose:  To set all the default programs called for different 
c        Multilevel calculations
c
c     Called by:  read5
c     Calls:
c
c     Variables defined here:
c
      use input, only : proglist
      use progdef
c
c  i/o variables
c
      type (proglist) :: progrms
c
      progrms%extoptprog = defextoptp
      progrms%testprog = deftestp
      progrms%hessprog = defhessp
      progrms%testmmprog = deftestmmp                                    
      progrms%qmprog = defqmp                                            
      progrms%mmprog = defmmp                                            
      return
      end
c
c
c*******************************************************************************
c  DEFGEN
c*******************************************************************************
c
      subroutine defgen( mlgeninp, mloptinp, extoptinp )
c
c     Created:  Feb. 21, 2005 by Hai Lin
c     Revised:  Aug. 21, 2006 by Yan Zhang
c               Dec. 12, 2006 by Yan zhang
c
c     Purpose:  To set all the default variables used in the multigen,
c         extopt, and multiopt sections
c
c               Also set debug flag (given in multigen section but
c               not stored it in multigen, rather it is stored in the 
c               common block /dodebug/ in module caltyp).
c
c     Description:  Lists all variables for the Multilevel keywords in
c         the Multigen section and defines those that have default values
c         or initializes them to zero.  All switch parameters are defined
c         as integers and assigned values 0 or 1.
c
c     Called by:  read5
c     Calls:
c
c     Variables defined here:
c
      use input, only : general, maxatm, mlopt, extopt, maxvalen,       
     *                  maxoptl, maxidnum, maxpart1stlay, maxpart2ndlay
      use param, only : nonlin, lowqmhs,mmhs
      use caltyp                                                        
      
      implicit none
c 
c  i/o variables
c
      type (general)  :: mlgeninp
      type (mlopt)    :: mloptinp
      type (extopt)   :: extoptinp
c
c  local variables
c
      integer i, j
c     
c -------------------------------------
c set defaults for switches
c -------------------------------------
c
c switch                   ml name
c ------                   -------
c ENERGY                   lener
c GRADIENT                 lgrad
c HESSIAN                  lhess
c EXTOPT                   lextopt
c MLOPT                    lopt
c PRSUM                    lprsum                                       
c MMVALEN                  lmmvalen                                     
c DEBUG                    tdebug
c
      mlgeninp%lener = 1
      mlgeninp%lgrad = 0
      mlgeninp%lhess = 0
c
c   add 2/10/2007 by Christoph Riplinger
c
c lhessType: type of hessian to be calculated: 0(none), 1(analytical), 2(numerical),
c                                              3(hybrid of QM hessian and estimated hessian),
c                                              4(estimated hessian: Almloef from orca)
c
      mlgeninp%lhessType = 0
c
c   end 2/10/2007 by Christoph 
c
      mlgeninp%lextopt = 0
      mlgeninp%lopt  = 0
      mlgeninp%lprsum = 1                                               
      mlgeninp%lmmvalen = 0                                             
      tdebug = 0
c
c -------------------------------------
c set defaults for variables
c -------------------------------------
c
c variable                 ml name
c --------                 -------
c NATOMS                   natoms
c TITLE                    mtitle
c CALMODEL                 calmodel                                    
c CHARGE                   charge
c MULTIPLICITY             mult
c GEOMUNIT                 geomunit
c GEOMTYPE                 geomtype
c GEOM                     geom
C MMGEOM                   mmgeom                                       
c EXTOPT                   extoptinp
c MLOPT                    mloptinp
c
c  No default for NATOMS.
c
c  TITLE is blank by default.
c
      do 10 i=1, 5
          mlgeninp%mtitle(i) = '   '
  10  continue
c
c  Cal Model is QM by default.
c
      mlgeninp%calmodel = 'QM'                                          
c
c  No special MM keywords (begin with '!') for primary or entire systems
c
      tcssmmkey = 0      
c
c  Charge and Multiplicity defaults
c
      mlgeninp%geom%charge = 0
      mlgeninp%geom%mult = 1
c
c  Default input geometry unit is angstroms.
c  Default input geometry format is cartesian.
c
      mlgeninp%geomunit = 1
      mlgeninp%geomtype = 0
c
c  Set 3-d geometry array to 0.
c  Set array of atoms to blanks and atomic mass array to 0.0
c
      do 30 i=1, 3*maxatm
         mlgeninp%geom%angcoord(i) = 0.0d0
  30  continue
      do 35 i=1, maxatm
         mlgeninp%geom%atm(i) = '  '
         mlgeninp%geom%atmmss(i) = 0.0d0 
 35   continue
c
c  Set MM geometry                                                      
c     Zero out the fields
c
      mlgeninp%mmgeom%lprnatmprm = 0
      do i=1, maxatm
         mlgeninp%mmgeom%atmcharge(i) = 0.0d0
         mlgeninp%mmgeom%atmid(i) = 0
         mlgeninp%mmgeom%atmtypname(i) = '    '
         mlgeninp%mmgeom%atmtyp(i) = 0
         mlgeninp%mmgeom%atmvalen(i) = 0
         do j=1, maxvalen
            mlgeninp%mmgeom%atmvalenlist(i,j) = 0
         enddo
      enddo	 
c
c  add 2/10/2007 by Christoph Riplinger
c  Set info on partial atoms 
c
      mlgeninp%part%pcharge    = 0      
      mlgeninp%part%pmult      = 1      
      mlgeninp%part%ipartcal   = 0      
      mlgeninp%part%partatmnum = 0      
      do i=1,maxidnum
         mlgeninp%part%partatmid(i) = 0
      end do
c
c   end 2/10/2007 by Christoph 
c 
c  EXTOPT
c     Set single-level external pre-optimization parameters
c
      extoptinp%mmconverg = 0.01                                        
      extoptinp%smmconverg = '  '                                       
      extoptinp%meth    = 'hf'
      extoptinp%bas     = '3-21g'
      do 50 i=1, maxoptl
c
         extoptinp%optl(i)(1:80) = ' '
  50  continue
c
c  MLOPT
c     Set Multilevel optimization parameters - in Atomic Units
c
c  NR optimization
c
      mloptinp%algrthm  = 0
c
c  Type of Hessian used = low level (usually HF)
c
      mloptinp%htyp = mmhs
      mloptinp%hmeth = 'hf             '
      mloptinp%hbas = '3-21g         '
      mloptinp%hscale = 1.0d-5
      mloptinp%ihunit = 1
c
c  Options                                                              
c      
      do i=1, maxoptl
c
         mloptinp%optl(i)(1:80) = ' ' 
      enddo	 
c
c  Return molecule to old orientation after optimization
c
      mloptinp%reorient = 1
c
c  Use the qmmm Method for multi-level optimization
c
      mloptinp%mlmeth   = 'qmmm '
c
c  Set molecule type to nonlinear minimum
c
      mloptinp%iop  = nonlin
c
c  Step size for 1st deriv of grad in geom optimization
c
      mloptinp%dlx2     = 1.0d-5
c
c  Max allowed grad component
c
      mloptinp%gcomp    = 1.0d-3
c
c  Max RMS step before Brent line minimization
c
      mloptinp%scale    = 1.0d0
c
c  'optimization failure' parameter
c
      mloptinp%stptol   = 1.0d-5
c
c  Recalc hessian every 10 steps
c
      mloptinp%hrec     = 10
c
c  Maximum of 50 optimization iterations
c
      mloptinp%niter    = 50
c
c  Don't switch to full Newton if original optimization fail
c
      mloptinp%retry    = 0
c
c  Use Brent line minimization                                          
c
      mloptinp%llinmn   = 1      
c
c  RMIN, RMAX, OMIN, DDMAX, DDMAXTS IUPD
c
 
       mloptinp%rmin    = 0.0d0                                         
       mloptinp%rmax    = 4.0d0                                         
       mloptinp%omin    = 0.8d0	                                        
       mloptinp%ddmax   = 0.5d0	                                        
       mloptinp%ddmaxts = 0.3d0                                         
       mloptinp%iupd    = 0
c
c  1st step is steepest descent
c
      mloptinp%sdstrt   = 1
c
c  Hold x1, y1, z1, y2, z2, z3 constant (since nonlin is default)
c
      do 57 i=1, 3*maxatm
         mloptinp%constant(i) = 0
  57  continue
      mloptinp%constant(1) = 1
      mloptinp%constant(2) = 1
      mloptinp%constant(3) = 1
      mloptinp%constant(5) = 1
      mloptinp%constant(6) = 1
      mloptinp%constant(9) = 1
c
c  partial atom add by Yan Zhang 8/21/2006
c
c
c   modified 2/10/2007 by Christoph Riplinger
c
      mloptinp%part%pcharge    = 0      
      mloptinp%part%pmult      = 1      
      mloptinp%part%ipartcal   = 0      
      mloptinp%part%partatmnum = 0      
      do i=1,maxidnum
         mloptinp%part%partatmid(i) = 0
      end do
c
c extend layer add by Yan Zhang 10/29/2007           
c
       mloptinp%part%extlayer1atmnum = 0
       mloptinp%part%extlayer2atmnum = 0
       mloptinp%part%extlayernum     = 1
       do i = 1,maxpart1stlay
         mloptinp%part%layer1atmid(i) = 0
       end do
       do i = 1,maxpart2ndlay
         mloptinp%part%layer2atmid(i) = 0
       end do

       mloptinp%part%partcentid = 0
       mloptinp%part%ipartcent  = 1
       mloptinp%part%ipartyp    = 1       
       mloptinp%part%initgpart  = 0
       mloptinp%part%partcentx  = 0.d0
       mloptinp%part%partcenty  = 0.d0
       mloptinp%part%partcentz  = 0.d0      
       mloptinp%part%partrad    = 999.d0                          
c
c end by Yan Zhang 10/29/2007 
c   end 2/10/2007 by Christoph 
c
c    end by Yan Zhang 8/21/2006
c
c set default values for lbfgs optimization added by Yan Zhang 12/12/2006
c
      mloptinp%rmsgrad  =  1.0d-2
      mloptinp%maxdx    =  4.0d-1
      mloptinp%rmsdx    =  2.0d-1
      mloptinp%minstep  =  1.0d-9
      mloptinp%maxstep  =  5.0d0
      mloptinp%cappa    =  0.9d0
      mloptinp%maxslope =  1.0d4
      mloptinp%maxang   =  1.8d2
      mloptinp%minenr   = -1.0d6
      mloptinp%intpolat =  5
c
c end by Yan zhang 12/12/2006
c
c set default values for the keyword frozeatm in the lbfgs optimization
c added by Yan Zhang 02/14/2008
c
      do i = 1, maxatm
         mloptinp%frozeatmid(i) = 0
      end do
      mloptinp%frozenatm = 0
c
c end by Yan Zhang 02/14/2008
c
      return
      end
c
c
c*******************************************************************************
c  DEFTEST
c*******************************************************************************
c     
      subroutine deftest(ltest, tmeth, tbas, toptl)
c
c     Created:  Feb. 21, 2005 by Hai Lin
c     Revised:
c     Purpose:  create default values for the test (QM) jobs
c
c     Called by:  read5
c     Calls:
c
      use input , only : maxoptl
      implicit none     
c 
c i/o variables
c
      integer       ltest
      character*20  tmeth, tbas
c
      character*80  toptl(maxoptl)
c
c local variables
c
      integer  i
c      
      ltest = 0
      tmeth = 'hf '
      tbas = '3-21g '
      do 20 i=1, maxoptl
         toptl(i) = '                               '
  20  continue
      return
      end
c 
c 
c*******************************************************************************
c DEFTESTMM
c*******************************************************************************
c
      subroutine deftestmm(ltestmm, tmeth, tbas, toptl)
c
c     Created:  Feb 22, 2004 by Hai Lin
c     Revised:
c     Purpose:  create default values for the MM test jobs
c
c     Called by:  read5
c     Calls:
c
      use input, only : maxoptl
      implicit none
c
c  i/o variables
c
      integer  ltestmm
      character*20  tmeth, tbas
c
      character*80  toptl(maxoptl)
c
c  local variables
c
      integer i
c      
      ltestmm = 0
      tmeth = 'mm  '
      tbas = 'n/a '
      do 20 i=1, maxoptl
         toptl(i) = '                               '
  20  continue
      return
      end
c
c
c*******************************************************************************
c  DEFQMMM
c*******************************************************************************
c 
      subroutine defqmmm(qmmminp)
c 
c     Created:  Feb 22, 2004 by Hai Lin
c     Revised:  Jul.21, 2006 by Yan Zhang
c               Aug. 7, 2006 by Yan Zhang
c               Aug.28, 2006 by Yan Zhang
c               Oct.24, 2007 by Yan Zhang
c               March 24, 2011 by Soroosh Pezeshki
c
c     Purpose:  create default values for the QMMM model
c
c     Called by:  read5
c     Calls:
c
      use input
      use caltyp
      use energy,   only : qmmmener, qmes, mmes
      use gradient, only : qmmmgrad, qmmmqmgr, qmmmmmgr
      use hessian,  only : qmmmhess, qmmmqmhs, qmmmmmhs, hessmaxatm                  
      implicit none
c 
c i/o variables
c
      type (qmmminf) :: qmmminp
            
c      
c local variables
c
      integer  i, j
c
c  Read point charge parameters
c
      tprm = 1      
c
c  Default values for border treatment 
c
      qmmminp%border = 'capatom '
      qmmminp%embed  = 'electric '
      qmmminp%bordercharge = 'redist3 '
c
c  Default values for methods and bases 
c
      qmmminp%qmmeth = 'hf '
      qmmminp%qmbas  = '3-21g '
      qmmminp%mmmeth = 'mm '
      qmmminp%mmbas  = 'n/a '
      do 41 i=1, maxoptl
c
         qmmminp%qmoptl(i)(1:80) = ' '
         qmmminp%mmoptl(i)(1:80) = ' '
  41  continue
c
c  Default values for QM atoms
c
      qmmminp%qmnatm = 0
      do i=1, maxatm
         qmmminp%qmatm(i) = 0
      enddo
c
c  Default values for MM atoms
c
      qmmminp%mmnatm = 0
      do i=1, maxatm
         qmmminp%mmatm(i) = 0
         qmmminp%mlist(i) = 0
         qmmminp%m3list(i) = 0
      enddo
c
c  Default values for cap atoms
c
      qmmminp%capatm%capnatm = 0
      qmmminp%capatm%capconstrain = 'scale'
      do 21 i=1, maxcapatm
         qmmminp%capatm%capatm(i) = 0
         qmmminp%capatm%capatmqm(i) = 0
         qmmminp%capatm%capatmm1(i) = 0
         qmmminp%capatm%capatmtyp(i) = 0
         qmmminp%capatm%capatmtypname(i) = '   '
         qmmminp%capatm%capbondscale(i) = 0.713d0
  21  continue
c
c  Default values for charge scale scheme: 0.00  0.00  0.00
c
      qmmminp%chscale%chargelay = 3
      qmmminp%chscale%chargescale(1) = 0.0d0
      do i=2, maxchargelay
         qmmminp%chscale%chargescale(i) = 0.0d0
      enddo
c
c  Deault values for MM 1st layer (the cap atom host)
c
      qmmminp%mm1stlay%natm1stlay = qmmminp%capatm%capnatm
      
      do i=1, max1stlay
         qmmminp%mm1stlay%atm1stlay(i) = 0
         qmmminp%mm1stlay%atm1stlayqm(i) = 0
         qmmminp%mm1stlay%atm1stlaym2num(i) = 0
         qmmminp%mm1stlay%atm1stlaym2(i,:maxvalen) = 0
         qmmminp%mm1stlay%atm1stlaycharge(i) = 0.0d0
      enddo
c
c  Deault values for MM 2nd layer (MM atoms bonded to MM 1st layer atoms)
c
      qmmminp%mm2ndlay%natm2ndlay = qmmminp%capatm%capnatm * 3
      
      do i=1, max2ndlay
         qmmminp%mm2ndlay%atm2ndlay(i) = 0
         qmmminp%mm2ndlay%atm2ndlaym1(i) = 0
         qmmminp%mm2ndlay%atm2ndlaycharge(i) = 0.0d0
      enddo
c
c  Deault values for MM 3rd layer (MM atoms bonded to MM 2nd layer atoms)
c
      qmmminp%mm3rdlay%natm3rdlay = qmmminp%capatm%capnatm * 3 * 3
      do i=1, max3rdlay
         qmmminp%mm3rdlay%atm3rdlay(i) = 0
         qmmminp%mm3rdlay%atm3rdlaym2(i) = 0
         qmmminp%mm3rdlay%atm3rdlaycharge(i) = 0.0d0
      enddo	 
c
c  Deafault values for charge redistribute (and shift) scheme
c
      qmmminp%chredist%nredist  = 0
      qmmminp%chredist%chposit  = 0.5d0
      qmmminp%chredist%dipposit = 0.5d0
      qmmminp%chredist%dipdist  = 0.2d0
            
      do i=1, maxredist
         qmmminp%chredist%m1(i)  = 0
         qmmminp%chredist%m2(i)  = 0
         qmmminp%chredist%q(i)  = 0.0d0
         qmmminp%chredist%qd(i) = 0.0d0
         qmmminp%chredist%x(i)  = 0.0d0
         qmmminp%chredist%y(i)  = 0.0d0
         qmmminp%chredist%z(i)  = 0.0d0
         qmmminp%chredist%mx(i) = 0.0d0
         qmmminp%chredist%my(i) = 0.0d0
         qmmminp%chredist%mz(i) = 0.0d0
         qmmminp%chredist%px(i) = 0.0d0
         qmmminp%chredist%py(i) = 0.0d0
         qmmminp%chredist%pz(i) = 0.0d0
         qmmminp%chredist%qb(i)  = 0.0d0   !1123BW08  balanced charge
         qmmminp%chredist%qc(i)  = 0.0d0   !1123BW08
         qmmminp%chredist%qd2(i) = 0.0d0   !0220BW09  balanced dipole
      enddo
c
c  Intiaialize the energy, gradient, and hessian
c     Check the value of module.F:hessian:maxatm
c
      qmmmener  = 0.0d0
      qmes(1)   = 0.0d0
      mmes(:3) = 0.0d0
      
      i = maxatm*3
      qmmmgrad(:i)    = 0.0d0
      qmmmqmgr(:i)    = 0.0d0
      qmmmmmgr(:3,:i) = 0.0d0
c
c modified by Yan zhang 11/11/2007
c      hessmaxatm = 50
c end by Yan zhang 11/1/2007
c
      i = hessmaxatm*3
      qmmmhess(:i,:i)    = 0.0d0
      qmmmqmhs(:i,:i)    = 0.0d0
      qmmmmmhs(:3,:i,:i) = 0.0d0
                  
c
c     add 7/21/2006 by Yan Zhang
c
      qmmminp%qmcharge = 0
      qmmminp%qmmult = 1
c
c	 end 7/21/2006 by Yan Zhang
c  Default values of the polarized calculation 8/7/2006 by Yan Zhang
c
      qmmminp%polmeth   = 'none '
      qmmminp%polmpot   = 'uq0'
      do i=1, 103
c
         qmmminp%polparal(i)(1:80) = ' '
      end do
      qmmminp%polmaxdq = 5.0d-3
      qmmminp%polrmsdq = 2.0d-3
      qmmminp%polgnum  = 0
      qmmminp%polcycl  = 30


      do i=1,maxpolgnum
        qmmminp%polgidnum(i)  = 0
        do j= 1,maxpolgidnum 
          qmmminp%polgid(i,j) = 0
        end do
      end do
c
c     end 8/7/2006 by Yan Zhang
c  Default values for QMMMCUTOFF add 8/28/2006 by Yan Zhang 
c
      qmmminp%lcutoff        = 0
      qmmminp%ccutoffid      = 0
      qmmminp%selcent        = 2
      qmmminp%cutoffcoor(1)  = 0.d0
      qmmminp%cutoffcoor(2)  = 0.d0
      qmmminp%cutoffcoor(3)  = 0.d0
      qmmminp%rcutoff        = 999.d0
      
      do i=1,maxatm
        qmmminp%cutoffatm(i) = 0
      end do
c
c   end 8/28/2006 by Yan Zhang 
c
c   add by Bo Wang 0203BW15 
c   Default value for screened charge and smeared chargeschemes
      qmmminp%ldampchg       = 0
      qmmminp%lambda          = 1.0
      qmmminp%ngto1          = 3
      qmmminp%ngto2          = 6
      qmmminp%dampnatm       = 0
c   Default value for the link atom
      qmmminp%lchgcorr       = 0
      qmmminp%lppf           = 0
c   Defaut value for whether MM charges are read in from QMMM input
c      only used when MMFF94 force field is used
      qmmminp%lrdmmchg       = 0
c    Default value for groups for charge balancing
      qmmminp%lchgbal  = 0
      qmmminp%nbalgroup = 0
c end by Bo Wang 0203BW15 
c
c Add by Yan zhang 9/04/2007
c Flexible-boundary default value.
c
      qmmminp%iflexbound = 0
      qmmminp%asqmcharge = 0 
      qmmminp%asqmmult   = 1 
      qmmminp%maxfbcycl  = 30 
      qmmminp%maxfbdq    = 5.0d-3 
      qmmminp%rmsfbdq    = 2.0d-3
      qmmminp%maxfbdqtot = 2.0d-2
      qmmminp%temprt     = -1.d0 
      qmmminp%fbccmeth   = 'qeqrg'
      qmmminp%fbgid      = 1 
      qmmminp%fbgnum     = 1 

      do i=1,maxgnum
        qmmminp%fbgan(i) = 0
        do j= 1,maxganum 
          qmmminp%fbgaid(i,j) = 0
        end do
      end do
      do i=1,103
         qmmminp%sscp(i) = '  '
      end do 
c
c  
c Chang charges model defaut in the MM calculation of background 
c charges interaction.
c
      qmmminp%modmmcharg = 1
c
c
c  End by Yan Zhang 09/04/2007
c
      return
      end
c
c
c*******************************************************************************
c  RTEST
c*******************************************************************************
c
      subroutine rtest( progrms, tmeth, tbas, toptl, 
     *     string, iend, istrt )
c
c     Created:  August 5, 1999 by J.M. Rodgers
c     Revised:
c     Purpose:  read the TEST
c
c     Called by:  read5
c     Calls:  rline, rlist, rvar
c
      use files, only : outfile, infile
      use input, only : proglist, maxoptl
      implicit none
c
      integer istrt, ierr, iend, isect, icint, iscend
c
      character*80  string, toptl(maxoptl)
      character*20  rvar, tbas, tmeth
      type (proglist) :: progrms
      call rline(infile,string,istrt,isect,iscend,iend)
c
c loop through the keywords of this section until the end of the
c section is reached.
c
      do while (isect.eq.0 .and. iend.eq.0 .and. iscend.eq.0)
         if (string(istrt:istrt+5).eq.'method') then
            tmeth = rvar(string,istrt,'TEST:METHOD')
         elseif (string(istrt:istrt+4).eq.'basis') then
            tbas = rvar(string,istrt,'TEST:BASIS')
         elseif (string(istrt:istrt+6).eq.'options') then
            call rlist(toptl, 'TEST:OPTIONS', iend )
         elseif (string(istrt:istrt+6).eq.'program') then
            progrms%testprog = rvar(string,istrt,'TEST:PROGRAM')
c
c    3/28/2006 by Yan Zhang
c
            if (  (string(istrt:istrt+2) .ne. 'g03').and.
     $            (string(istrt:istrt+2) .ne. 'g09').and.    !1222BW10 add the keyword g09
     $            (string(istrt:istrt+2) .ne. 'g16').and.               1020XW17
     $        (string(istrt:istrt+4) .ne. 'orca').and.
     $          (string(istrt:istrt+5) .ne. 'gamess')) then                   
               write (outfile,500)
c  500          format(3x, 'ERROR: G03, GAMESS and ORCA are ',
  500          format(3x, 'ERROR: Gaussian, GAMESS and ORCA are ',      1020XW17
     *                 'the allowed PROGRAMs for this ',
     *                 'version of QMMM')
               stop 'rtest 2' 
            endif
c
c        end 3/28/2006 by Yan Zhang
c
 
c
c  07/01/2011 by Soroosh Pezeshki
c
c
c comments
c
         elseif (string(istrt:istrt) .eq. ' ') then
            string=string
c
c end 07/01/2011 by Soroosh Pezeshki
c
         else
c
            write (outfile,1000) string(istrt:80)
            stop 'rtest 1'
 1000      format(3x,'ERROR: the following is not a valid keyword in ',
     *               'the TEST section: ',a)
         endif
c
         call rline(infile,string,istrt,isect,iscend,iend)
c
      enddo

      call settsemiempirical(tmeth)                                     0311SP11

      return
      end

c
c
c*******************************************************************************
c  RTESTMM
c*******************************************************************************
c
      subroutine rtestmm( progrms, tmeth, tbas, toptl, 
     *     string, iend, istrt, mlgeninp )
c
c     Created:  Feb. 22, 2004 by Hai Lin
c     Revised:  July 01, 2011 by Soroosh Pezeshki
c     Purpose:  read the TESTMM section
c
c     Called by:  read5
c     Calls:  rline, rlist, rvar
c
c     Note: Basis is the force field.
c           Method is mm.
c
      use files, only : outfile, infile
      use input, only : proglist, general, maxoptl
      implicit none
c
c  i/o variables
c      
      integer       istrt, iend
c
      character*80  string, toptl(maxoptl)
      character*20  tbas, tmeth
      type (proglist) :: progrms
      type (general)  :: mlgeninp
c
c  local variables
c
      integer       ierr, isect, icint, iscend
      character*20  rvar
c                  
      call rline(infile,string,istrt,isect,iscend,iend)
c
c loop through the keywords of this section until the end of the
c section is reached.
c
      do while (isect.eq.0 .and. iend.eq.0 .and. iscend.eq.0)
         if (string(istrt:istrt+6).eq.'version') then
            tmeth = rvar(string,istrt,'TESTMM:METHOD')
         elseif (string(istrt:istrt+9).eq.'forcefield') then
            tbas = rvar(string,istrt,'TESTMM:BASIS')
         elseif (string(istrt:istrt+6).eq.'options') then
            call rlist(toptl, 'TESTMM:OPTIONS', iend )
         elseif (string(istrt:istrt+6).eq.'program') then
            progrms%testmmprog = rvar(string,istrt,'TESTMM:PROGRAM')
c	    
c 
c
            if (string(istrt:istrt+5) .ne. 'tinker') then               
               write (outfile,500)
  500          format(3x, 'ERROR: TINKER is ',
     *                 'the only allowed PROGRAM for this ',
     *                 'version of QMMM')
               stop 'rtestmm 2' 
            endif
 
c
c  07/01/2011 by Soroosh Pezeshki
c
c
c comments
c
         elseif (string(istrt:istrt) .eq. ' ') then
            string=string
c
c end 07/01/2011 by Soroosh Pezeshki
c

c	    
c 
c
         else
c
            write (outfile,1000) string(istrt:80)
            stop 'rtest 1'
 1000      format(3x,'ERROR: the following is not a valid keyword in ',
     *               'the TESTMM section: ',a)
         endif
c
         call rline(infile,string,istrt,isect,iscend,iend)
c
      enddo
      return
      end
c
c
c*******************************************************************************
c  RQMMM
c*******************************************************************************
c
      subroutine rqmmm( progrms, qmmminp, mlginp, 
     *           string, iend, istrt )
c
c     Created:  Feb 22, 2004 by Hai Lin
c     Revised:  Jul.21, 2006 by Yan Zhang
c               Aug. 7, 2006 by Yan Zhang
c               Aug.28, 2006 bu Yan Zhang
c               Oct.27, 2006 by Yan Zhang
c               Nov. 7, 2006 by Yan Zhang
c               Oct.24, 2007 by Yan Zhang
c               March 24, 2011 by Soroosh Pezeshki
c
c
c     Purpose:  read the QM/MM section of the input file
c
c     Called by:  read5
c     Calls:  rline, rlist, readln
c
      use input
      use files, only : outfile, infile
      use hessian,  only : hessmaxatm
      implicit none
c
c i/o variable
c 
      integer istrt, iend 
      character*80  string
      type (qmmminf)  :: qmmminp
      type (general)  :: mlginp
      type (proglist) :: progrms
c
c local variable
c
      integer       ierr, isect, icint
      integer       iscend, iscend2, iscend3
      integer       natoms, i, j, k, m, ii, jj, kk, mm, temp
      integer       t1, t2, t3, m2, m3, idpolg
      integer       gid, fbg, fbidn
      character*20  rvar
      
      integer nwords, length
      integer ieof, isec
      integer  polidn(maxpolgidnum), fbgaid(maxganum)
      character*80  words(40)      
      double precision cfloat
      double precision mindist, dist

      integer       qmtag   !1029BW09 a tag to check whether QM host atom is in QM atom list
      integer       id      !0126BW12 the id of atom in the balancing step 

c
c modified by Yan zhang 11/1/2007
c      integer, parameter :: hessmaxatm = 50
c end by Yan zhang 11/1/2007                 
c
      integer iqmc, iqmm
c
c    set iqmc and iqmm
c
      iqmc=0
      iqmm=0
c
c  please check the value of module.F:hessian:maxatm
c      
      idpolg=0
      fbg   =0
c start ...
c
      natoms = mlginp%mmgeom%natoms
      call rline(infile,string,istrt,isect,iscend,iend)
c  
c loop through the keywords of this section until the end of the
c section is reached.
c
      do while (isect.eq.0 .and. iend.eq.0 .and. iscend.eq.0)
c
c  Border  
c      
         if (string(istrt:istrt+9).eq.'bordertype') then
            qmmminp%border = rvar(string,istrt,'QMMM:BORDER')
c
c  Embed
c
         elseif (string(istrt:istrt+4).eq.'embed') then
            qmmminp%embed = rvar(string,istrt,'QMMM:EMBED')
            if(qmmminp%embed .ne. 'mechanical' .and.
     *         qmmminp%embed .ne. 'electric') then
               write(outfile,150)
150            format('Error: Only mechanical and electric',
     *            'embedding schemes are allowed.')
               stop 'rqmmm 8'
            endif   
c
c  Bordercharge
c
         elseif (string(istrt:istrt+11).eq.'bordercharge') then
            qmmminp%bordercharge = 
     *          rvar(string,istrt,'QMMM:BORDERCHARGE')
            if(qmmminp%bordercharge .ne. 'scale'   .and.
     *         qmmminp%bordercharge .ne. 'shift'   .and.
     *         qmmminp%bordercharge .ne. 'rc'      .and.
     *         qmmminp%bordercharge .ne. 'rcd'     .and.
     *         qmmminp%bordercharge .ne. 'rcd2'    .and.
     *         qmmminp%bordercharge .ne. 'redist1' .and.
     *         qmmminp%bordercharge .ne. 'redist2' .and. 
     *         qmmminp%bordercharge .ne. 'redist3' .and.
c add by Bo Wang 0203BW15
     *         qmmminp%bordercharge .ne. 'rcbal'   .and.
     *         qmmminp%bordercharge .ne. 'rcbal2'  .and.
     *         qmmminp%bordercharge .ne. 'rcbal3'  .and.
     *         qmmminp%bordercharge .ne. 'amber2'  .and.
     *         qmmminp%bordercharge .ne. 'rcdbal'  .and.
     *         qmmminp%bordercharge .ne. 'seebal'  .and.
     *         qmmminp%bordercharge .ne. 'shiftbal'  .and.
     *         qmmminp%bordercharge .ne. 'shiftbal2' .and. 
     *         qmmminp%bordercharge .ne. 'amber1')    then     
c end by Bo Wang 0205BW15
               write(outfile,160)
160            format('Error: Unsupported bordercharge treatment')
               stop 'rqmmm 9'
            endif	    	            	                      	    

c  add by Bo Wang 0203BW15 
c  Charge balancing step
c  add the constraints for the balanced M1 charges
c  make sure the total charge of the system and the
c  charges of parts of systems are conserved.
c  the sequence of the groups should be the same as the
c  sequece of M1 atoms.
c  The format is: total_charge M1_atom other atoms in the group
c
         elseif (string(istrt:istrt+8).eq.'balgroup') then
            qmmminp%lchgbal = 1
            qmmminp%nbalgroup = qmmminp%nbalgroup + 1
            qmmminp%groupchg(qmmminp%nbalgroup)
     &                 = cfloat(rvar(string, istrt, 'BALGROUP'))
            call readln(infile,words,nwords,isec,ieof,iscend2)
            j = 0
            do while (iscend2.eq.0.and.isect.eq.0.and.iend.eq.0)
               j = j + 1
               jj = icint(words(1))
               if ((jj .le. 0) .or. (jj .gt. natoms)) then
                  write(outfile,*) 'Error: Invalid MM atom:',jj
                  stop 'rqmmm 7'
               endif
               qmmminp%balgroup(qmmminp%nbalgroup,j)=jj
               call readln(infile,words,nwords,isec,ieof,iscend2)
            enddo
            qmmminp%balgroupn(qmmminp%nbalgroup) = j
c
c Screened and Smeared charge schemes
c
         elseif (string(istrt:istrt+6).eq.'dampchg') then  ! whether use sreened or smeared charge schemes
             qmmminp%ldampchg = icint(rvar(string, istrt, 'DAMPCHG'))
c
c Specify  the screened MM atoms
c
        elseif (string(istrt:istrt+7).eq.'dampatom') then
            call readln(infile,words,nwords,isec,ieof,iscend2)
            j = 0
            do while (iscend2.eq.0.and.isect.eq.0.and.iend.eq.0)
               j = j + 1
               jj = icint(words(1))
               if ((jj .le. 0) .or. (jj .gt. natoms)) then
                  write(outfile,*) 'Error: Invalid MM atom:',jj
                  stop 'rqmmm 7'
               endif
               if (nwords .eq. 1) then
                 qmmminp%dampatm(j)=jj
                 qmmminp%dampzeta(j)=-1.0
                 qmmminp%dampval(j)=-1.0
                 qmmminp%dampchg(j)=999.0
                 call readln(infile,words,nwords,isec,ieof,iscend2)
               elseif (nwords .eq. 3) then
                 qmmminp%dampatm(j)=jj
                 qmmminp%dampzeta(j)=cfloat(words(2))
                 qmmminp%dampval(j)=cfloat(words(3))
                 qmmminp%dampchg(j)=999.0
                 call readln(infile,words,nwords,isec,ieof,iscend2)
               elseif (nwords .eq. 4) then
                 qmmminp%dampatm(j)=jj
                 qmmminp%dampzeta(j)=cfloat(words(2))
                 qmmminp%dampval(j)=cfloat(words(3))
                 qmmminp%dampchg(j)=cfloat(words(4))
                 call readln(infile,words,nwords,isec,ieof,iscend2)
               else
                   write(outfile,165) j
165                  format(/3x,'ERROR: Too many info  for the '
     *                 ,i4,'-th MM atom.')
                     stop 'rqmmm 1'
               endif
            enddo
            qmmminp%dampnatm = j

         elseif (string(istrt:istrt+5).eq. 'lambda') then    !  the smearing width for the redistributed charges
             qmmminp%lambda = cfloat(rvar(string, istrt, 'LAMBDA')  )

         elseif (string(istrt:istrt+4).eq.'ngto1') then    !  number of GTO is used to expand STO for screened MM atom
             qmmminp%ngto1 = icint(rvar(string, istrt, 'NGTO1'))
             if (qmmminp%ngto1 .ne. 3 .and. qmmminp%ngto1 .ne. 6
     &         .and. qmmminp%ngto1 .ne. 9 .and. qmmminp%ngto1 .ne.12
     &         .and. qmmminp%ngto1 .ne. 15) then
               write(outfile,161)
161            format('Error: number of GTO1 is not supported yet!')
               stop 'rqmmm'
             endif

        elseif (string(istrt:istrt+4).eq.'ngto2') then     ! number of GTO to expand STO for the smeared redistributed charges
             qmmminp%ngto2 = icint(rvar(string, istrt, 'NGTO2'))
             if (qmmminp%ngto2 .ne. 3 .and. qmmminp%ngto2 .ne. 6
     &         .and. qmmminp%ngto2 .ne. 9 .and. qmmminp%ngto2 .ne.12
     &         .and. qmmminp%ngto2 .ne. 15) then
               write(outfile,162)
162            format('Error: number of GTO2 is not supported yet!')
               stop 'rqmmm'
             endif

         elseif (string(istrt:istrt+6).eq.'chgcorr') then   ! wheter to use balanced M1 charges in MM part in QMMM calculations
             qmmminp%lchgcorr = 1
         elseif (string(istrt:istrt+8).eq.'nochgcorr') then
             qmmminp%lchgcorr = 0

         elseif (string(istrt:istrt+6).eq.'pseudof') then   ! whether to use pseduo F atom as link atom
             qmmminp%lppf = 1
         elseif (string(istrt:istrt+8).eq.'nopseudof') then
             qmmminp%lppf = 0
c
        elseif (string(istrt:istrt+8).eq.'readmmchg') then  !whether read the MM charges from the QMMM .dat file
             qmmminp%lrdmmchg = 1                           !needed only for MMFF94 and MM charges are read from input
        elseif (string(istrt:istrt+10).eq.'noreadmmchg') then
             qmmminp%lrdmmchg = 0
c
c Cap atom constrain
c
         elseif (string(istrt:istrt+11).eq.'capconstrain') then
            qmmminp%capatm%capconstrain
     *                   = rvar(string,istrt,'QMMM:CONSTRAIN')
            if(qmmminp%capatm%capconstrain .ne. 'scale' .and.
     *         qmmminp%capatm%capconstrain .ne. 'fix') then
               write(outfile,170)
170            format('Error: Only scaled and fixed capped atom',
     *            ' schemes are allowed.')
               stop 'rqmmm 10'
            endif
c  end by Bo Wang 0203BW15 


c
c  Charge scale
c
         elseif (string(istrt:istrt+10).eq.'chargelayer') then
            qmmminp%chscale%chargelay = 
     *       icint(rvar(string,istrt,'QMMM:CHARGELAYER'))
         elseif (string(istrt:istrt+10).eq.'chargescale') then
            call readln(infile,words,nwords,isec,ieof,iscend2)
            j = 0
            do while (iscend2.eq.0.and.isect.eq.0.and.iend.eq.0)
               j = j + 1			    
               if (j .gt. maxchargelay) then
                  write(outfile,200)
200               format(/3x,'Error: too many charge layers!')
                  stop 'rqmmm 7'
               endif
               qmmminp%chscale%chargescale(j)=cfloat(words(1))
               call readln(infile,words,nwords,isec,ieof,iscend2)
            enddo
c
c  Charge redistribution/shift  and dipole 
c
         elseif (string(istrt:istrt+10).eq.'chargeposit') then
            qmmminp%chredist%chposit = 
     *	     cfloat(rvar(string,istrt,'QMMM:CHARGEPOSIT'))
         elseif (string(istrt:istrt+7).eq.'dipposit') then
            qmmminp%chredist%dipposit =
     *       cfloat(rvar(string,istrt,'QMMM:DIPPOSIT'))
         elseif (string(istrt:istrt+6).eq.'dipdist') then
            qmmminp%chredist%dipdist =
     *       cfloat(rvar(string,istrt,'QMMM:DIPDIST'))	 	    
c
c  QMatom
c
         elseif (string(istrt:istrt+5).eq.'qmatom') then
            call readln(infile,words,nwords,isec,ieof,iscend2) 
            j = 0
            do while (iscend2.eq.0.and.isect.eq.0.and.iend.eq.0)
               j = j + 1
               jj = icint(words(1))
               if ((jj .le. 0) .or. (jj .gt. natoms)) then
                  write(outfile,*) 'Error: Invalid QM atom:',jj
                  stop 'rqmmm 7'
               endif
               qmmminp%qmatm(j)=jj
               call readln(infile,words,nwords,isec,ieof,iscend2) 
            enddo
            qmmminp%qmnatm = j
c
c  Rearrange QM atoms
c	    
c	    natoms = qmmminp%qmnatm
c	    do i = 1, natoms
c	       do j = i, natoms
c	          if (qmmminp%qmatm(i) .gt. qmmminp%qmatm(j)) then
c		     temp = qmmminp%qmatm(i)
c		     qmmminp%qmatm(i) = qmmminp%qmatm(j)
c		     qmmminp%qmatm(j) = temp
c		  endif
c	       enddo	       
c	    enddo   
c            write(outfile,*) qmmminp%qmnatm
c            write(outfile,*) qmmminp%qmatm
c
c  add by Bo Wang 0203BW15 
c  Capatom
c   revise the input format of Capatom to allow wider applicability
c   for the use of link atoms
c    eg. one QM atom have
c        more than one link atom (the situation can be treated
c        in the original way, but the new way is more easy to read)
c    change "MM_host  link_type_name link_type scale_factor" to
c         "MM_host  QM_host link_type_name link_type scale_factor"
c    The old way to define link atom can still be used.
c
         elseif ((string(istrt:istrt+6).eq.'capatom').or.
     *      (string(istrt:istrt+7).eq.'linkatom')) then
            call readln(infile,words,nwords,isec,ieof,iscend2)
            j = 0
            do while (iscend2.eq.0.and.isect.eq.0.and.iend.eq.0)
               j = j + 1
               if (nwords .lt. 4) then
                     write(outfile,250) j
250                  format(/3x,'ERROR: More info needed for the '
     *                 ,i4,'-th Cap atom.')
                     stop 'rqmmm 1'
cx             endif
c
c original way to define the link atom
c
               elseif (nwords .eq. 4) then
                 jj = icint(words(1))
                 if ((jj .le. 0) .or. (jj .gt. natoms)) then
                    write(outfile,*) 'Error: Invalid Cap atom:',jj
                    stop 'rqmmm 8'
                 endif
                 qmmminp%capatm%capatm(j)=jj
                 qmmminp%capatm%capatmtypname(j)=words(2)
                 qmmminp%capatm%capatmtyp(j)=icint(words(3))
cx                 qmmminp%capatm%capbondscale(j)=cfloat(words(4))
                 if (qmmminp%capatm%capconstrain .eq. 'scale') then
                   qmmminp%capatm%capbondscale(j)=cfloat(words(4))
                 elseif (qmmminp%capatm%capconstrain .eq. 'fix') then
                   qmmminp%capatm%capbondfix(j)=cfloat(words(4))
                 endif
                 do ii=1, qmmminp%qmnatm
                    if (qmmminp%capatm%capatm(j) .eq.
     *                  qmmminp%qmatm(ii)) then
                       write(outfile,300) qmmminp%qmatm(ii)
300                    format(3x, 'ERROR: Cap atom = QM atom:', i4)
                       stop 'rqmmm 1'
                    endif
                 enddo
c
c new way to define the link atom
c
               elseif (nwords .eq. 5) then
                 jj = icint(words(1))
                 kk = icint(words(2))
                 if ((jj .le. 0) .or. (jj .gt. natoms) .or.
     *              (kk .le. 0) .or. (kk .gt. natoms)) then
                   write(outfile,*) 'Error: Invalid Cap atom:',jj
                   stop 'rqmmm 8'
                 endif
                 qmmminp%capatm%capatm(j)=jj
                 qmmminp%capatm%capatmqm(j)=kk
                 qmmminp%capatm%capatmtypname(j)=words(3)
                 qmmminp%capatm%capatmtyp(j)=icint(words(4))
                 if (qmmminp%capatm%capconstrain .eq. 'scale') then
                   qmmminp%capatm%capbondscale(j)=cfloat(words(5))
                 elseif (qmmminp%capatm%capconstrain .eq. 'fix') then
                   qmmminp%capatm%capbondfix(j)=cfloat(words(5))
                 endif
                 do ii=1, qmmminp%qmnatm
                   if (qmmminp%capatm%capatm(j) .eq.
     *                      qmmminp%qmatm(ii)) then
                     write(outfile,300) qmmminp%qmatm(ii)
                     stop 'rqmmm 1'
                   endif
                 enddo
                 do ii=1, qmmminp%mmnatm
                   if (qmmminp%capatm%capatmqm(j) .eq.
     *                      qmmminp%mmatm(ii)) then
                     write(outfile,310) qmmminp%mmatm(ii)
310                  format(3x, 'ERROR: QM host atom = MM atom:', i4)
                     stop 'rqmmm 1'
                   endif
                 enddo
               else
                 write (outfile,320) j
320              format (/3x,'ERROR:Less info needed for the'
     *                   ,i4, '-th Cap atom.')
               endif
               call readln(infile,words,nwords,isec,ieof,iscend2)
            enddo
            qmmminp%capatm%capnatm = j
c end by Bo Wang 0203BW15 

c
c QMKEY
c
         elseif (string(istrt:istrt+4) .eq. 'qmkey') then
c
c read first line of qmkey
c 
            call rline(infile,string,istrt,isect,iscend2,iend)
            do while (iscend2.eq.0.and.isect.eq.0.and.iend.eq.0)
c
c QMKEY:METHOD
c
               if (string(istrt:istrt+5) .eq. 'method') then
                  qmmminp%qmmeth = rvar(string, istrt, 'QMKEY:METHOD')
c
c QMKEY:BASIS
c
               elseif (string(istrt:istrt+4) .eq. 'basis') then
                  qmmminp%qmbas = rvar(string, istrt, 'QMKEY:BASIS')
c
c    7/21/2006 by Yan Zhang
c QMKEY:CHARGE
c
               elseif (string(istrt:istrt+5) .eq. 'charge') then
                  qmmminp%qmcharge =
     &                  icint(rvar(string,istrt,'QMKEY:CHARGE'))
                  iqmc=1
c
c QMKEY:MULTIPLICITY
c
               elseif (string(istrt:istrt+11) .eq. 'multiplicity') then
                  qmmminp%qmmult =
     &                  icint(rvar(string, istrt,'QMKEY:MULTIPLICITY'))
                 iqmm=1
c
c   end 7/21/2006 by Yan Zhang
c
c QMKEY:PROGRAM
c
               elseif (string(istrt:istrt+6) .eq. 'program') then
                  progrms%qmprog = rvar(string, istrt, 
     *                   'QMKEY:PROGRAM')
c
c	 3/28/2006
c
            if (  (string(istrt:istrt+2) .ne. 'g03').and.
     $            (string(istrt:istrt+2) .ne. 'g09').and.  !1222BW10
     $            (string(istrt:istrt+2) .ne. 'g16').and.               1020XW17
     $          (string(istrt:istrt+4) .ne. 'orca').and.
     $          (string(istrt:istrt+5) .ne. 'gamess')) then                   
               write (outfile,500)
c  500          format(3x, 'ERROR: G03, GAMESS and ORCA are ',
  500          format(3x, 'ERROR: Gaussian, GAMESS and ORCA are ',      1020XW17
     *                 'the allowed PROGRAMs for this ',
     *                 'version of QMMM')
               stop 'rqmmm 2' 
            endif
c
c
c              
c QMKEY:OPTIONS
c              
               elseif (string(istrt:istrt+6) .eq. 'options') then
                  call rlist(qmmminp%qmoptl, 'QMKEY:OPTIONS', iend )
               else
c
                  write (outfile,1100) string(istrt:80)
1100              format(/3x,'ERROR: the following is not a valid ',
     *                   'option of the QMKEY keyword: ', a)
                  stop 'rqmmm 3'
               endif
               call rline(infile,string,istrt,isect,iscend2,iend)
            enddo
c
c
c     8/7/2006 by Yan Zhang
c
c     POLAR
c
         elseif (string(istrt:istrt+4) .eq. 'polar') then
c
c read first line of POLAR
c 
            call rline(infile,string,istrt,isect,iscend2,iend)
            do while (iscend2.eq.0.and.isect.eq.0.and.iend.eq.0)
c
c POLAR: METHOD
c
               if (string(istrt:istrt+5) .eq. 'method') then
                  qmmminp%polmeth = rvar(string, istrt, 'POLAR:METHOD')

                   if (  (string(istrt:istrt+3) .ne. 'none').and.
     $          (string(istrt:istrt+4) .ne. 'qeqrg').and.
     $          (string(istrt:istrt+4) .ne. 'qeqbt').and.
     $          (string(istrt:istrt+2) .ne. 'eem')) then                   
                       write (outfile,*)'Error: the keyword in POLAR. '
                       stop
                   end if
c
c POLAR: MPOT
c
               elseif (string(istrt:istrt+3) .eq. 'mpot') then
                  qmmminp%polmpot = rvar(string, istrt, 'POLAR:MPOT')
c              
c POLAR:PARAMETER
c              
               elseif (string(istrt:istrt+8) .eq. 'parameter') then
                  call rlist(qmmminp%polparal, 'POLAR:PARAMETER', iend )
c
c POLAR: MAXDQ
c
               elseif (string(istrt:istrt+4).eq.'maxdq') then
                  qmmminp%polmaxdq= cfloat(rvar(string, 
     &                              istrt, 'POLAR:MAXDQ')) 
c
c POLAR: RMSDQ
c
               elseif (string(istrt:istrt+4).eq.'rmsdq') then
                  qmmminp%polrmsdq= cfloat(rvar(string, 
     &                              istrt, 'POLAR:RMSDQ')) 
c
c POLAR: GROUPNUM
c
               elseif (string(istrt:istrt+4).eq.'cycle') then
                  qmmminp%polcycl= icint(rvar(string, 
     &                              istrt, 'POLAR:CYCLE')) 
c
c POLAR: GROUPNUM
c
               elseif (string(istrt:istrt+7).eq.'groupnum') then
                  qmmminp%polgnum= icint(rvar(string, 
     &                              istrt, 'POLAR:RMSDQ')) 
c
c POLAR: GROUP
c
               elseif (string(istrt:istrt+4).eq.'group') then
                  idpolg=idpolg+1
                  call ridlist(polidn, 
     &                        qmmminp%polgidnum(idpolg), iend)
                  do i=1,	qmmminp%polgidnum(idpolg)
                     qmmminp%polgid(idpolg,i)=polidn(i)
                  end do
                  if(qmmminp%polgidnum(idpolg).gt.maxpolgidnum) then
                    write(outfile,*)' The total id number in a line',
     &                   'is larger the maximum permit number.',
     &                    qmmminp%polgidnum(idpolg)
                     stop 'rqmmm polar group 1'
                  elseif(qmmminp%polgidnum(idpolg).lt.2) then
                    write(outfile,*)' The total number in a group',
     &                   'is too little.',qmmminp%polgidnum(idpolg)
                     stop 'rqmmm polar group 2'
                  end if
               else
c
                  write (outfile,1101) string(istrt:80)
1101              format(/3x,'ERROR: the following is not a valid ',
     *                   'option of the POLAR keyword: ', a)
                  stop 'rqmmm 3 eeapc'
               endif
               call rline(infile,string,istrt,isect,iscend2,iend)
            enddo
c
c      end 8/7/2006 by Yan Zhang
c
c     QMMMCUTOFF  8/28/2006 by Yan Zhang
c
         elseif (string(istrt:istrt+9) .eq. 'qmmmcutoff') then

            qmmminp%lcutoff = 1

c
c read first line of QMMMCUTOFF
c 
            call rline(infile,string,istrt,isect,iscend2,iend)
            do while (iscend2.eq.0.and.isect.eq.0.and.iend.eq.0)
c
c QMMMCUTOFF: CUTOFFCENTID
c
                if (string(istrt:istrt+11) .eq. 'cutoffcentid') then
                     qmmminp%ccutoffid = 
     &	                 icint(rvar(string,istrt,'QMMM:CUTOFFCENTID'))
                     qmmminp%selcent = 1
c
c QMMMCUTOFF: CUTOFFCENTID
c
              elseif (string(istrt:istrt+12) .eq. 'cutoffcentxyz') then
                   qmmminp%cutoffcoor(1) = 
     &	            cfloat(rvar(string,istrt,'QMMM:CUTOFFCENTXYZ'))
                   qmmminp%cutoffcoor(2) = 
     &	            cfloat(rvar(string,istrt,'QMMM:CUTOFFCENTXYZ'))
                   qmmminp%cutoffcoor(3) = 
     &	            cfloat(rvar(string,istrt,'QMMM:CUTOFFCENTXYZ'))
                   qmmminp%selcent = 2
c
c QMMMCUTOFF: CUTOFFRADIS
c
                elseif (string(istrt:istrt+8) .eq. 'cutoffrad') then
                     qmmminp%rcutoff=
     &                     cfloat(rvar(string,istrt,'QMMM:CUTOFFRADIS')) 	    
                else
c
                  write (outfile,1102) string(istrt:80)
1102              format(/3x,'ERROR: the following is not a valid ',
     *                   'option of the QMMMCUTOFF keyword: ', a)
                  stop 'rqmmm qmmmcutoff'
               endif
               call rline(infile,string,istrt,isect,iscend2,iend)
            enddo
c
c      end 8/28/2006 by Yan Zhang
c

c MMKEY
c
         elseif (string(istrt:istrt+4) .eq. 'mmkey') then
c
c read first line of mmkey
c
            call rline(infile,string,istrt,isect,iscend3,iend)
            do while (iscend3.eq.0.and.isect.eq.0.and.iend.eq.0)
c
c MMKEY:METHOD
c
               if (string(istrt:istrt+6) .eq. 'version') then
                  qmmminp%mmmeth = rvar(string, istrt, 'MMKEY:METHOD')
c 
c MMKEY:FORCEFIELD  
c 
               elseif (string(istrt:istrt+9) .eq. 'forcefield') then 
                  qmmminp%mmbas = rvar(string, istrt, 'MMKEY:BASIS')  
c 
c MMKEY:PROGRAM
c 
               elseif (string(istrt:istrt+6) .eq. 'program') then 
                  progrms%mmprog = rvar(string, istrt, 
     *                      'MMKEY:PROGRAM')
                  if (string(istrt:istrt+5) .ne. 'tinker') then
                     write (outfile,600)
  600                format(3x, 'ERROR: Tinker is ',
     *                       'the only allowed PROGRAM for this ',
     *                       'version of QMMM')
                     stop 'rqmmm 4' 
                  endif
c
c MMKEY:OPTIONS
c
               elseif (string(istrt:istrt+6) .eq. 'options') then  
                  call rlist(qmmminp%mmoptl, 'MMKEY:OPTIONS', iend )
               else
c
                  write (outfile,1100) string(istrt:80)
1200              format(/3x,'ERROR: the following is not a valid ',
     *                   'option of the MMKEY keyword: ', a)
                  stop 'rqmmm 5'
               endif
               call rline(infile,string,istrt,isect,iscend3,iend)
            enddo
c
c
c Add by Yan zhang 9/04/2007
c
c Flexible-boundary
c
         elseif (string(istrt:istrt+8) .eq. 'flexbound') then
            qmmminp%iflexbound = 1
c
c Read first line of FLEXBOUND
c 
            call rline(infile,string,istrt,isect,iscend2,iend)
            do while (iscend2.eq.0.and.isect.eq.0.and.iend.eq.0)
c
c FLEXBOUND: Oxidized state (additional state) charge
c
               if (string(istrt:istrt+5) .eq. 'charge') then
                  qmmminp%asqmcharge = icint(rvar(string, 
     &                              istrt, 'FLEXBOUND:CHARGE')) 
c
c FLEXBOUND: Oxidized state (additional state) MULTIPLICITY.
c
               else if (string(istrt:istrt+3) .eq. 'mult') then
                  qmmminp%asqmmult = icint(rvar(string, 
     &                              istrt, 'FLEXBOUND:MULT')) 
c
c FLEXBOUND: MAXFBCYCL.
c
               else if (string(istrt:istrt+7) .eq. 'maxcycle') then
                  qmmminp%maxfbcycl = icint(rvar(string, 
     &                              istrt, 'FLEXBOUND:MAXCYCLE')) 
c
c FLEXBOUND: MAXDQ.
c
               elseif (string(istrt:istrt+4).eq.'maxdq') then
                  qmmminp%maxfbdq = cfloat(rvar(string, 
     &                              istrt, 'FLEXBOUND:MAXDQ')) 
c
c FLEXBOUND: RMSDQ.
c
               elseif (string(istrt:istrt+4).eq.'rmsdq') then
                  qmmminp%rmsfbdq = cfloat(rvar(string, 
     &                              istrt, 'FLEXBOUND:RMSDQ')) 
c
c FLEXBOUND: MAXCHARGTRANS.
c
               elseif (string(istrt:istrt+12).eq.'maxchargtrans') then
                  qmmminp%maxfbdqtot = cfloat(rvar(string, 
     &                              istrt, 'FLEXBOUND:MAXCHARGTRANS')) 
c
c FLEXBOUND: TEMPERATURE.
c
               elseif (string(istrt:istrt+10).eq.'temperature') then
                  qmmminp%temprt = cfloat(rvar(string, 
     &                              istrt, 'FLEXBOUND:TEMPERATURE')) 
c
c FLEXBOUND: CALCHARGMETH.
c
               elseif (string(istrt:istrt+11).eq.'calchargmeth') then
                  qmmminp%fbccmeth = rvar(string, istrt, 
     *                                 'FLEXBOUND:CALCHARGMETH')

                  if ( (string(istrt:istrt+4) .ne. 'qeqrg').and.
     $                 (string(istrt:istrt+4) .ne. 'qeqbt').and.
     $                 (string(istrt:istrt+2) .ne. 'eem')) then                   
                      write (outfile,*)
     *            'Error: the keyword CALCHARGMETH in FLEXBOUND. '
                      stop  'flexbound 1'
                   end if
c              
c FLEXBOUND: PARAMETER
c              
               elseif (string(istrt:istrt+8) .eq. 'parameter') then
                  call rlist(qmmminp%sscp, 'FLEXBOUND:PARAMETER', iend )
c
c FLEXBOUND: FBGOUPID.
c
               elseif (string(istrt:istrt+10).eq.'fbgroupid') then
                  qmmminp%fbgid = cfloat(rvar(string, 
     &                              istrt, 'FLEXBOUND:FBGOUPID')) 
c
c FLEXBOUND: GROUP
c
               elseif (string(istrt:istrt+4).eq.'group') then
                  gid = cfloat(rvar(string, 
     &                              istrt, 'FLEXBOUND:GROUP')) 
                  fbg = fbg + 1
                  call ridlist(fbgaid, 
     &                        qmmminp%fbgan(gid), iend)

                  do i=1, qmmminp%fbgan(gid)
                     qmmminp%fbgaid(gid,i) = fbgaid(i)
                  end do

                  if(qmmminp%fbgan(gid).gt.maxganum) then
                    write(outfile,*)' The total id number in a group',
     &                   'is larger the maximum permit number.',
     &                    qmmminp%fbgan(gid)
                     stop 'rqmmm flebound group 1'
                  elseif(qmmminp%fbgan(gid).lt.2) then
                    write(outfile,*)' The total number in a group',
     &                   'is too little.',qmmminp%fbgan(gid)
                     stop 'rqmmm flexbound group 2'
                  end if
               else
c
                  write (outfile,1103) string(istrt:80)
1103             format(/3x,'ERROR: the following is not a valid ',
     *                   'option of the FLEXBOUND keyword: ', a)
                  stop 'rqmmm flexbound'
               endif
               call rline(infile,string,istrt,isect,iscend2,iend)
            enddo
c
c  End by Yan Zhang 09/04/2007
c
 
c
c  07/01/2011 by Soroosh Pezeshki
c
c
c comments
c
         elseif (string(istrt:istrt) .eq. ' ') then
            string=string
c
c end 07/01/2011 by Soroosh Pezeshki
c

c  Invalid option
c
         else
            write (outfile,1000) string(istrt:80)
            stop 'rqmmm 1'
 1000      format(3x,'ERROR: the following is not a valid keyword in ',
     *               'the QM/MM section: ',a)
c     
         endif
         call rline(infile,string,istrt,isect,iscend,iend)
c
      enddo
c
c  Fill necessary information before return
c

c
c    chech the group number and method in POLAR 8/7/2006 by Yan Zhang
c
      if(qmmminp%polgnum.ne.idpolg) then
        write(outfile,*)' The polgnum ',
     &    'is not equal to idpolg.',idpolg,
     &     qmmminp%polgnum
        stop 'rqmmm polar group '
      end if

c
c     end 8/7/2006 by Yan Zhang
c
c     if iqmc=0, qmmminp%qmcharge= mlginp%geom%charge
c     if iqmm=0,  qmmminp%qmmult=mlginp%geom%mult  add 10/27/2006 by Yan Zhang 
c 
      if(iqmc.eq.0) qmmminp%qmcharge= mlginp%geom%charge
      if(iqmm.eq.0) qmmminp%qmmult=mlginp%geom%mult
c
c     The keyword--qmmmcutoff is not used in the Hessian calculation.
c
      if((qmmminp%lcutoff.eq.1).and.(mlginp%lhess.eq.1)) then
         write(outfile,*)
     $  'Error: qmmmcutoff can not used in the Hessian calculation. '
      stop 'qmmmcutoff can not used in the Hessian calculatio'
      endif
c
c     end 10/27/2006 by Yan Zhang    
c
c   The polarized calculation only use the RC and RCD schemes.
c         11/7/2006 by Yan Zhang
c 
      if(((qmmminp%bordercharge.ne.'rc').and.
     $    (qmmminp%bordercharge.ne.'rcd')).and.
     $     (qmmminp%polmeth.ne.'none')) then
         write(outfile,*)'Error: The polarized calculation only',
     $       'use the RC or RCD schemes.'
         stop 'rqmmm polarization 1'
      end if
c
c     end 11/7/2006 by Yan Zhang
c
c  0) Check if maximum number for atoms need to be increased
c
      jj = mlginp%geom%natoms + qmmminp%capatm%capnatm * 9
      if (jj .gt. maxatm) then
         write(outfile,1500) 
	 stop 'rqmmm 10'
      endif	 
c
c   add 2/10/2007 by Christoph Riplinger
c   the estimated hessian is not at all expensive in terms of calculation
c
      if ((mlginp%lhess .eq. 1) .and. (mlginp%lhessType .ne. 4) .and. 
     *    (jj .gt. hessmaxatm)) then
         write(outfile,1600)
         stop 'rqmmm 10'	       
      endif
c
c   end 2/10/2007 by Christoph 
c
1500  format (/2x,'Error: Exceed the maximum allowed total number ',
     *   'for atoms and auxiliary charges.',/2x,
     *   'Please increase the maxatm.')
1600  format (/2x,'Error: Exceed the maximum allowed total number ',
     *   'for atoms and auxiliary charges.',/2x,
     *   'Please increase the maxatm for hessian calculation.')	  
c      
c  1) Set the M1 atom (cap atom host) id, Cap-M1 Link
c
      jj = qmmminp%capatm%capnatm
      qmmminp%mm1stlay%natm1stlay     = jj
      qmmminp%mm1stlay%atm1stlay(:jj) = qmmminp%capatm%capatm(:jj)
      qmmminp%capatm%capatmm1(:jj)    = qmmminp%capatm%capatm(:jj)
c
c  2) Set the M1-QM and M1-M2 links
c   
      m2 = 0 
      ii = qmmminp%qmnatm + qmmminp%capatm%capnatm
      do j=1, jj
         i = qmmminp%mm1stlay%atm1stlay(j)
         kk = mlginp%mmgeom%atmvalen(i)
         temp = 0
c  add by Bo Wang 1029BW09
         if (qmmminp%capatm%capatmqm(j) .ne. 0) then  !when the QM host has been set in the input,
            qmtag=0                               !check if the Q1 atom is included in QM atom list
            mm = qmmminp%qmnatm
            do m=1, mm
              t3 = qmmminp%qmatm(m)
              if (qmmminp%capatm%capatmqm(j) .eq. t3) then
                  qmtag=1
              endif
            enddo
            if (qmtag .eq. 0) then
              write (outfile,1980) qmmminp%capatm%capatmqm(j)
              stop 'rqmmm 11'
1980          format (2x,'Error: Q1 atom:',i4,
     *                '  is not included in QM atom list.')
            endif
         endif
c  end by Bo Wang 1029BW09

         
         do k=1, kk
            t2 = mlginp%mmgeom%atmvalenlist(i,k)
c
c  QM link
c           
c add by Bo Wang 0203BW15
c  in the new input format for the link atom, the QM link atom is
c   defined in the input, so  we can assign the atom directly,don't
c  need to search for the QM link atom. Original method is compatible
c
           if (qmmminp%capatm%capatmqm(j) .ne. 0) then     !1029BW09  the QM host has been set in the input
             if (t2 .eq. qmmminp%capatm%capatmqm(j)) then  !1029BW09  t2 is the QM host
               qmmminp%mm1stlay%atm1stlayqm(j) = t2
               goto 2000
             else
               goto 1990         !1029BW09  t2 is not the QM host, so t2 is M2 atom
             endif
           else                !1029BW09  the QM host has not been set in the input
              mm = qmmminp%qmnatm
              do m=1, mm
                t3 = qmmminp%qmatm(m)
                if (t2 .eq. t3) then
                   qmmminp%mm1stlay%atm1stlayqm(j) = t3
                   qmmminp%capatm%capatmqm(j) = t3
                   goto 2000
                endif
             enddo
           endif
1990       continue
c end by Bo Wang 0203BW15 

c
c  M2 link         
c         
           temp = temp + 1
           m2 = m2 + 1
           qmmminp%mm1stlay%atm1stlaym2(j,temp) = t2
           qmmminp%mm2ndlay%atm2ndlay(m2) = t2
           qmmminp%mm2ndlay%atm2ndlaym1(m2) = i
           qmmminp%chredist%m1(m2) = i
           qmmminp%chredist%m2(m2) = t2
2000     continue   
         enddo
         
         if(temp .ne. (kk-1)) then
            write(outfile,*) 
     *        'Error: Only one QM atom should connect to M1 atom:',i
         endif   
         qmmminp%mm1stlay%atm1stlaym2num(j) = kk - 1
         
      continue
      enddo
      qmmminp%mm2ndlay%natm2ndlay = m2
c
c  3) check if capatm too close to M1 atom when bordercharge = scale
c            
      if (qmmminp%embed .ne. 'mechanical')  then
         if (qmmminp%bordercharge .eq. 'scale') then
            mindist = 1.0d-3
            ii = qmmminp%capatm%capnatm
            do i=1, ii	       
               dist = 1.0d0 - qmmminp%capatm%capbondscale(i)
               if((dist .le. mindist) .or. (-dist .ge. -mindist)) then
                  write(outfile,3000) qmmminp%capatm%capatm(i)
                  stop 'rqmmm 9'
               endif
            enddo
         endif       
      endif
3000  format(/2x,'Error: Cap atom ',i5,' too close to MM host.')
c     
c  add by Bo Wang 0126BW13
c  3.5) chekc if the balanced charge input is consistent
c       with the capatom input
       if (qmmminp%lchgbal .eq. 1) then
         ii = qmmminp%capatm%capnatm
         do i = 1, ii
          if (qmmminp%balgroup(i,1) .ne. qmmminp%capatm%capatm(i)) then
                  write(outfile,3100) qmmminp%capatm%capatm(i)
                  stop 'rqmmm 8'
3100  format(/2x,'Error: Cap atom ',i5,' is not consistent with charge
     & balancing input.')
          endif
         enddo
       endif
c   end by Bo Wang 0126BW13


c 5) Set the M2-M3 links
c
      temp = 0
      ii = mlginp%geom%natoms
      jj = qmmminp%qmnatm
      kk = qmmminp%capatm%capnatm
      mm = qmmminp%mm2ndlay%natm2ndlay
      do m=1, mm
         m2 = qmmminp%mm2ndlay%atm2ndlay(m)
         t1 = mlginp%mmgeom%atmvalen(m2)
         do t2=1, t1
            m3 = mlginp%mmgeom%atmvalenlist(m2,t2)
            do j=1, jj
               k = qmmminp%qmatm(j)
               if (m3 .eq. k) goto 3500
            enddo
            do j=1, kk
               k = qmmminp%capatm%capatm(j)
               if  (m3 .eq. k) goto 3500
            enddo
            do j=1, mm
               k = qmmminp%mm2ndlay%atm2ndlay(j)
               if  (m3 .eq. k) goto 3500
            enddo
            temp = temp + 1
            qmmminp%mm3rdlay%atm3rdlay(temp) = m3
            qmmminp%mm3rdlay%atm3rdlaym2(temp) = m2
3500     continue
         enddo
      enddo
      qmmminp%mm3rdlay%natm3rdlay = temp
c  
c 4) Set the MM atoms excluding the M1 (cap host) atoms
c
      qmmminp%mmnatm = mlginp%geom%natoms - qmmminp%qmnatm
     *                 - qmmminp%capatm%capnatm
      if (qmmminp%mmnatm .lt. 0) then
         write(outfile,4000)
4000  format(/3x,'ERROR: Too many QM and Cap atoms!')
         stop 'rqmmm 6'
      endif
      temp = 0
      ii = mlginp%geom%natoms
      jj = qmmminp%qmnatm
      kk = qmmminp%capatm%capnatm
      mm = qmmminp%mm2ndlay%natm2ndlay
      m3 = qmmminp%mm3rdlay%natm3rdlay
      do i=1, ii
         k = mlginp%mmgeom%atmid(i)
         do j=1, jj
            if (k .eq. qmmminp%qmatm(j)) goto 4500
         enddo
         do j=1, kk
            if (k .eq. qmmminp%capatm%capatm(j)) goto 4500
         enddo
         temp = temp + 1
         qmmminp%mmatm(temp) = k
         do j=1, mm
            if (k .eq. qmmminp%mm2ndlay%atm2ndlay(j)) then
               qmmminp%mlist(temp) = j
               goto 4500
            endif   
         enddo
         do j=1, m3
            if (k .eq. qmmminp%mm3rdlay%atm3rdlay(j)) then
               qmmminp%m3list(temp) = j
               goto 4500
            endif
         enddo
4500     continue
      enddo
c
c Add by Yan Zhang 9/04/2007
c Set flexible-boundary group numbers
c      
      qmmminp%fbgnum = fbg
      if(fbg.gt.maxgnum) then
        write(outfile,*) ' Group number exceed the permit.'
        stop 'flexible-boundary group num'
      endif
c
c  Chang charges in the MM calculation of background charges interaction.
c
      if(qmmminp%polmeth.eq.'none'.and.qmmminp%iflexbound.eq.0)
     *   qmmminp%modmmcharg = 1
      if(qmmminp%polmeth.ne.'none'.and.qmmminp%iflexbound.eq.0)
     *   qmmminp%modmmcharg = 2
      if(qmmminp%polmeth.eq.'none'.and.qmmminp%iflexbound.eq.1)
     *   qmmminp%modmmcharg = 3
      if(qmmminp%polmeth.eq.'none'.and.qmmminp%iflexbound.eq.0     !1014BW09  
     * .and.qmmminp%mmbas.eq.'mmff' .and. qmmminp%lrdmmchg .eq. 0) !1014BW09  for MMFF94 force field
     *   qmmminp%modmmcharg = 4                                    !1004BW09
      if(qmmminp%polmeth.ne.'none'.and.qmmminp%iflexbound.eq.1) then
        write(outfile,*)'Error: the boundary charge treatment.'
          stop
      end if
c
c End by Yan Zhang 9/04/2007
c
      call settsemiempirical(qmmminp%qmmeth)                            0311SP11

c  add by Bo Wang 0203BW15 
c  If no balanced charge group is specified but
c  balanced charge scheme is used, then the whole MM region is
c  considered as a group. Only for one M1 atom.
       if (qmmminp%lchgbal .eq. 0) then
         if ( qmmminp%bordercharge .eq. 'rcbal'   .or.
     *      qmmminp%bordercharge .eq. 'rcbal2'  .or.
     *      qmmminp%bordercharge .eq. 'rcbal3'  .or.
     *      qmmminp%bordercharge .eq. 'amber2'  .or.
     *      qmmminp%bordercharge .eq. 'rcdbal'  .or.
     *      qmmminp%bordercharge .eq. 'seebal'  .or.
     *      qmmminp%bordercharge .eq. 'shiftbal'  .or.
     *      qmmminp%bordercharge .eq. 'shiftbal2' .or.
     *      qmmminp%bordercharge .eq. 'amber1')    then
           qmmminp%lchgbal = 1
           qmmminp%nbalgroup = 1
           qmmminp%groupchg(1)= mlginp%geom%charge-qmmminp%qmcharge
           do i=1, qmmminp%mm1stlay%natm1stlay
             qmmminp%balgroup(1,1) = qmmminp%mm1stlay%atm1stlay(i)
           enddo
           ii = qmmminp%mmnatm
           do i=1,ii
             qmmminp%balgroup(1,i+1)=qmmminp%mmatm(i)
           enddo
           qmmminp%balgroupn(1) = ii+1
         endif
       endif
c    end by Bo Wang 0203BW15 

      return
      end
c
c*******************************************************************************
c  RMLGEN
c*******************************************************************************
c
      subroutine rmlgen(mlgeninp,string,iend,istrt)
c
c     Created:  Feb 22, 2005 by Hai Lin
c     Revised:  July 01, 2011 by Soroosh Pezeshki
c
c     Purpose:  read the MULTIGEN section of the input file
c
c               The debug flag is controled by keyword DEBUG 
c               given in multigen section, but its value is not 
c               stored in multigen, rather it is stored in the
c               common block /dodebug/ in module caltyp.
c	    
c
c     Description:  The Multigen section is scanned with rline and for
c     each keyword present, a value is assigned to the appropriate
c     variable or a function is called to do this.
c
c     Called by: read5
c     Calls: rline, rlist, icint, rgeom, cfloat, rvar
c
      use input, only : general
      use files, only : outfile, infile
      use param, only : maxatm
c
c added by Yan zhang 11/1/2007
c
      use hessian, only : hessmaxatm
c
c end by Yan zhang 11/1/2007
c
      use caltyp
      implicit none
c
c  i/o variables
c
      integer istrt, iend
c
      character*80 string
      type (general)  :: mlgeninp
c
c  local variables
c
c   add 2/10/2007 by Christoph Riplinger
c  we need iscendl for the search in the Partial subunit
c
c      integer  ierr, isect, icint, iscend
      integer  ierr, isect, icint, iscend, iscend1
c
c   end 2/10/2007 by Christoph 
c
      integer  atmset, numatom
      
      double precision  cfloat
      character*20      unit, type, rvar
c
      atmset = 0
c
c read first line of this section
c
      call rline(infile,string,istrt,isect,iscend,iend)      
c
c loop through the keywords of this section until the end of the 
c section is reached.
c
      do while (isect.eq.0 .and. iend.eq.0 .and. iscend.eq.0)
c
c TITLE
c
        if (string(istrt:istrt+4) .eq. 'title') then
           call rlist(mlgeninp%mtitle, 'TITLE', iend)
c
c CALMODEL                                                              
c
        elseif (string(istrt:istrt+7) .eq. 'calmodel') then
           mlgeninp%calmodel = rvar(string, istrt, 'CALMODEL')
	   if( mlgeninp%calmodel .ne. 'qm' .and.
     *	       mlgeninp%calmodel .ne. 'mm' .and.
     *         mlgeninp%calmodel .ne. 'qm/mm' ) then
	      write(outfile, *)
     * 	        'Error: Invalid model type (must be QM, MM, QM/MM)'
              stop 'rmlgen 2'
          endif
c 0222HL04end
c
c ENERGY
c
        elseif (string(istrt:istrt+5) .eq. 'energy') then
          mlgeninp%lener = 1
c
c NOENERGY
c
        elseif (string(istrt:istrt+7) .eq. 'noenergy') then
           mlgeninp%lener = 0
c
c GRADIENT
c
        elseif (string(istrt:istrt+7) .eq. 'gradient') then
           mlgeninp%lgrad = 1
c
c NOGRADIENT
c
        elseif (string(istrt:istrt+9) .eq. 'nogradient') then
           mlgeninp%lgrad = 0
c
c HESSIAN
c
        elseif (string(istrt:istrt+6) .eq. 'hessian') then
           mlgeninp%lhess = 1
c
c   add 2/10/2007 by Christoph Riplinger
c   since there are different types of hessians available, we nedd to specify the type
           mlgeninp%lhessType = 1
c
c NUMHESSIAN
c
        elseif (string(istrt:istrt+9) .eq. 'numhessian') then
           mlgeninp%lhess = 1
           mlgeninp%lhessType = 2
c
c HYBRIDHESSIAN
c
        elseif (string(istrt:istrt+12) .eq. 'hybridhessian') then
           mlgeninp%lhess = 1
           mlgeninp%lhessType = 3
c
c estimated HESSIAN (e.g. Almloef in orca)
c
        elseif (string(istrt:istrt+15) .eq. 'estimatedhessian') then
           mlgeninp%lhess = 1
           mlgeninp%lhessType = 4
c
c   end 2/10/2007 by Christoph 
c
c NOHESSIAN
c
        elseif (string(istrt:istrt+8) .eq. 'nohessian') then
           mlgeninp%lhess = 0
c
c   add 2/10/2007 by Christoph Riplinger
c
           mlgeninp%lhessType = 0
c
c   end 2/10/2007 by Christoph 
c
c   add 2/10/2007 by Christoph Riplinger
c   Partial Hessian Calculation for the general input        
c
        elseif (string(istrt:istrt+6) .eq. 'partial') then
           mlgeninp%part%ipartcal = 1
c
c read first line of partial calculation.
c 
           call rline(infile,string,istrt,isect,iscend1,iend)
           do while (iscend1.eq.0.and.isect.eq.0.and.iend.eq.0)
c
c PARTIAL: PARTCHARGE--- the charge for the partial atoms. 
c
               if (string(istrt:istrt+9).eq.'partcharge') then
          mlgeninp%part%pcharge = 
     *       icint(rvar( string, istrt,'PARTCHARGE'))
c
c PARTIAL: PARTMULT--- the multiplicity for the partial atoms.
c
               elseif (string(istrt:istrt+7).eq.'partmult') then
           mlgeninp%part%pmult = icint(rvar( string, istrt,'PARTMULT'))
c
c PARTIAL: PARTATM---- the atomic ID for the partial calculation.
c
               elseif (string(istrt:istrt+6).eq.'partatm') then
                    call ridlist(mlgeninp%part%partatmid, 
     &                       mlgeninp%part%partatmnum, iend)
               else
c
                 write (outfile,1102) string(istrt:80)
1102             format(/3x,'ERROR: the following is not a valid ',
     *                  'option of the PARTIAL keyword: ', a)
                 stop 'rmlgen partial'
              endif
              call rline(infile,string,istrt,isect,iscend1,iend)
           enddo
c
c   end 2/10/2007 by Christoph 
c
c NATOMS
c
        elseif (string(istrt:istrt+5) .eq. 'natoms') then
           mlgeninp%geom%natoms = icint(rvar(string, istrt, 'NATOMS'))
           atmset = 1
c
c GEOMUNIT
c
        elseif (string(istrt:istrt+7) .eq. 'geomunit') then
           unit = rvar(string, istrt, 'GEOMUNIT')
           if (unit(:3) .eq. 'ang') then
              mlgeninp%geomunit = 1
	   elseif (unit(:2) .eq. 'au') then
              mlgeninp%geomunit = 0
	   else
              write (outfile,11) string
c
  11          format ('ERROR:  Invalid GEOMUNIT option:', a80)
              stop 'rmlgen 3'
           endif
c
c GEOMTYPE
c
        elseif (string(istrt:istrt+7) .eq. 'geomtype') then
           type = rvar(string, istrt, 'GEOMTYPE')
           if (type(:9) .eq. 'cartesian') then
              mlgeninp%geomtype = 0
           else
              write (outfile,21) string
c
  21          format ( 'ERROR:  Invalid GEOMTYPE option:', a80)
              stop 'rmlgen 5'
           endif
c
c GEOM
c
        elseif (string(istrt:istrt+3) .eq. 'geom') then
           call rgeom(mlgeninp%geom, mlgeninp%geomunit, numatom,
     *                  string, istrt, iend)
c
c MMGEOM                                                                
c
        elseif (string(istrt:istrt+6) .eq. 'mmvalen') then
	   mlgeninp%lmmvalen = 1
  	   call rmmgeom(mlgeninp%mmgeom, mlgeninp%geom,
     *	     mlgeninp%geomunit, numatom,
     *                  string, istrt, iend)
c                                                                       
c
c PRNATMPRM / NOPRNATMPRM                                               
c
         elseif (string(istrt:istrt+8).eq.'prnatmprm') then
	     mlgeninp%mmgeom%lprnatmprm = 1
         elseif (string(istrt:istrt+10).eq.'noprnatmprm') then
	     mlgeninp%mmgeom%lprnatmprm = 0					  
c
c CHARGE
c
        elseif (string(istrt:istrt+5) .eq. 'charge') then
           mlgeninp%geom%charge = icint(rvar(string,istrt,'CHARGE'))
c
c MULTIPLICITY
c
        elseif (string(istrt:istrt+11) .eq. 'multiplicity') then
           mlgeninp%geom%mult = icint(rvar(string,istrt,'MULTIPLICITY'))
c
c PRSUM                                                                 
c                                                                       
        elseif (string(istrt:istrt+4) .eq. 'prsum') then                
           mlgeninp%lprsum = 1                                          
c
c NOPRSUM                                                               
c
        elseif (string(istrt:istrt+6) .eq. 'noprsum') then              
           mlgeninp%lprsum = 0                                          
c
c DEBUG                                                                 
c
        elseif (string(istrt:istrt+4) .eq. 'debug') then
            tdebug = 1
            call rword(string,istrt,ierr)
            if (ierr .eq. 0) then
                tdebug = icint(rvar(string,istrt-1,'DEBUG'))
            endif

c                                                                       
 
c
c  07/01/2011 by Soroosh Pezeshki
c
c
c comments
c
         elseif (string(istrt:istrt) .eq. ' ') then
            string=string
c
c end 07/01/2011 by Soroosh Pezeshki
c

c
c Invalid option
c
        else
c
           write (outfile,1000) string(istrt:80)
           stop 'rmlgen 9'
c
 1000      format(3x,'ERROR: the following is not a valid keyword in ',
     *               'the GENERAL section: ',a80)
        endif
c
        call rline(infile,string,istrt,isect,iscend,iend)
c
      end do
c
c  Stop if NATOMS never specified.
c
      if (atmset .ne. 1) then
         write (outfile,*) 'ERROR:  must specify natoms.'
         stop 'rmlgen 10'
c
c  Stop if NATOMS and GEOM not match each other.
c
      elseif (mlgeninp%geom%natoms .ne. numatom) then
         write (outfile,1100) numatom, mlgeninp%geom%natoms
1100     format ('ERROR: atoms in GEOM not equal NATOMS.',i3,i3)
         stop 'rmlgen 11'
      endif
c
c  Stop if Hessian calculations with too many atoms                     
c     Check the value of module.F:hessian:maxatm
c
c
c   add 2/10/2007 by Christoph Riplinger
c   the estimated hessian is not expensive in terms of calculation time
c
      if ((mlgeninp%lhess .eq. 1) .and. (mlgeninp%lhessType .ne. 4)
     *    .and. (numatom .gt. hessmaxatm)) then   
         write (outfile,1200)
	 stop 'rmlgen 12'
      endif
1200  format ('Error: too many atoms for Hessian calculations.')
c
c   end 2/10/2007 by Christoph 
c
c  add by Yan Zhang 10/29/2007
c
      if((mlgeninp%part%extlayernum.ne.0).and.
     * (mlgeninp%part%extlayernum.ne.1).and.
     * (mlgeninp%part%extlayernum.ne.2)) then
        write(outfile,1300)
        stop 'rmlgen 13'
      endif
1300  format('Error: extend layer number in partial optimization.')
c
      	 
      return
      end
c
c
c*******************************************************************************
c  REXTOPT
c*******************************************************************************
c
      subroutine rextopt( progrms, extoptinp, string, istrt, iend )
c
c     Created:  Feb 22, 2005 by Hai Lin
c     Revised:  Mar.28, 2006 by Yan Zhang
c               July 01, 2011 by Soroosh Pezeshki
c
c 
c     Purpose:  reads the EXTOPT input section under multigen
c     
c     Called by:  rmlgen
c     Calls:  rline, rvar, rlist
c     
      use files, only : outfile, infile
      use input, only : extopt, proglist
      implicit none
c
c  i/o variables
c
      type (extopt)   :: extoptinp
      type (proglist) :: progrms
      integer            istrt, iend
c
      character*80       string
c
c  local variables
c      
      integer           i, j, isect, iscend            
      character*20      rvar
      double precision  cfloat
c
      isect = 0 
      iscend = 0
c
c read first line in EXTOPT section
c  
      call rline(infile,string,istrt,isect,iscend,iend)
c
c loop through the keywords of the EXTOPT section
c
      do while (isect.eq.0 .and. iend.eq.0)
c
c PROGRAM
c
         if (string(istrt:istrt+6).eq.'program') then
            progrms%extoptprog = rvar(string, istrt, 'EXTOPT:PROGRAM')
c
c	 revised 3/28/2006 by Yan Zhang
c
            if (   string(istrt:istrt+2) .ne. 'g03'      .and.
     *             string(istrt:istrt+2) .ne. 'g09'      .and.        !1222BW10
     *             string(istrt:istrt+2) .ne. 'g16'      .and.          1020XW17
     *             string(istrt:istrt+5) .ne. 'tinker'.and.
     *             string(istrt:istrt+5) .ne. 'gamess'.and.
     *             string(istrt:istrt+4) .ne. 'orca' ) then
               write (outfile,500)
c  500          format(3x, 'ERROR: Tinker, Gamess, Orca and G03 are ',
  500          format(3x, 'ERROR: Tinker, Gamess, Orca and Gaussian ',  1020XW17
     *                   'are the only allowed PROGRAMs for this ',     1020XW17 
     *                   'version of QMMM')
               stop 'rextopt1'
            endif
c
c      end  3/28/2006 by Yan Zhang
c
c METHOD   
c
         elseif (string(istrt:istrt+5) .eq. 'method') then
            extoptinp%meth = rvar( string, istrt, 'EXTOPT:METHOD' )
c
c BASIS
c
         elseif (string(istrt:istrt+4) .eq. 'basis') then
            extoptinp%bas = rvar( string, istrt, 'EXTOPT:BASIS' )
c
c MM program version
c
         elseif (string(istrt:istrt+6) .eq. 'version') then
            extoptinp%bas = rvar( string, istrt, 'EXTOPT:BASIS' )
c
c FORCEFIELD
c  treated as basis in electronic structure calculations
c
         elseif (string(istrt:istrt+9) .eq. 'forcefield') then
            extoptinp%bas = rvar( string, istrt, 'EXTOPT:FORCEFIELD')	    	 
c
c MMCONVERG
c
         elseif (string(istrt:istrt+8) .eq. 'mmconverg') then
            extoptinp%smmconverg =
     *        rvar(string,istrt,'EXTOPT:MMCONVERG')	    
            extoptinp%mmconverg = 
     *	      cfloat(extoptinp%smmconverg)
c
c OPTIONS
c
         elseif (string(istrt:istrt+6) .eq. 'options') then
            call rlist(extoptinp%optl, 'EXTOPT:OPTIONS', iend )
 
c
c  07/01/2011 by Soroosh Pezeshki
c
c
c comments
c
         elseif (string(istrt:istrt) .eq. ' ') then
            string=string
c
c end 07/01/2011 by Soroosh Pezeshki
c

c
c Invalid option
c
         else
             write (outfile, 11) string
c
  11         format ( 'ERROR: Invalid EXTOPT option:', a80)
             stop 'extopt 2'
         endif
c
c read next line 
c
         call rline(infile,string,istrt,isect,iscend,iend)
      enddo
      return
      end
c 
c
c*******************************************************************************
c  RMLOPT
c*******************************************************************************
c
      subroutine rmlopt( progrms, mloptinp, natoms, string, 
     *      istrt, iend )
c
c     Created:  July 13, 1999 by J.M. Rodgers
c     Revised:  January 11, 2000 by P. L. Fast 
c               January 25, 2000 by P. L. Fast
c               Feb 22, 2004 by Hai Lin
c               APr.20, 2006 by Yan Zhang
c               Aug.21, 2006 by Yan Zhang
c               Nov. 6, 2006 by Yan Zhang
c               Dec.12, 2006 by Yan Zhang
c               July 01, 2011 by Soroosh Pezeshki
c
c     Purpose:  reads the MLOPT input section
c
c     Called by:  rmlgen
c     Calls:  rline, rvar, cfloat, icint
c
      use files, only : outfile, infile
      use param, only : linear, nonlin, lints, nonlints, uniths,lowqmhs,
c
c   add 2/10/2007 by Christoph Riplinger
c
c     *     qmmmhs,mmhs
     *    qmmmhs,mmhs,hybridhs,numhs,esths
c
c   end 2/10/2007 by Christoph 
c
      use input, only : mlopt, proglist
      implicit none
c
c i/o variables
c
      type (mlopt)    :: mloptinp
      type (proglist) :: progrms
      integer            istrt, iend
c
      character*80       string
      integer            natoms
c
c local variables
c
      integer       i, j, isect, iscend, constset
      character*20  rvar, tempalg, mlm, tempret, tempsds, tempmol,
     *   temphtyp, tempih
     
      integer           icint
      double precision  cfloat

      integer     iscend1, isect1, iend1
c                             
      isect    = 0
      iscend   = 0
      constset = 0
c
c read first line in MULTIOPT section
c
      call rline(infile,string,istrt,isect,iscend,iend)
c
c loop through the keywords of the MLOPT section
c
      do while (isect.eq.0 .and. iend.eq.0)
c
c ALGORITHM                                                             
c
         if (string(istrt:istrt+8).eq.'algorithm') then
            tempalg = rvar( string, istrt, 'ALGORITHM' )
            if (tempalg(:4) .eq. 'bfgs') then
               mloptinp%algrthm = 1
            elseif (tempalg(:2) .eq. 'nr') then
               mloptinp%algrthm = 0
            elseif (tempalg(:3) .eq. 'dfp') then
               mloptinp%algrthm = 2
            elseif (tempalg(:2) .eq. 'ef')  then
               mloptinp%algrthm =3 
            elseif (tempalg(:6) .eq. 'gauext')  then
	       mloptinp%algrthm =4   
c
c  LBFGS added by Yan zhang 12./11/2006
c
            elseif (tempalg(:6) .eq. 'lbfgs')  then
               mloptinp%algrthm =5       
c
c  end 12/11/2006
c
c   add 2/10/2007 by Christoph Riplinger
c
c
            elseif (tempalg(:7) .eq. 'orcaext')  then
               mloptinp%algrthm =6
c
c   end 2/10/2007 by Christoph 
c
            else
               write (outfile,1001) tempalg
1001           format('ERROR: Invalid ALGORITHM:',2x,a)
               stop 'rmlopt 1'
            endif

c
c PARTIAL ATOMIC OPT
c   add 8/21/2006	by Yan Zhang
c
c         elseif (string(istrt:istrt+9).eq.'partcharge') then
c            mloptinp%pcharge = icint(rvar( string, istrt,'PARTCHARGE'))
c         elseif (string(istrt:istrt+7).eq.'partmult') then
c            mloptinp%pmult = icint(rvar( string, istrt,'PARTMULT'))
c         elseif (string(istrt:istrt+9).eq.'partial') then
c            mloptinp%ipartcal = 1
c         elseif (string(istrt:istrt+9).eq.'partatm') then
c            call ridlist(mloptinp%partatmid, 
c     &                        mloptinp%partatmnum, iend)
c
c     Revise the input format for the partial optimization using 
c     the Gaussian03 optimizer 11/6/2006 by Yan Zhang
c
         elseif (string(istrt:istrt+6) .eq. 'partial') then
c
c   modified 2/10/2007 by Christoph Riplinger
c            mloptinp%ipartcal = 1
            mloptinp%part%ipartcal = 1
c
c read first line of partial calculation.
c 
            call rline(infile,string,istrt,isect,iscend1,iend)
            do while (iscend1.eq.0.and.isect.eq.0.and.iend.eq.0)
c
c PARTIAL: PARTCHARGE--- the charge for the partial atoms. 
c
c
c                if (string(istrt:istrt+9).eq.'partcharge') then
c          mloptinp%pcharge = icint(rvar( string, istrt,'PARTCHARGE'))
                if (string(istrt:istrt+9).eq.'partcharge') then
                    mloptinp%part%pcharge 
     *              = icint(rvar( string, istrt,'PARTCHARGE'))
c
c PARTIAL: PARTMULT--- the multiplicity for the partial atoms.
c
c                elseif (string(istrt:istrt+7).eq.'partmult') then
c          mloptinp%pmult = icint(rvar( string, istrt,'PARTMULT'))
                elseif (string(istrt:istrt+7).eq.'partmult') then
           mloptinp%part%pmult = icint(rvar( string, istrt,'PARTMULT'))
c
c PARTIAL: PARTATM---- the atomic ID for the partial calculation.
c
c
c                elseif (string(istrt:istrt+9).eq.'partatm') then
c                     call ridlist(mloptinp%partatmid, 
c     &                        mloptinp%partatmnum, iend)
                elseif (string(istrt:istrt+9).eq.'partatm') then
                     call ridlist(mloptinp%part%partatmid, 
     &                        mloptinp%part%partatmnum, iend)
c
c   end 2/10/2007 by Christoph 
c
c
c PARTIAL: EXTLAYERNUM add by Yan Zhang 10/29/2007
c extend partial atoms layer number around moving atoms
c
               elseif (string(istrt:istrt+10).eq.'extlayernum') then
                 mloptinp%part%extlayernum =
     *         icint(rvar( string, istrt,'EXTLAYERNUM'))
c
c PARTIAL: PARTCENTID                
c
               elseif (string(istrt:istrt+9).eq.'partcentid') then
                 mloptinp%part%partcentid = 
     *         icint(rvar( string, istrt,'PARTCENTID'))
                 mloptinp%part%ipartcent = 1
                 mloptinp%part%ipartyp   = 2                  
c
c PARTIAL: PARTCENTXYZ   
c
               elseif (string(istrt:istrt+10).eq.'partcentxyz') then
	         mloptinp%part%partcentx = 
     &	            cfloat(rvar(string,istrt,'PARTCENTXYZ'))
	         mloptinp%part%partcenty = 
     &	            cfloat(rvar(string,istrt,'PARTCENTXYZ'))
	         mloptinp%part%partcentz = 
     &	            cfloat(rvar(string,istrt,'PARTCENTXYZ'))
                 mloptinp%part%ipartcent = 2
                 mloptinp%part%ipartyp   = 2
c
c PARTIAL: PARTRAD  
c
               elseif (string(istrt:istrt+6).eq.'partrad') then
                 mloptinp%part%partrad = 
     &              cfloat(rvar(string,istrt,'PARTRAD'))
c
c PARTIAL: PARTINIT 
c
               elseif (string(istrt:istrt+7).eq.'partinit') then
                 mloptinp%part%initgpart = 1
c
c end by Yan Zhang 10/29/2007
c
                else
c
                  write (outfile,1102) string(istrt:80)
1102              format(/3x,'ERROR: the following is not a valid ',
     *                   'option of the PARTIAL keyword: ', a)
                  stop 'rmlop partial'
               endif
               call rline(infile,string,istrt,isect,iscend1,iend)
            enddo
c
c   end 11/6/2006 by Yan Zhang
c   end 8/21/2006 by Yan Zhang
c
c METHOD
c modify	 4/20/2006	by Yan Zhang
c
         elseif (string(istrt:istrt+5).eq.'method') then
            mlm = rvar( string, istrt, 'METHOD' )
            if (  mlm(:4).ne.'qmmm') then                            

c            if (  mlm(:4).ne.'qmmm'   .and.                             
c  
C     *            mlm(:2).ne.'mm'     .and.                             
C     *            mlm(:2).ne.'qm'     .and.                             
c     *            mlm(:4).ne.'test' )  then                             
c
c       end 4/20/2006  by Yan Zhang
c 
               write (outfile,1011) mlm
1011           format('ERROR: Invalid MLOPT METHOD:',2x,a)
               stop 'rmlopt 2'
            else
              mloptinp%mlmeth = mlm
            endif
c
c MOLTYPE
c
        elseif (string(istrt:istrt+6).eq.'moltype') then
           tempmol = rvar(string, istrt, 'MOLTYPE')
           if (tempmol(:8).eq.'nonlints') then                          
              mloptinp%iop = nonlints                                   
           elseif (tempmol(:5).eq.'lints') then                         
              mloptinp%iop = lints
           elseif (tempmol(:3).eq.'lin') then
              mloptinp%iop = linear
           elseif (tempmol(:6).eq.'nonlin') then                        
              mloptinp%iop = nonlin                                     
           else
              write (outfile,1016) tempmol
1016          format('ERROR: Invalid MOLTYPE:',2x,a)
              stop 'rmlopt 7'
           endif
c
c  CONSTANT
c  
        elseif (string(istrt:istrt+7).eq.'constant')  then
           call rconst(mloptinp%constant, natoms, iend)
           constset = 1
c
c  REORIENT
c
        elseif (string(istrt:istrt+7).eq.'reorient') then
           mloptinp%reorient = 1
        elseif (string(istrt:istrt+9).eq.'noreorient') then
           mloptinp%reorient = 0
c
c HESSIAN
c
c    revised 4/20/2006 by Yan Zhang
c
        elseif (string(istrt:istrt+6).eq.'hessian') then
           temphtyp = rvar(string, istrt, 'HESSIAN')
           if (temphtyp(:7).eq.'unitmat') then
              mloptinp%htyp = uniths
           elseif (temphtyp(:4).eq.'qmmm') then
              mloptinp%htyp = qmmmhs
           elseif (temphtyp(:2).eq.'mm') then
              mloptinp%htyp = mmhs
           elseif (temphtyp(:5).eq.'lowqm') then
              mloptinp%htyp = lowqmhs
c
c   add 2/10/2007 by Christoph Riplinger
c   this information is read again by the orca_External script
c
           elseif (temphtyp(:13).eq.'hybridhessian') then
              mloptinp%htyp = hybridhs
           elseif (temphtyp(:10).eq.'numhessian') then
              mloptinp%htyp = numhs
           elseif (temphtyp(:16).eq.'estimatedhessian') then
              mloptinp%htyp = esths
c
c   end 2/10/2007 by Christoph 
c
           else
              write (outfile,1017) temphtyp
1017          format('ERROR: Invalid HESSIAN option:',2x,a)
              stop 'rmlopt 8'
           endif
c
c	end 4/20/2006 by Yan Zhang
c
c HMETH
c
         elseif (string(istrt:istrt+4).eq.'hmeth') then
            mloptinp%hmeth = rvar(string, istrt, 'HMETH')
c
c HBAS
c             
         elseif (string(istrt:istrt+3).eq.'hbas') then
            mloptinp%hbas = rvar(string, istrt, 'HBAS')
c
c HPROG
c
         elseif (string(istrt:istrt+4).eq.'hprog') then
            progrms%hessprog = rvar(string, istrt, 'HPROG')
c
c HSCALE
c
         elseif (string(istrt:istrt+5).eq.'hscale') then
            mloptinp%hscale = cfloat(rvar(string,istrt,'HSCALE'))
c
c INITHESS
c
         elseif (string(istrt:istrt+7).eq.'inithess') then
            tempih = rvar(string, istrt, 'INITHESS')
            if (tempih(:2).eq.'on') then
               mloptinp%ihunit = 1
            elseif (tempih(:3).eq.'off') then
               mloptinp%ihunit = 0
            else
               write (outfile,1018)  tempih
1018           format('ERROR: Invalid INITHESS option:',2x,a)
               stop 'rmlopt 9'
            endif
c
c DLX2
c
         elseif (string(istrt:istrt+3).eq.'dlx2') then
            mloptinp%dlx2 = cfloat(rvar(string, istrt, 'DLX2'))
c
c GCOMP
c
         elseif (string(istrt:istrt+4).eq.'gcomp') then
            mloptinp%gcomp = cfloat(rvar(string,istrt,'GCOMP'))
c
c SCALE
c
         elseif (string(istrt:istrt+4).eq.'scale') then
            mloptinp%scale = cfloat(rvar(string,istrt,'SCALE'))
c RMIN								   
c
         elseif (string(istrt:istrt+3).eq.'rmin') then                   
           mloptinp%rmin = cfloat(rvar(string,istrt,'RMIN'))             
c
c RMAX
c
         elseif (string(istrt:istrt+3).eq.'rmax') then                   
           mloptinp%rmax = cfloat(rvar(string,istrt,'RMAX'))             
c
c omin
c 
         elseif (string(istrt:istrt+3).eq.'omin') then                   
           mloptinp%omin = cfloat(rvar(string,istrt,'OMIN'))             
c
c DDMAX
c	 
         elseif (string(istrt:istrt+4).eq.'ddmax') then                  
           mloptinp%ddmax = cfloat(rvar(string,istrt,'DDMAX'))           
c
c DDMAXTS
c
         elseif (string(istrt:istrt+6).eq.'ddmaxts') then                
           mloptinp%ddmaxts = cfloat(rvar(string,istrt,'DDMAXTS'))       
c
c IUPD
c
         elseif (string(istrt:istrt+3).eq.'iupd') then                   
           mloptinp%iupd = cfloat(rvar(string,istrt,'IUPD'))             
c
c STPTOL
c
         elseif (string(istrt:istrt+5).eq.'stptol') then
            mloptinp%stptol = cfloat(rvar(string,istrt,'STPTOL'))
c
c HREC
c
         elseif (string(istrt:istrt+3).eq.'hrec') then
            mloptinp%hrec = icint(rvar(string,istrt,'HREC'))
c
c OPTIONS                                                               
c 
         elseif (string(istrt:istrt+12) .eq. 'gauextoptions') then
	    call rlist(mloptinp%optl, 'GAUEXTOPTIONS', iend )		     
c
c   add 2/10/2007 by Christoph Riplinger
c   and the options added for the orca external optimizer
c
         elseif (string(istrt:istrt+13) .eq. 'orcaextoptions') then
            call rlist(mloptinp%optl, 'ORCAEXTOPTIONS', iend ) 
c
c   end 2/10/2007 by Christoph 
c
c NITER
c
         elseif (string(istrt:istrt+4).eq.'niter') then
            mloptinp%niter = icint(rvar(string,istrt,'NITER'))
c
c RETRY
c
         elseif (string(istrt:istrt+4).eq.'retry') then
            tempret = rvar(string,istrt,'RETRY')
            if (tempret(:3).eq.'off') then
               mloptinp%retry = 0
            elseif (tempret(:2).eq.'on') then
               mloptinp%retry = 1
            else
               write (outfile,1021) tempret
1021           format('ERROR: Invalid RETRY input:',2x,a)
               stop 'rmlopt 3'
            endif
c
c SDSTRT
c
         elseif (string(istrt:istrt+5).eq.'sdstrt') then
            tempsds = rvar(string,istrt,'SDSTRT')
            if (tempsds(:3).eq.'off') then
               mloptinp%sdstrt = 0
            elseif (tempsds(:2).eq.'on') then
               mloptinp%sdstrt = 1
            else
               write (outfile,1031) tempsds
1031           format('ERROR: Invalid SDSTRT input:',2x,a)
               stop 'rmlopt 4'
            endif
c
c LINMN
c
         elseif (string(istrt:istrt+4).eq.'linmn') then
            tempsds = rvar(string,istrt,'LINMN')
            if (tempsds(:3).eq.'off') then
               mloptinp%llinmn = 0
            elseif (tempsds(:2).eq.'on') then
               mloptinp%llinmn = 1
            else
               write (outfile,1051) tempsds
1051           format('ERROR: Invalid LINMN input:',2x,a)
               stop 'rmlopt 5'
            endif
c
c LBFGS keword added by Yan Zhang 12/12/2006
c
c RMSGRAD
c
         elseif (string(istrt:istrt+6).eq.'rmsgrad') then
            mloptinp%rmsgrad = cfloat(rvar(string,istrt,'RMSGRAD'))
c
c MAXDX
c
         elseif (string(istrt:istrt+4).eq.'maxdx') then
            mloptinp%maxdx = cfloat(rvar(string,istrt,'MAXDX'))
c
c RMSDX
c
         elseif (string(istrt:istrt+4).eq.'rmsdx') then
            mloptinp%rmsdx = cfloat(rvar(string,istrt,'RMSDX'))
c
c MAXSTEP
c
         elseif (string(istrt:istrt+6).eq.'maxstep') then
            mloptinp%maxstep = cfloat(rvar(string,istrt,'MAXSTEP'))
c
c MINSTEP
c
         elseif (string(istrt:istrt+6).eq.'minstep') then
            mloptinp%minstep = cfloat(rvar(string,istrt,'MINSTEP'))
c
c CAPPA
c
         elseif (string(istrt:istrt+4).eq.'cappa') then
            mloptinp%cappa = cfloat(rvar(string,istrt,'CAPPA'))
c
c MAXSLOPE
c
         elseif (string(istrt:istrt+7).eq.'maxslope') then
            mloptinp%maxslope = cfloat(rvar(string,istrt,'MAXSLOPE'))
c
c MAXANG
c
         elseif (string(istrt:istrt+5).eq.'maxang') then
            mloptinp%maxang = cfloat(rvar(string,istrt,'MAXANG'))
c
c MINENR
c
         elseif (string(istrt:istrt+5).eq.'minenr') then
            mloptinp%minenr = cfloat(rvar(string,istrt,'MINENR'))
c
c INTPOLAT
c
         elseif (string(istrt:istrt+7).eq.'intpolat') then
            mloptinp%intpolat = icint(rvar(string,istrt,'INTPOLAT'))
c
c end by Yan Zhang 12/12/2006
c
c FROZEATM
c read the frozen atomic ID in the minized optimization calling LBFGS
c added by Yan Zhang 02/14/2008
c 
         elseif (string(istrt:istrt+9).eq.'frozeatm') then
            call ridlist(mloptinp%frozeatmid, 
     &            mloptinp%frozenatm, iend)
c
c end by Yan Zhang 12/14/2007
c
 
c
c  07/01/2011 by Soroosh Pezeshki
c
c
c comments
c
         elseif (string(istrt:istrt) .eq. ' ') then
            string=string
c
c end 07/01/2011 by Soroosh Pezeshki
c

c  Invalid MLOPT option
c	    	       	       	    	       	    	       	    	    	 	    
         else
            write (outfile, 11) string
c
  11        format ( 'ERROR: Invalid MLOPT option:', a80)
            stop 'rmlopt 5'
         endif
c
c read next line
c 
         call rline(infile,string,istrt,isect,iscend,iend)
      enddo
c
c  If constant keyword not set and using a linear molecule then 
c    change 1 value in constant
c
      if ((mloptinp%iop.eq.linear .or. mloptinp%iop.eq.lints) 
     *       .and. constset.eq.0) then
         mloptinp%constant(9) = 0
      endif
c
c  The PARTIAL keyword is only used with the GAUEXT keyword.
c  11/6/2006 by Yan Zhang
c
c   modified 2/10/2007 by Christoph Riplinger
c
c      if((mloptinp%algrthm.ne.4).and.(mloptinp%ipartcal.eq.1)) then
      if((mloptinp%algrthm.ne.4).and.(mloptinp%algrthm.ne.6)
     *       .and.(mloptinp%part%ipartcal.eq.1)) then
        write (outfile, 1071)
1071    format ('Error: The PARTIAL keyword is only',
     *          ' used with the GAUEXT and the ORCAEXT keywords.')
        stop 'mlopt 6'
      end if
c
c   end 2/10/2007 by Christoph 
c
c   end 11/6/2006 by Yan Zhang
c
      return
      end
c
c*******************************************************************************
c  RCONST
c*******************************************************************************
c
      subroutine rconst(constant, natoms, iend)
c
c     Created:  August 10, 1999 by J.M. Rodgers
c     Revised:
c     Purpose:  Reads the constant coordinates for MLOPT
c
c     Called by:  rmlopt
c     Calls:  rline, fchar, fspace
c
      use files, only : infile, outfile
      implicit none
c
      integer  numcoord, iend, isect, iscend, i, j, natoms, atm
      integer   ilong, ifin, ibeg, ierr, constant(3*natoms), icint
      character*20 name
c
      character*80 string
      i = 1
      isect = 0
      iend = 0
      iscend = 0
c
c  Initialize constant array to 0
c
      do 20 j=1, 3*natoms
         constant(j) = 0
  20  continue
      call rline(infile,string,ibeg,isect,iscend,iend)
      do while (isect.eq.0.and.iscend.eq.0.and.iend.eq.0)
         ierr = 0
         ilong = 0
         ibeg = 1
         call fchar(string, ibeg, ierr)
         ifin = ibeg + 1
         call fspace(string, ifin, ilong)
         if (ilong .eq. 0) then
            ifin = ifin - 1
         endif
         ifin = ifin+1
         atm = icint(string(ibeg:ifin))
         ibeg = ifin
         call fchar(string, ibeg, ierr)
         do while (ierr.eq.0 .and. ilong.eq.0)
            if (i.gt.6 .or. (natoms.eq.2 .and. i.gt.5))  goto 100
            ifin = ibeg + 1
            call fspace(string, ifin, ilong)
            if (ilong .eq. 0) then
               ifin = ifin - 1
            endif
            if (string(ibeg:ibeg).eq.'x') then
               constant(3*(atm-1)+1) = 1
            elseif (string(ibeg:ibeg).eq.'y') then
               constant(3*(atm-1)+2) = 1
            elseif (string(ibeg:ibeg).eq.'z') then
               constant(3*(atm-1)+3) = 1
            else
               write(outfile,*) 'Invalid Coordinate in CONSTANT'
               stop 'rconst 1'
            endif
            i = i+1
            ibeg = ifin + 1
            call fchar(string, ibeg, ierr)
         end do
         call rline(infile, string, ibeg, isect, iscend, iend)
      end do
c
c  Terminate if end of file or new section reached  before the end
c    of the coefficient list.
c    
      if (isect.eq.1 .or. (iend.eq.1 .and. iscend.eq.0)) then
         write (outfile, 1100)
1100     format(/3x,'ERROR: No end to CONSTANT' )
         stop 'rconst 2'
      endif
      return
 100  write (outfile, 1000)
1000  format(/3x,'ERROR:  Too many coordinates in CONSTANT')
      stop 'rconst 3'
  
      return
      end
c
c
c*******************************************************************************
c  RLIST
c*******************************************************************************
c
      subroutine rlist(list, sctname, iend) 
c 
c     Created:  April 15, 1999 by P. L. Fast 
c     Revised:  June 17, 1999 by jmr 
c               April 28, 2004 by Hai Lin
c
c     Purpose:  reads a line list following a list keyword
c               now maxoptl lines!
c 
c     Description:  Using the index i, loop through each line after the
c     input file line w/ section name.  Reads in a line and finds the
c     first character with fchar and then checks the line with chkln.
c     Saves the line to list if appropriate.
c
c     Called by:  rmlgen, rextopt 
c     Calls:  fchar, chkln
c
      use files, only : outfile, infile
      use input, only : maxoptl
      implicit none
c
c i/o variables
c
      character*80  list(maxoptl)
      integer       iend
      character*(*)  sctname
c
c local variables
c            
      integer        i, j, istrt, isect, iblnk, iscend, icommt
c
      character*80   string
c
      i = 0
      isect = 0
      iend = 0
      iscend = 0
c
c     Reads and checks the next non-blank, non-comment line.
c
  20  i = i + 1
      iblnk = 1
      icommt = 1
      do while ((iblnk .eq. 1) .or. (icommt .eq. 1))
         istrt=1
         read(infile,800,end=9999) string
c
 800     format(a80)
         call fchar(string, istrt, iblnk)
         call chkln(string, istrt, isect, icommt, iscend)
      end do
c
c     Exits if a new section is reached.  Ends if an 'END' is found.
c     Exits if the list is longer than maxoptl lines and no 'END' is found.
c     Otherwise saves the line to list
c
      if (isect .eq. 1) then
         write (outfile, 1000) sctname
1000     format(/3x, 'ERROR:  No termination of ', a20, ' section.')
         stop 'rlist 1'
      elseif (iscend .eq. 1) then
         goto 40
      elseif (i .gt. maxoptl) then
         write (outfile, 1100) sctname, maxoptl
1100     format (/3x, 'ERROR: ', /a20, ' section longer than ',
     *      i5, ' lines.')
         stop 'rlist 2'
      else
         list(i) = string
         goto 20
      endif
   40 return
9999  write (outfile, 1200) sctname
1200  format(/3x, 'ERROR:  No termination of ', a,' before EOF.')
      stop 'rlist 3'
      end
c
c
c*******************************************************************************
c  RWORD 
c*******************************************************************************
c
      subroutine rword(string,istrt,ierr)
c
c     Created:  April 15, 1999 by P. L. Fast
c               Taken from Polyrate
c     Revised:  June 18, 1999 by JMR
c     Purpose:  read the next word on the line after the word that istrt
c                   is in.
c
c     Called by:  rgeom, rvar
c     Calls:  fspace, fchar
c
c
      implicit none
c
      integer istrt, ierr
c
      character*80  string
c
c clear flags
c
      ierr = 0
c
c search for the first blank - signaling the end of the current word
c
      call fspace(string, istrt, ierr)
      if (ierr .eq. 1) then
         return
      endif
c
c find first letter of next word
c
      call fchar(string, istrt, ierr)
      return
      end
c
c
c*******************************************************************************
c  FSPACE
c*******************************************************************************
c
      subroutine fspace(string, istrt, ierr)
c
c     Created:  June 18, 1999 by J. M. Rodgers
c     Revised:
c     Purpose:  Find the next space on the line
c
c     Description:  Scrolls through the positions in string starting
c        at position istrt.  Sets istrt to the position of the first
c        space.  Or if there is no spacebar left on the line, sets 
c        ierr to 1.
c
c     Called by:  rword, cfloat, icint, rvar, rcoef
c     Calls:  
c
      implicit none
c
      integer istrt, ierr, blnk, length
      character*(*) string
      ierr=0
      blnk = 0
      length = len(string)
      do while (istrt .le. length .and. blnk .eq. 0)
         if (string(istrt:istrt) .eq. ' ') then
            blnk = 1
         elseif (istrt .eq. length) then
            ierr = 1
         endif
         istrt = istrt + 1
      enddo
c
c     Sets istrt back 1 in order to counter act increment at end
c       of do while loop.
c
      istrt = istrt - 1
      return
      end
c  
c*******************************************************************************
c  FCHAR
c*******************************************************************************
c  
      subroutine fchar(string, istrt, ierr)
c               
c     Created:  June 18, 1999 by J. M. Rodgers
c     Revised:
c     Purpose:  Find the next character on the line
c
c     Description:  Scrolls through the positions in string starting
c         at position istrt.  Sets istrt to position of first character.
c         If there is no character left on the line, sets ierr to 1.
c
c     Called by:  rline, rlist, rword, cfloat, icint, rcoef
c     Calls:
c
      implicit none
c
      integer istrt, ierr, char, length
      character*(*) string
      ierr = 0
      char = 0
      length = len(string)
      do while (istrt .le. length .and. char .eq. 0)
         if (string(istrt:istrt) .ne. ' ') then
            char = 1
         elseif (istrt .eq. length) then
            ierr = 1
         endif
         istrt = istrt + 1
      enddo
c
c     Sets istrt back 1 in order to counteract increment at end
c       of do-while loop.
c
      istrt = istrt -1
      return
      end
c
c*******************************************************************************
c  CHKLN
c*******************************************************************************
c  
      subroutine chkln(string, istrt, isect, icommt, iscend)
c     
c     Created:  June 18, 1999 by J. M. Rodgers
c     Revised:
c     Purpose:  Check line to see if it's a special type.
c
c     Description:  Examines character at istrt to see if the line 
c       is a comment or a section header.  Examine 1st 4 characters
c       starting at istrt to see if it's a section end.
c
c     Called by:  rline, rlist
c     Calls:
c
      implicit none
c
      integer istrt, isect, icommt, iscend
c
      character*80 string, case, wrd
      isect = 0
      icommt = 0
      iscend = 0
      wrd = string
      wrd = case(wrd)
      if (wrd(istrt:istrt) .eq. '*') then
         isect=1
      elseif (wrd(istrt:istrt) .eq. '#') then
         icommt=1
      elseif (wrd(istrt:istrt+3) .eq. 'end ') then
         iscend = 1
      endif
      return
      end
c     
c
c*******************************************************************************
c  RGEOM
c*******************************************************************************
c
      subroutine rgeom(geom,geomunit,numatom,string,istrt,iend)
c
c     Created:  April 20, 1999 by P. L. Fast
c     Revised:  July 01, 2011 by Soroosh Pezeshki
c
c     Purpose:  Read the atoms and geometry from the input file.
c
c     Called by:  rmlgen
c     Calls:  rline, rword, cfloat
c
      use input, only : cartgeom
      use atminfo
      use files, only : infile, outfile
      implicit none
c
      integer i, istrt, isect, iend, iatom, ierr, iscend
      integer ifin, ibeg, ifind, iasym, numatom, geomunit, chindex
      type (cartgeom) :: geom
      double precision cfloat
      double precision angtoau
c
      character*80  string
c
c number of angstroms in a bohr (au)
c
c      angtoau = 0.52918d0
      angtoau = 0.529177249d0
c
c read each line in the GEOM section until an 'end' is found.  for each
c line read the atomic symbol and cartesian coordinates.
c
      iatom = 0
      call rline(infile,string,istrt,isect,iscend,iend)
c
      do while (iscend .ne. 1)
c
c  get the atomic symbol, determine the atomic number and therefore the
c  atomic mass from that.  Store the symbol (with the first letter back in
c  uppercase) and mass in atm(i) and atmmass(i) within the structure geom
c
         iatom = iatom + 1
         ibeg = istrt
         call rword(string,istrt,ierr)
         ifin = istrt - 1
         if (ierr.ne.1) then
            ifind = 0
            iasym = 1
            do while(ifind.eq.0.and.iasym.le.103)
               if (string(ibeg:ibeg+1).eq.asymb(iasym)) then
                  chindex = ichar(string(ibeg:ibeg)) - 32
                  string(ibeg:ibeg) = char(chindex)
                  geom%atm(iatom) = string(ibeg:ibeg+1)
                  geom%atmmss(iatom) = ams(iasym)
                  ifind = 1
               endif
c
               iasym = iasym + 1
c
            end do
c
            if (ifind.eq.0) then
               write (outfile,1000) string(istrt:istrt+1)
 1000          format (/3x,'ERROR: illegal atomic symbol: ',a2)
               stop 'rgeom 1'
            endif
c
c get coordinates off rest of line
c
            do 100 i = -2, 0
               ibeg = istrt
               call rword(string,istrt,ierr)
               ifin = istrt - 1
c
c check that the coordinate was found on the line
c
               if (ierr.eq.1 .and. i.ne.0) then
                  write (outfile,1100) string
c
 1100             format(/3x,'ERROR:  invalid Cartesian coordinate ',
     *                   ' in GEOM.  Invalid line is: ',/a80)
                  stop 'rgeom 2'
               endif
c
c save coordinate:
c    i = 1  x-coordinate, *geom(1, iatom)
c    i = 2  y-coordinate, *geom(2, iatom)
c    i = 3  z-coordinate, *geom(3, iatom)
c
               if (geomunit .eq. 1) then
		  geom%angcoord(3*iatom+i) = cfloat(string(ibeg:ifin))
                  geom%aucoord(3*iatom+i) = 
     *                  geom%angcoord(3*iatom+i)/angtoau
               else
                  geom%aucoord(3*iatom+i) = cfloat(string(ibeg:ifin))
                  geom%angcoord(3*iatom+i) = 
     *                  geom%aucoord(3*iatom+i)*angtoau
               endif
c
 100        continue
c
 
c
c  07/01/2011 by Soroosh Pezeshki
c
c
c comments
c
         elseif (string(istrt:istrt) .eq. ' ') then
            string=string
c
c end 07/01/2011 by Soroosh Pezeshki
c

         else
            write (outfile,1200) string
c
 1200       format(/3x,'ERROR: invalid line in GEOM: ',/a80)
            stop 'rgeom 3'
         endif
c
         call rline(infile,string,istrt,isect,iscend,iend)
c
      end do
c
c  return the final iatom value.
c
      numatom = iatom
      return
      end
c
c
c*******************************************************************************
c  RMMGEOM
c*******************************************************************************
c
      subroutine rmmgeom(mmgeom,geom,geomunit,numatom,string,istrt,iend)
c
c     Created:  Feb 22, 2004 by Hai Lin
c     Revised:  Aug. 25, 2011 by Soroosh Pezeshki
c               Sept. 21, 2017 by Xin-Ping Wu
c     Purpose:  Read the MM atomic information from the .crd file.
c
c               The cartesian coordinates in .crd file will be read in
c               and saved to (geom). 
c
c               The GEOM section in fu5 is not needed in such a case. 
c 
c               The connectivities will be read in and saved to (mmgeom). 
c
c
c     Called by:  rmlgen
c     Calls:  rline, rword, cfloat, icint
c
      use input, only : cartgeom, mmvalen, maxvalen
      use atminfo
      use files, only : infile, outfile, t41crdf, t41crd
      implicit none
c
c  i/o variables
c
      integer istrt, iend
      integer numatom, geomunit
      type (cartgeom) :: geom
      type (mmvalen) :: mmgeom
c
c
      character*80  string
c
c  local variables
c			      
      integer i, isect, iatom, ierr, iscend
      integer j, iiatom, ifields, imaxfields, itemp(maxvalen)
      integer ifin, ibeg, ifind, iasym, chindex
      integer nwords, length, icint
      integer ieof, isec
      
      double precision cfloat
      double precision angtoau
c
      character*80  words(40)      
c
c
c number of angstroms in a bohr (au)
c
c      angtoau = 0.52918d0
      angtoau = 0.529177249d0
c
c modified by Xin-Ping Wu, Sept. 21, 2017
c
c mm information required at least 7 fields
c the maximum valency is 8 (for complex systems) 
       ifields = 7
       imaxfields = 15
c
c mm information required at least 7 fields
c    the maximum valency is 6
c      
c      ifields = 7
c      imaxfields = 13
c
c end by Xin-Ping Wu, Sept. 21, 2017
c      
c open the t41.crd file
c
      open (unit=t41crdf, file=t41crd, status='old',
     *      form='formatted', err=5000)
c      
c read t41.crd for the number of atoms
c
      call readln(t41crdf,words,nwords,isec,ieof,iscend) 
c      
      if (iscend .eq. 1 .or. ieof .eq. 1) goto 4000
      iiatom = icint(words(1))
c
c add Aug. 25, 2011 by Soroosh Pezeshki
c check if the # atoms in ml.inp = # atoms in crd file
c
      if (geom%natoms .ne. iiatom) then
         write(*,1301)
1301     format(/3x,'Error: Number of atoms in .crd and input file',
     *              ' do not match')
         goto 6000
      endif

c
c end add Aug. 25, 2011 by Soroosh Pezeshki
c

c      
c read each line in t41.crd:
c  index, atom symbol, atom type name, x, y, z, atom type, connectivities 
c
      iatom = 0
      do while (iscend .ne. 1 .and. ieof .ne. 1)  
         call readln(t41crdf,words,nwords,isec,ieof,iscend)
         if (iscend .ne. 1) then 
	    if(nwords .lt. ifields) then
	       write(outfile,1100) 
1100           format(/3x,'Error: insufficient data in .crd file')
	       goto 6000	       
	    endif   
            if(nwords .gt. imaxfields) then
               write(outfile,1200)
c
c modified by Xin-Ping Wu, Sept. 21, 2017
c
1200           format(/3x,'Error: the allowed maximum valency is 8')
c1200           format(/3x,'Error: the allowed maximum valency is 6')
c
c end by Xin-Ping Wu, Sept. 21, 2017
c
               goto 6000
            endif
c
c read mm atom id
c	    
            iatom = iatom + 1 
            mmgeom%atmid(iatom) = icint(words(1))
            mmgeom%atmtyp(iatom) = icint(words(7))
            mmgeom%atmtypname(iatom) = words(3)(1:4)
	    if(iatom .ne. mmgeom%atmid(iatom)) then
	       write(outfile,1210) iatom
	       goto 6000
	    endif
1210  format(/2x,'Error: Atom ID',i4,/2x,
     *   'Atom ID is not given correctly.',/2x,
     *   'It should start from 1 and increases sequentially.')
c
c read and match the atom symbol
c		  
            ifind = 0
            iasym = 1
            do while(ifind.eq.0.and.iasym.le.103)
               if (words(2).eq.asymbu(iasym)) then
                  geom%atm(iatom) = words(2)  
                  geom%atmmss(iatom) = ams(iasym)
                  ifind = 1  
               endif
c
               iasym = iasym + 1  
c
            end do
c
            if (ifind.eq.0) then
               write (outfile,1000) words(2)
 1000          format (/3x,'ERROR: illegal atomic symbol: ',a2)
               goto 6000
            endif   
c
c read the cartesian coordinates:    i = 1,2,3 = x,y,z
c
            do i = -2, 0
               if (geomunit .eq. 1) then
                  geom%angcoord(3*iatom+i) = cfloat(words(6+i))
                  geom%aucoord(3*iatom+i) = 
     *                  geom%angcoord(3*iatom+i)/angtoau
               else
                  geom%aucoord(3*iatom+i) = cfloat(words(6+i))
                  geom%angcoord(3*iatom+i) = 
     *                  geom%aucoord(3*iatom+i)*angtoau
               endif
            enddo
c
c read the valency and connectivities
c
            j = nwords - ifields
            mmgeom%atmvalen(iatom) = j
            do i = 1, j
               mmgeom%atmvalenlist(iatom,i) = icint(words(ifields+i))
            enddo
c	    
         endif
      enddo
c
c  return the final iatom value.
c
      if (iiatom .ne. iatom) then
         write(*,1300)
1300     format(/3x,'Error: pleass check atom number in .crd file')
         goto 6000
      endif
      numatom = iatom
      geom%natoms = numatom
      mmgeom%natoms = numatom
      close (t41crdf)
      return			     
c
4000  write (*,'(/a)') 'ERROR: The .crd file is empty.'
      goto 6000
c
5000  write (*,'(/a)') 'ERROR: Cannot open the .crd file.'
6000  close (t41crdf)
      close (infile)
      close (outfile)
      stop 'rmmgeom 1'
c              
      end
c
c
c*******************************************************************************
c  CFLOAT
c*******************************************************************************
c
      function cfloat(string)
c
c     Created:  April 20, 1999 by P. L. Fast
c     Revised:  April 18, 2011 by S. Pezeshki
c     Purpose:  Convert a string to a double precision number
c
c     Called by:  rmlgen,rmlopt,rgeom,rcoef
c     Calls:  fchar, fspace
c
      use files, only : outfile
      implicit none
c
      integer length, ibeg, iblnk, ifin, ierr, i, j
      integer idec, iue, ile, iud, ild, isum, iexp, n
      integer iuee,ilee,iudd,ildd                                       0418SP11
      double precision  cfloat, f1, f2, f3, sign, esign
      character*(*) string
c
      character*80 number
      character ch
      logical lexp, ldec
c
      lexp = .false.
      ldec = .false.
      idec = 0
      iue = 0
      ile = 0
      iud = 0
      ild = 0
      isum = 0
      iexp = 0
      length = len(string)
      if (length .eq. 0) then
         cfloat = 0.0d0
         return
      endif
c
c     find the first nonblank character
c
      ibeg = 1
      call fchar(string, ibeg, iblnk)
c
c     if it is a blank string set function to zero
c
      if (iblnk .eq. 1) then
         cfloat = 0.0d0
         return
      endif
c
c     find the first blank character after the number
c
      ifin = ibeg+1
      call fspace(string, ifin, ierr)
      if (ierr .eq. 1) then
         ifin = length
      else 
         ifin = ifin - 1
      endif
c
c     strip the blanks before and after the number
c
      number = string(ibeg:ifin)
      length = ifin - ibeg + 1
c
c     find the decimal point
c
      idec = index(number,'.')
      if (idec .ne. 0) ldec = .true.
c
c     finds the exponential symbol and ensures that there
c     is only one such marker (d or e) in the whole number
c
      iue = index(number,'e')
      ile = index(number(iue+1:),'e')
      iud = index(number,'d')
      ild = index(number(iud+1:),'d')
c
c add Apr. 18, 2011 by Soroosh Pezeshki
c
      iuee = index(number,'E')
      ilee = index(number(iuee+1:),'E')
      iudd = index(number,'D')
      ildd = index(number(iudd+1:),'D')
      isum = iue + ile + iud + ild + iuee + ilee + iudd + ildd
      iexp = max0(iue,ile,iud,ild,iuee,ilee,iudd,ildd)
c
c end add Apr. 18, 2011 by Soroosh Pezeshki
c
!       isum = iue + ile + iud + ild 
!       iexp = max0(iue,ile,iud,ild)
      if (isum .gt. iexp) then
         write(outfile,1000) string
         flush (outfile)                                                0713SP11
         stop 'cfloat 2'
      endif
      if (iexp .ne. 0) then
         lexp = .true.
      else
         iexp = length + 1
      endif
c
      if (.not. ldec) idec = iexp
c
c     get the number before decimal
c
      ibeg = 2
      if (number(1:1) .eq. '+') then
         sign = 1.0d0
      elseif(number(1:1) .eq. '-') then
         sign = -1.0d0
      else
         sign = 1.0d0
         ibeg = 1
      endif
      if (ibeg .eq. iexp) then
         f1 = 1.0d0
      else
         f1 = 0.0d0
      endif
      do 50 i = ibeg,idec-1
         ch = number(i:i)
         if (ch .ge. '0' .and. ch .le. '9') then
            n = ichar(ch) - ichar('0')
            f1 = f1 * 10.0d0 + dble(n)
         else
            write(outfile,1001) string
            flush (outfile)                                             0713SP11
            stop 'cfloat 3'
         endif
50    continue
c
c     get the number after decimal
c
      f2 = 0.0d0
      if (ldec) then
         j = 0
         do 60 i = idec+1,iexp-1
            ch = number(i:i)
            if (ch .ge. '0' .and. ch .le. '9') then
               n = ichar(ch) - ichar('0')
               f2 = f2 * 10.0d0 + dble(n)
               j = j + 1
            else
               write(outfile,1002) string
               flush (outfile)                                          0713SP11
               stop 'cfloat 4'
            endif
60       continue
         f2 = f2 / 10.0d0 ** dble(j)
      endif
c
c    get the exponent
c
      esign = 1.0d0
      f3 = 0.0d0
      if (lexp) then
         ibeg = iexp + 2
         if (number(iexp+1:iexp+1) .eq. '+') then
            esign = 1.0d0
         elseif(number(iexp+1:iexp+1) .eq. '-') then
            esign = -1.0d0
         else
            esign = 1.0d0
            ibeg = iexp + 1
         endif
         do 70 i = ibeg,length
            ch = number(i:i)
            if (ch .ge. '0' .and. ch .le. '9') then
               n = ichar(ch) - ichar('0')
               f3 = f3 * 10.0d0 + dble(n)
            else
               write(outfile,1003) string
               flush (outfile)                                          0713SP11
               stop 'cfloat 5'
            endif
70       continue
      endif
c
      cfloat = (sign * (f1 + f2)) * 10.0d0 ** (esign*f3)
c
      return
c
1000  format(/1x,'illegal number-1: ',a80)
1001  format(/1x,'illegal number-2: ',a80) 
1002  format(/1x,'illegal number-3: ',a80) 
1003  format(/1x,'illegal number-4: ',a80) 
c
      end
c
c
c*******************************************************************************
c  ICINT
c*******************************************************************************
c
      function icint(svalue)
c
c     Created:  April 20, 1999 by P. L. Fast
c     Revised:
c     Purpose:  Convert a string into an integer
c
c     Called by:  rmlgen,rmlopt,
c     Calls:  fchar, fspace
c
      use files, only : outfile
      implicit none
c
      integer icint, ibeg, ifin, iblnk, ierr, length, isign
      integer istart, i, n
      character*(*) svalue
      character ch
      length = len(svalue)
      if (length .eq. 0) then
         icint = 0
         return
      endif
c
c     find the first nonblank character
c
      ibeg = 1
      call fchar(svalue, ibeg, iblnk)
c
c     if it is a blank string set function to zero
c    
      if (iblnk .eq. 1) then
         icint = 0
         return
      endif
c
c     find the first blank character after the number
c
      ifin = ibeg+1
      call fspace(svalue, ifin, ierr)
      if (ierr .eq. 1) then
         ifin = length
      else
         ifin = ifin - 1
      endif
c
c     strip the blanks before and after the number
c
      svalue = svalue(ibeg:ifin)
      length = ifin - ibeg + 1
c
c
c     check for negative or positive sign (- or +)
c
      icint = 0
      istart = 2
      isign = +1
      if (svalue(1:1).eq.'+') then
         isign = +1
         ibeg = ibeg + 1
      elseif (svalue(1:1).eq.'-') then
         isign = -1
         ibeg = ibeg + 1
      else
         istart = 1
      endif
c
c     now convert each character to an integer - and store in icint
c
      do 70 i = ibeg,length
         ch = svalue(i:i)
         if (ch .ge. '0' .and. ch .le. '9') then
            n = ichar(ch) - ichar('0')
            icint = icint * 10 + n
         else
            write(outfile,1000) svalue
            flush (outfile)                                             0713SP11
            stop 'icint 1'
         endif
70    continue
      icint = icint * isign
c
      return
c
1000  format(/3x,'ERROR: illegal digit in an integer: ',A80)
      end
c
c*******************************************************************************
c  RVAR
c*******************************************************************************
c
      function rvar(string, istrt, varname)
c
c     Created:  June 21, 1999 by J.M. Rodgers
c     Revised:
c     Purpose:  Read a variable following a word and assign to var
c
c     Called by:  rmlgen,rextopt,rmlopt,
c     Calls:  fspace, rword
c
      use files, only : outfile
      implicit none
c
      integer istrt, ifin, length, ierr
c
      character*80 string
      character*20 rvar
      character*(*) varname
      call rword(string,istrt,ierr)
      if (ierr .eq. 1) then
         write (outfile, 800) varname
 800     format(/3x, 'ERROR: ', a15, ' must have an argument.')
         stop 'rvar 1'
      endif
      ifin = istrt+1
      call fspace(string, ifin, ierr)
      if (ierr .eq. 1) then
         length = ifin - istrt + 1
      else
         length = ifin - istrt
      endif
      if ( length .gt. 20 ) then
         write (outfile, 900) varname, string(istrt:ifin)
c
 900     format(/3x, 'ERROR: ', a15, ' argument too long: ', /a80)
         stop 'rvar 2'
      endif
      rvar = string(istrt:ifin)
      end
c
c
c*******************************************************************************
c  RCOEF
c*******************************************************************************
c
      subroutine rcoef(coefvar, numcoef, name, iend)
c           
c     Created:  June 21, 1999 by J. M. Rodgers
c     Revised:
c     Purpose:  Read a list of numbers and assign to coefvar
c        
c     Called by:  rmcsac,rmmcg2,,rmmcg3,
c        rmcg3,rsac
c     Calls:  rline, fchar, fspace
c           
      use files, only : infile, outfile
      implicit none
c
      integer  numcoef, iend, isect, iscend, i, j
      integer   ilong, ifin, ibeg, ierr
      double precision coefvar(numcoef), cfloat
      character*20 name
c
      character*80 string
      i = 1
      isect = 0
      iend = 0
      iscend = 0
c
c  Initialize coefficient array to 0
c
      do 20 j=1, numcoef
         coefvar(j) = 0.0d0
  20  continue
      call rline(infile,string,ibeg,isect,iscend,iend)
      do while (isect.eq.0.and.iscend.eq.0.and.iend.eq.0)
         ierr = 0
         ilong = 0
         ibeg = 1
         call fchar(string, ibeg, ierr)
         do while (ierr.eq.0 .and. ilong.eq.0)
            if (i .gt. numcoef)  goto 100
            ifin = ibeg + 1
            call fspace(string, ifin, ilong)
            if (ilong .eq. 0) then
               ifin = ifin - 1
            endif
            coefvar(i) = cfloat(string(ibeg:ifin))
            i = i+1
            ibeg = ifin + 1
            call fchar(string, ibeg, ierr)
         end do
         call rline(infile, string, ibeg, isect, iscend, iend)
      end do
c
c  Terminate if end of file or new section reached  before the end
c    of the coefficient list.
c    
      if (isect.eq.1 .or. (iend.eq.1 .and. iscend.eq.0)) then
         write (outfile, 1100) name
1100     format(/3x,'ERROR: No end to coefficient list in', a )
         stop 'rcoef 2'
      endif
      return
 100  write (outfile, 1000) name
1000  format(/3x,'ERROR:  Too many coefficients in ', a)
      stop 'rcoef 1'
  
      return
      end

