#!/bin/csh
#
# Usage test.ml [working_directory]
#
# This can be used as a template for writing scripts for QMMM runs
#
#############################################
#
# You need to change the name here
#
   set name = test2001 
#
# You also need to change the name later 
#
#############################################
#
if ($#argv != 0) then
   set actdir = `pwd`
   set wrkdir = $argv[1]
else
   set actdir = `pwd`
   set wrkdir = $actdir/$name
check:
   if (-e $wrkdir) then
      set tmp = $wrkdir/$name
      set wrkdir = $tmp
      goto check
   endif
   mkdir $wrkdir
endif
#
   cp $name.dat $wrkdir
########################################
#
   /bin/cp  $name.prm $wrkdir/t41.prm
   /bin/cp  $name.crd $wrkdir/t41.crd
   
#######################################
#
# copy .chk file to work directory
#
   if (-e guess.chk) then 
     cp guess.chk $wrkdir/Test.chk
   endif
#
   cd $wrkdir
   mkdir par
#
   set multidir = `cat ~/.qmmm_path2018`
   set scriptdir = $multidir/script
   set basisdir = $multidir/basis
   set exedir = $multidir/exe
   set exe = $exedir/qmmm.exe
#
#  Copy over the shuttles for the electronic structure program
#    to be use
#
   cp $scriptdir/g03shuttle $wrkdir/g03shuttle
   cp $scriptdir/t41shuttle $wrkdir/t41shuttle
#
# add scripts to use gaussian optimzer
#   
   cp $scriptdir/Gau_External $wrkdir/Gau_External
   cp $scriptdir/ex_shuttle $wrkdir/ex_shuttle         
    if (-e $scriptdir/Gau_External2) then
      cp $scriptdir/Gau_External2 $wrkdir/Gau_External2 
    endif
#
#  Copy over the basis sets
#
   cp $basisdir/*.gbs $wrkdir
   cp $basisdir/*.gbs $wrkdir/par
#
#######################################
#
# You need to change the name here again
#
   foreach i (test2001)
      cp ${i}.dat ml.inp
      (time $exe) >& ${i}.jobs
      echo " " >> ${i}.jobs
      mv ml.out ${i}.out  >>& /dev/null
      mv ml.sum ${i}.sum  >>& /dev/null
      rm extopt.inp >>& /dev/null
      mv extopt.out ${i}.extopt >>& /dev/null
      mv g03.out ${i}.g03out >>& /dev/null
      mv g03.inp.1 ${i}.g03inp >>& /dev/null
      mv Test.FChk ${i}.fchk >>& /dev/null
      rm g03.inp.* g03.out.* Test.FChk.* >>& /dev/null
      rm ml.inp >>& /dev/null
   end
#
   rm $wrkdir/g03shuttle  >>& /dev/null
   rm $wrkdir/*.gbs  >>& /dev/null
   rm $wrkdir/Test.chk >>& /dev/null
   rm $wrkdir/mlresult/Test.chk >>& /dev/null
   if (! -e $actdir/Gau_ext.acc) then
     rm $wrkdir/tmp.chk >>& /dev/null
   endif
#   rm $wrkdir/*.g03out *.jobs *.fchk  >>& /dev/null
   rm -Rf par
#   mv $wrkdir/*.* $actdir
   cd $actdir
   if (-e $actdir/guess.chk.bak) then
     mv $actdir/guess.chk.bak $actdir/guess.chk >>& /dev/null
   endif
#   rm -rf $wrkdir
#
#  End of script
#
############################################################ 
