#!/bin/csh
#
# Usage test.ml [working_directory]
#
# This can be used as a template for writing scripts for QMMM runs
#
#############################################
#
# You need to change the name here
#
   set name = test4014
#
# You also need to change the name later 
#
#############################################
#
if ($#argv != 0) then
   set actdir = `pwd`
   set wrkdir = $argv[1]
else
   set actdir = `pwd`
   set wrkdir = $actdir/$name
check:
   if (-e $wrkdir) then
      set tmp = $wrkdir/$name
      set wrkdir = $tmp
      goto check
   endif
   mkdir $wrkdir
endif
#
   cp $name.dat $wrkdir
########################################
#
   /bin/cp  $name.prm $wrkdir/t41.prm
   /bin/cp  $name.crd $wrkdir/t41.crd
   
#######################################
   cd $wrkdir
#
   set multidir = `cat ~/.qmmm_path2018`
   set scriptdir = $multidir/script
   set basisdir = $multidir/basis
   set exedir = $multidir/exe
   set exe = $exedir/qmmm.exe
#
#  Copy over the shuttles for the electronic structure program
#    to be use
#
   cp $scriptdir/gmsshuttle $wrkdir/gmsshuttle
   cp $scriptdir/t41shuttle $wrkdir/t41shuttle
#
#######################################
#
# You need to change the name here again
#
   foreach i (test4014)
      cp ${i}.dat ml.inp
      (time $exe) >& ${i}.jobs
      echo " " >> ${i}.jobs
      mv ml.out ${i}.out  >>& /dev/null
      mv ml.sum ${i}.sum  >>& /dev/null
      rm extopt.inp >>& /dev/null
      mv extopt.out ${i}.extopt >>& /dev/null
      cp gms.out ${i}.gmsout >>& /dev/null
      mv gms.inp.1 ${i}.gmsinp >>& /dev/null
      rm  temp1 >>& /dev/null
      rm ml.inp >>& /dev/null
   end

   rm $wrkdir/gmsshuttle  >>& /dev/null
   rm $wrkdir/*.gmsinp *.gmsout *.jobs  >>& /dev/null
#   mv $wrkdir/*.* $actdir
   cd $actdir
#   rm -rf $wrkdir
#
#  End of script
#
############################################################ 
