c
c     ####################################################################
c     ##                                                                ##
c     ##  dampchg.i  --  parameters used for screening (damping) scheme ##
c     ##                                                                ##
c     ####################################################################
c
c   use_dampchg:     tag to determine if screened charge scheme is used.0: no screening
c                    1: MMODS used for MM  2: ODS used for QMMM 
c   use_dampatm:     tag to determine if the atom charge is screened
c   scnzeta:  generalized zeta parameters for each element in MM calculation
c   scnval:  generalized valence electrons for each element in MM calculation
c   scnzeta0:  generalized zeta parameters for each element in QMMM calculation
c   scnval0:  generalized valence electrons for each element in QMMM calculation
c   zeta,nval,nchg:  zeta value, number of valence electrons,extra charge for the atom
c   use_damprc: whether the redistributed charge (rc) near the boundary should be smeared 
c                     0: no screening  1: used smeared charge  2: use one Guassian
c   slambda:  width (in unit of Angstrom) of the smeared charge used for redistributed charge
c   ngto1,ngto2: number of GTO expanded to fit STO for real atoms and dummy atom charges

      real*8 scnzeta,scnval, scnzeta0, scnval0                                      
      real*8 zeta,nval,nchg
      real*8 slambda
      integer ngto1,ngto2             
      integer use_damprc
      integer use_dampchg
      logical use_dampatm
                                                                    
      common /dampchg/  scnzeta(36),scnval(36),
     &        scnzeta0(36),scnval0(36),
     &        zeta(maxatm),nval(maxatm),nchg(maxatm),slambda,
     &        ngto1,ngto2,use_damprc,
     &        use_dampchg, use_dampatm(maxatm)
